#include<bits/stdc++.h>
#define MAXN 300007
using namespace std;

const long long mod=1e9+7,inf=1e10;

long long n,k;
long long a[MAXN];
long long fact[MAXN];

long long power(long long a,long long b){
    if(b==0)return 1;
    if(b==1)return a;
    if(b==2)return (a*a)%mod;
    if(b%2==0)return power(power(a,b/2),2);
    return (a*power(power(a,b/2),2))%mod;
}

int maxs[4*MAXN];

int best(int x,int y){
    if(a[x]>a[y])return x;
    return y;
}

void builds(int v,int l,int r){
    if(l==r){
        maxs[v]=l;
    }else{
        int tt=(l+r)/2;
        builds(2*v,l,tt);
        builds(2*v+1,tt+1,r);
        maxs[v]=best(maxs[2*v],maxs[2*v+1]);
    }
}

int getpos(int v,int l,int r,int ll,int rr){
    if(ll>rr)return 0;
    if(l==ll and r==rr){
        return maxs[v];
    }else{
        int tt=(l+r)/2;
        return best( getpos(2*v,l,tt,ll,min(tt,rr)) , getpos(2*v+1,tt+1,r,max(ll,tt+1),rr) );
    }
}

vector<long long> tree[4*MAXN];

void combine(int x,int y,int z){
    for(long long c:tree[y])tree[x].push_back(c);
    for(long long c:tree[z])tree[x].push_back(c);
    sort(tree[x].begin(),tree[x].end());
}

void build(int v,int l,int r){
    if(l==r){
        tree[v]={a[l]};
    }else{
        int tt=(l+r)/2;
        build(2*v,l,tt);
        build(2*v+1,tt+1,r);
        combine(v,2*v,2*v+1);
    }
}

int bin(int v,long long from,long long to){
    int l=-1,r=tree[v].size(),tt,lt,rt;
    while(l+1<r){
        tt=(l+r)/2;
        if(tree[v][tt]<=to){
            l=tt;
        }else{
            r=tt;
        }
    }
    rt=l;
    l=-1; r=tree[v].size();
    while(l+1<r){
        tt=(l+r)/2;
        if(tree[v][tt]>=from){
            r=tt;
        }else{
            l=tt;
        }
    }
    lt=r;
    return max(0,rt-lt+1);
}

int query(int v,int l,int r,int ll,int rr,long long from,long long to){
    if(ll>rr)return 0;
    if(l==ll and r==rr){
        return bin(v,from,to);
    }else{
        int tt=(l+r)/2;
        return query(2*v,l,tt,ll,min(tt,rr),from,to) + query(2*v+1,tt+1,r,max(tt+1,ll),rr,from,to);
    }
}

long long solve(int l,int r,long long mins){
    if(l>=r)return 1;

    int maxpos=getpos(1,1,n,l,r);
    if(a[maxpos]<=mins)return 1;

    int cnt=query(1,1,n,l,r,mins+1,k-a[maxpos]),len=query(1,1,n,l,r,mins+1,inf),br=0;
    if(2*a[maxpos]<=k)cnt--;

    long long del=1;
    vector<int> v={};

    for(int i=l;i<maxpos;i++){
        if(a[i]+a[maxpos]<=k and a[i]>mins){
            v.push_back(a[i]);
        }
    }
    for(int i=maxpos+1;i<=r;i++){
        if(a[i]+a[maxpos]<=k and a[i]>mins){
            v.push_back(a[i]);
        }
    }

    sort(v.begin(),v.end());
    for(int i=0;i<v.size();i++){
        br++;
        if(i==v.size()-1 or v[i]!=v[i+1]){
            del*=fact[br]; del%=mod;
            br=0;
        }
    }

    long long lt=solve(l,maxpos-1,max(k-a[maxpos],mins));
    long long rt=solve(maxpos+1,r,max(k-a[maxpos],mins));

    return (((lt*rt)%mod)*((((fact[len]*power(fact[len-cnt],mod-2))%mod)*power(del,mod-2))%mod))%mod;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    fact[0]=1;
    for(long long i=1;i<=n;i++){
        fact[i]=(fact[i-1]*i)%mod;
    }

    for(int i=1;i<=n;i++){
        cin>>a[i];
    }

    build(1,1,n);
    builds(1,1,n);

    cout<<solve(1,n,-1)<<"\n";

    return 0;
}

/**

7 200
127 70 122 45 127 135 58 1



*/
