#include <bits/stdc++.h>
#define endl "\n"
using namespace std;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; } 
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; } 
typedef long long ll;
const ll mod = 1000000007;

const ll MAX_N = 3e5 + 10;

struct seg_tree {
	int tree[4 * MAX_N];

	void upd(int curr, int l, int r, int ind, int val) {
		if(l == r && l == ind) {
			tree[curr] += val;
			return;
		} else if(l > ind || r < ind) { return; }

		int m = (l + r) / 2ll;
		upd(curr * 2, l, m, ind, val);
		upd(curr * 2 + 1, m + 1, r, ind, val);
		tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
	}

	int sum(int curr, int l, int r, int ql, int qr) {
		if(ql <= l && r <= qr) {
			return tree[curr];
		} else if(ql > r || qr < l) {
			return 0;
		}

		int m = (l + r) / 2ll;
		return sum(curr * 2, l, m, ql, qr) + sum(curr * 2 + 1, m + 1, r, ql, qr);
	}
};

seg_tree st;

ll arr[MAX_N];
ll n, k;
bool ok[MAX_N];

ll fpow(ll x, ll p) {
	if(p == 0) return 1;

	ll ans = fpow(x, p / 2);
	ans = (ans * ans) % mod;

	if(p & 1) {
		return (ans * x) % mod;
	} else {
		return ans;
	}
}

ll perm[MAX_N], inv[MAX_N];
int lft[MAX_N], rght[MAX_N];

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

	perm[0] = inv[0] = 1;
	for(ll i = 1; i < MAX_N; i ++) {
		perm[i] = (perm[i - 1] * ll(i)) % mod;
		inv[i] = fpow(perm[i], mod - 2);
		assert(perm[i] * inv[i] % mod == 1);
	}

	map<int, vector<int> > pos;

	cin >> n >> k;
	for(ll i = 0; i < n; i ++) {
		cin >> arr[i];
		pos[-arr[i]].push_back(i);
	}

	{
		vector<pair<int, int> > st;
		st.push_back({mod, -1});

		for(int i = 0; i < n; i ++) {
			int l = 0, r = st.size();
			while(l < r - 1) {
				int m = (l + r) / 2ll;
				if(st[m].first + arr[i] > k) {
					l = m;
				} else {
					r = m;
				}
			}
			lft[i] = st[l].second;
		
			while(st.back().first <= arr[i]) { st.pop_back(); }
			st.push_back({arr[i], i});	
		}
	}

	{
		vector<pair<int, int> > st;
		st.push_back({mod, n});

		for(int i = n - 1; i >= 0; i --) {
			int l = 0, r = st.size();
			while(l < r - 1) {
				int m = (l + r) / 2ll;
				if(st[m].first + arr[i] > k) {
					l = m;
				} else {
					r = m;
				}
			}
			rght[i] = st[l].second;
		
			while(st.back().first <= arr[i]) { st.pop_back(); }
			st.push_back({arr[i], i});	
		}
	}

	ll ret = 1;

	for(const auto &it : pos) {
		for(int i = 0; i < it.second.size(); i ++) {
			if(i != 0 && lft[it.second[i - 1]] == lft[it.second[i]]) { continue; } 
		
			ll cnt = st.sum(1, 0, MAX_N - 1, lft[it.second[i]] + 1, rght[it.second[i]] - 1) + 1;
			ll cnt_bad = 0;
			int j = i;
			while(j < it.second.size() && lft[it.second[i]] == lft[it.second[j]]) {
				cnt_bad ++;
				st.upd(1, 0, MAX_N - 1, it.second[i], 1);
				j ++;
			}
			ret = ret * perm[cnt + cnt_bad - 1] % mod * inv[cnt - 1] % mod * inv[cnt_bad] % mod;
		}
	}
	
	cout << ret << endl;

	return 0;
}	
