// I taka produlzhavame s nai hitoviq kiuchek ot djodji bend specialno za vsichki romi
// Kiucheka konq vihur 2012
// Novata modifikaciq
// Aide Chochko
// Aide Vihyre
// Vlez
// Vlez Vihyre

#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 300000 + 10;
const int MOD  = 1e9 + 7;
const int INF  = 2e9;

struct Node
{
	int y;
	int value;
	int maxPos;
	int minPos;
	int maxValue;
	int minValue;
	int subtreeSize;
	Node *left, *right;
	Node()
	{
		value = 0;
		maxPos = 1;
		minPos = 1;
		maxValue = 0;
		minValue = INF;
		subtreeSize = 0;
		left = right = nullptr;
	}

	Node(int _value, int _y)
	{
		y = _y;
		maxPos = 1;
		minPos = 1;
		value = _value;
		maxValue = _value;
		minValue = _value;
		subtreeSize = 1;
		left = right = nullptr;
	}
};

int treapCnt = 1;
Node *treap[2*MAXN];
void recover(Node *curr)
{
	if (curr == nullptr) return;
	curr->maxPos = 1;
	curr->minPos = 1;
	curr->maxValue = curr->minValue = curr->value;
	curr->subtreeSize = 1;

	if (curr->left != nullptr)
	{
		curr->maxPos += curr->left->subtreeSize;
		curr->minPos += curr->left->subtreeSize;
		curr->subtreeSize += curr->left->subtreeSize;
		if (curr->maxValue < curr->left->maxValue)
		{
			curr->maxValue = curr->left->maxValue;
			curr->maxPos = curr->left->maxPos;
		}

		if (curr->minValue > curr->left->minValue)
		{
			curr->minValue = curr->left->minValue;
			curr->minPos = curr->left->minPos;
		}
	}

	if (curr->right != nullptr)
	{
		if (curr->maxValue < curr->right->maxValue)
		{
			curr->maxValue = curr->right->maxValue;
			curr->maxPos = curr->right->maxPos + curr->subtreeSize;
		}

		if (curr->minValue > curr->right->minValue)
		{
			curr->minValue = curr->right->minValue ;
			curr->minPos = curr->right->minPos + curr->subtreeSize;
		}
	
		curr->subtreeSize += curr->right->subtreeSize;
	}
}

void split(Node *curr, Node *&left, Node *&right, int k)
{
	// std::cout << "call split: " << k << ' ' << (curr == nullptr) << '\n';
	if (curr == nullptr)
	{
		left = right = nullptr;
		return;
	}

	int size = 1;
	if (curr->left != nullptr) size += curr->left->subtreeSize;
	// std::cout << "size is: " << size << ' ' << (curr->left == nullptr ? 0 : curr->left->subtreeSize) << '\n';
	if (k >= size)
	{
		left = curr;
		split(curr->right, left->right, right, k - size);
		recover(left);
	} else
	{
		right = curr;
		split(curr->left, left, right->left, k);
		recover(right);
	}
}

void merge(Node *&curr, Node *left, Node *right)
{
	if (left == nullptr)
	{
		curr = right;
		return;
	}

	if (right == nullptr)
	{
		curr = left;
		return;
	}

	if (left->y > right->y)
	{
		curr = left;
		merge(curr->right, left->right, right);
	} else
	{
		curr = right;
		merge(curr->left, left, right->left);
	}

	recover(curr);
}

int findMin(Node *curr)
{
	assert(curr != nullptr);
	return curr->minValue;
}

void eraseMin(Node *&curr)
{
	assert(curr != nullptr);
	int pos = curr->minPos;
	Node *left, *min, *ll, *right;
	split(curr, left, right, pos);
	split(left, ll, min, pos - 1);
	merge(curr, ll, right);
}

int findMax(Node *curr)
{
	assert(curr != nullptr);
	return curr->maxValue;
}

void splitMax(Node *&curr)
{
	treapCnt++;
	assert(curr != nullptr);
	int pos = curr->maxPos;
	Node *min, *right;
	split(curr, treap[treapCnt], right, pos);
	split(treap[treapCnt], treap[treapCnt], min, pos - 1);
	curr = right;
}

void pushBack(Node *&curr, int value)
{
	Node *newNode = new Node(value, rand());
	merge(curr, curr, newNode);
}

llong fact[MAXN];
int sorted[MAXN];
int a[MAXN], n, k;
int taken[MAXN];

llong power(llong value, int base)
{
	if (base == 0) return 1;
	if (base & 1) return (value * power(value, base - 1)) % MOD;
	llong res = power(value, base / 2);
	return (res * res) % MOD;
}

inline int var(int n, int k)
{
	return (fact[n] * power(fact[n - k], MOD - 2)) % MOD;
}

inline int comb(int n, int k)
{
	return ((1LL * (fact[n] * power(fact[n - k], MOD - 2)) % MOD) * power(fact[k], MOD - 2)) % MOD;
}

inline bool good(int x, int y)
{
	return x + y <= k;
}

llong ans = 1;
int times = 0;
void divide(Node *curr)
{
	if (curr == nullptr) return;
	if (curr->subtreeSize <= 1) return;

	while (curr != nullptr && curr->subtreeSize >= 2)
	{
		int left = curr->subtreeSize;
		int max = findMax(curr);
		std::unordered_map <int,int> count;
		while (curr != nullptr && curr->subtreeSize >= 2)
		{
			int min = findMin(curr);
			if (!good(min, max)) break;
			count[min]++;
			eraseMin(curr);
		}

		while (curr != nullptr && curr->subtreeSize >= 2 && findMax(curr) == max)
		{
			splitMax(curr);
			divide(treap[treapCnt]);
		}

		treap[++treapCnt] = curr;

		llong add = 1;
		for (auto [key, value] : count)
		{
			add *= comb(left, value);
			left -= value;
			add %= MOD;
		}

		ans *= add;
		ans %= MOD;
	}
}

void solve()
{
	treapCnt = 1;
	fact[0] = 1;
	for (int i = 1 ; i <= n ; ++i)
	{
		fact[i] = (fact[i - 1] * i) % MOD;
	}


	for (int i = 1 ; i <= n ; ++i)
	{
		pushBack(treap[1], a[i]);
	}

	divide(treap[1]);
	std::cout << ans << '\n';
}

void read()
{
	std::cin >> n >> k;
	for (int i = 1 ; i <= n ; ++i)
	{
		std::cin >> a[i];
	}
}

void fastIOI()
{
	std::ios_base :: sync_with_stdio(0);
	std::cout.tie(nullptr);
	std::cin.tie(nullptr);
}

int main()
{
	fastIOI();
	read();
	solve();

	return 0;
}