#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

const int maxn = 3e5 + 10;
const ll mod = 1e9 + 7;

int n;
ll k, a[maxn], f[maxn], pos[maxn], t[maxn];

ll power(ll base, ll st)
{
    ll ans = 1;
    while(st > 0)
    {
        if (st % 2 == 1)
            ans = (ans * base) % mod;
        st /= 2;
        base = (base * base) % mod;
    }
    return ans;
}

map < ll, ll > mp;
ll fac[maxn], rev_fac[maxn];

struct node
{
    ll mx, cnt;

    node(ll _mx = 0, ll _cnt = 0)
    {
        mx = _mx;
        cnt = _cnt;
    }
};

node merge_node(node nd1, node nd2)
{
    node nd;
    nd.mx = max(nd1.mx, nd2.mx);
    nd.cnt = nd1.cnt + nd2.cnt;
    return nd;
}

node tree[4 * maxn];

void update(int root, int left, int right, int idx, ll val)
{
    if (left == right)
    {
        tree[root] = node(val, 1);
        return;
    }

    int mid = (left + right) / 2;
    if (idx <= mid)
        update(root * 2, left, mid, idx, val);
    else
        update(root * 2 + 1, mid + 1, right, idx, val);

    tree[root] = merge_node(tree[root * 2], tree[root * 2 + 1]);
    ///cout << root << " : " << left << " " << right << " " << tree[root].mx << " " << tree[root].cnt << endl;
}

int walk_right(int root, int left, int right, int qleft, int qright, ll val)
{
    ///cout << root << " : " << left << " " << right << " " << tree[root].mx << endl;
    if (left > qright || right < qleft || tree[root].mx <= val)
    return 0;

    if (left == right)
        return left;

    int mid = (left + right) / 2;
    if (left >= qleft && right <= qright)
    {
        if (tree[root * 2 + 1].mx > val)
                    return walk_right(root * 2 + 1, mid + 1, right, qleft, qright, val);
            return walk_right(root * 2, left, mid, qleft, qright, val);
    }

    return max(walk_right(root * 2, left, mid, qleft, qright, val),
               walk_right(root * 2 + 1, mid + 1, right, qleft, qright, val));
}

int walk_left(int root, int left, int right, int qleft, int qright, ll val)
{
    if (left > qright || right < qleft || tree[root].mx <= val)
        return n + 1;

    if (left == right)
        return left;

    int mid = (left + right) / 2;
    if (left >= qleft && right <= qright)
    {
        if (tree[root * 2].mx > val)
                    return walk_left(root * 2, left, mid, qleft, qright, val);
            return walk_left(root * 2 + 1, mid + 1, right, qleft, qright, val);
    }

    return min(walk_left(root * 2 + 1, mid + 1, right, qleft, qright, val),
               walk_left(root * 2, left, mid, qleft, qright, val));
}

ll query(int root, int left, int right, int qleft, int qright)
{
    if (left > qright || right < qleft)
        return 0;

    if (left >= qleft && right <= qright)
        return tree[root].cnt;

    int mid = (left + right) / 2;
    return query(root * 2, left, mid, qleft, qright) +
    query(root * 2 + 1, mid + 1, right, qleft, qright);
}

ll query_max(int root, int left, int right, int qleft, int qright)
{
    if (left > qright || right < qleft)
        return 0;

    if (left >= qleft && right <= qright)
        return tree[root].mx;

    int mid = (left + right) / 2;
    return max(query_max(root * 2, left, mid, qleft, qright),
    query_max(root * 2 + 1, mid + 1, right, qleft, qright));
}

unordered_map < ll, vector < int > > to_get;
vector < int > to_rem[maxn];

const int maxlog = 21;

int dp[maxlog][maxn], lg[maxn];

void build_sparse_table()
{
    for (int i = 1; i <= n; i ++)
    {
        lg[i] = lg[i / 2] + 1;
        dp[0][i] = a[i];
    }

    for (int j = 1; j < lg[n]; j ++)
    {
        for (int i = 1; i <= n; i ++)
        {
            dp[j][i] = dp[j - 1][i];
            if (dp[j - 1][i + (1 << (j - 1))] > dp[j][i])
            {
                dp[j][i] = dp[j - 1][i + (1 << (j - 1))];
            }
        }
    }
}

int rmq(int left, int right)
{
    int len = lg[right - left + 1] - 1;
    return max(dp[len][left], dp[len][right - (1 << len) + 1]);
}

void solve()
{
    cin >> n >> k;
    vector < pair < ll, int > > v;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i];
        to_get[a[i]].push_back(i);
        v.push_back({a[i], i});
    }
    build_sparse_table();
    ///cout << rmq(1, 3) << endl;
    sort(v.begin(), v.end());
    for (int i = 0; i < n; i ++)
    {
        pos[i + 1] = v[i].second;
        ///mp[v[i]] = i + 1;
    }

    /**for (int i = 1; i <= n; i ++)
    {
        f[i] = mp[a[i]];
        pos[f[i]] = i;
    }*/

    ll ans = 1;
    set < int > my_set;
    for (int i = n; i > 0; i --)
    {
        int lf = walk_right(1, 0, n + 1, 0, pos[i] - 1, k - a[pos[i]]);
        int rf = walk_left(1, 0, n + 1, pos[i] + 1, n + 1, k - a[pos[i]]);
        update(1, 0, n + 1, pos[i], a[pos[i]]);
        ll cnt = query(1, 0, n + 1, lf + 1, rf - 1);
        ///cout << k - a[pos[i]] << endl;
        ///cout << i << " " << lf << " " << rf << " " << cnt << endl;
    ///if (i == 4)
       ///     exit(0);
        ans = (ans * cnt) % mod;
        /**int lf = pos[i] - 1;
        ll cnt = 1;
        while(lf > 0)
        {
            if (t[lf] == 0)
            {
                lf --;
                continue;
            }
            if (a[lf] + a[pos[i]] > k)
                break;
            cnt ++;
            lf --;
        }

        int rf = pos[i] + 1;
        while(rf <= n)
        {
            if (t[rf] == 0)
            {
                rf ++;
                continue;
            }
            if (a[rf] + a[pos[i]] > k)
                break;
            cnt ++;
            rf ++;
        }
        ///cout << i << " : " << cnt << " " << pos[i] << " " << lf << " " << rf << endl;
        ///update(1, 0, n + 1, pos[i], a[pos[i]]);
        t[pos[i]] = 1;
        ans = (ans * (ll)(cnt)) % mod;*/

    }
    ///cout << ans << endl;
    /**fac[0] = 1;
    rev_fac[0] = power(fac[0], mod - 2);
    for (int i = 1; i <= n; i ++)
    {
        fac[i] = (fac[i - 1] * (ll)(i)) % mod;
        rev_fac[i] = power(fac[i], mod - 2);
    }*/

    for (int i = 0; i < n; i ++)
    {
        if (i != 0 && v[i].first == v[i - 1].first)
            continue;
            int cnt = 1;
            vector < int > cur = to_get[v[i].first];
            for (int j = 1; j < cur.size(); j ++)
            {
                int bef = cur[j - 1], nw = cur[j];
                int num = rmq(bef, nw);
                ///cout << bef << " " << nw << " " << num << endl;
                if (num + v[i].first > k)
                {
                    ans = (ans * rev_fac[cnt]) % mod;
                    ///cout << cnt << endl;
                    cnt = 0;
                }
                cnt ++;
            }
            /**for (int j = 1; j <= n; j ++)
            {
                if (a[j] + v[i].first > k)
                {
                    ans = (ans * rev_fac[cnt]) % mod;
                    ///cout << cnt << endl;
                    cnt = 0;
                }
                if (a[j] == v[i].first)
                    cnt ++;
            }*/

            ans = (ans * rev_fac[cnt]) % mod;
    }
    cout << ans << endl;


}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int main()
{
    speed();
    solve();
    return 0;
}
/**
5 7
4 3 1 5 2

5 4
4 3 1 5 2

5 3
1 1 3 1 1
*/
