#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 300000;
const long long MOD = 1000000007;

int a[MAXN + 5];
int tree[4 * MAXN + 5];
vector<int> G[MAXN + 5];

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = a[l];
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

int query(int v, int l, int r, int L, int R)
{
    if (R < l or r < L) return 0;
    if (L <= l and r <= R) return tree[v];

    int mid = (l + r) / 2;
    return max(query(2 * v, l, mid, L, R), query(2 * v + 1, mid + 1, r, L, R));
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, k;
    //cin >> n >> k;

    n = k = MAXN;

    a[0] = k;
    for (int i = 1; i <= n; ++ i)
    {
      a[i] = i;
        //cin >> a[i];
    }

    build(1, 0, n);

    for (int i = 1; i <= n; ++ i)
    {
        int l = 0, r = i, mid;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (query(1, 0, n, mid, i - 1) > k - a[i]) l = mid;
            else r = mid;
        }
        G[l].push_back(i);
    }

    /**for (int i = 0; i < n; ++ i)
    {
        cout << i << ":   ";
        for (auto x : G[i])
        {
            cout << x << " ";
        }
        cout << endl;
    }*/

    return 0;
}
