#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 300000;
const long long MOD = 1000000007;

int a[MAXN + 5];
int tree[4 * MAXN + 5];
vector<int> G[MAXN + 5];

void update(int v, int l, int r, int p, int val)
{
    if (l == r)
    {
        tree[v] = val;
        return;
    }

    int mid = (l + r) / 2;
    if (p <= mid) update(2 * v, l, mid, p, val);
    else update(2 * v + 1, mid + 1, r, p, val);
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

int query(int v, int l, int r, int L, int R)
{
    if (R < l or r < L) return 0;
    if (L <= l and r <= R) return tree[v];

    int mid = (l + r) / 2;
    return max(query(2 * v, l, mid, L, R), query(2 * v + 1, mid + 1, r, L, R));
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, k;
    ///cin >> n >> k;

    n = k = MAXN;

    vector<int> v;

    a[0] = k;
    v.push_back(k);
    for (int i = 1; i <= n; ++ i)
    {
      a[i] = i;
        ///cin >> a[i];
        v.push_back(a[i]);
    }

    sort(v.begin(), v.end());
    auto it = unique(v.begin(), v.end());
    v.resize(distance(v.begin(), it));

    int sz = v.size();

    for (int i = 1; i <= n; ++ i)
    {
        int pos = lower_bound(v.begin(), v.end(), k - a[i] + 1) - v.begin() + 1;
        int par = query(1, 1, sz, pos, sz);
        G[par].push_back(i);
        pos = lower_bound(v.begin(), v.end(), a[i]) - v.begin() + 1;
        update(1, 1, n, pos, i);
    }

    /**for (int i = 0; i < n; ++ i)
    {
        cout << i << ":   ";
        for (auto x : G[i])
        {
            cout << x << " ";
        }
        cout << endl;
    }*/

    return 0;
}
