#include "ones.h"
#include <stdlib.h>
#include <cassert>
#include <iostream>

int flip_bits(const std::vector<bool> &flips);

int n;

int randomize() {
	int bits;

	do {
		std::vector<bool> v;

		for (int i = 0; i < n; i += 1) {
			v.push_back(rand() & 1);
		}

		bits = flip_bits(v);
	} while (bits > 6);

	return bits;
}

int flip_bits_mask(int mask) {
	std::vector<bool> v;
	for (int i = 0; mask; i += 1) {
		v.push_back(mask & (1 << i));
		mask &= ~(1 << i);
	}
	while (v.size() < n) v.push_back(false);

	return flip_bits(v);
}

int iterate(int bits) {
	int best_idx = 0;
	int best_score = 0;

	for (int i = 1; i < (1 << bits); i += 1) {
		int curr_score = flip_bits_mask(i ^ (i - 1));

		if (curr_score > best_score) {
			best_idx = i;
			best_score = curr_score;
		}
	}

	int assert_score = flip_bits_mask(best_idx ^ ((1 << bits) - 1));

	assert(assert_score == best_score);
	
	return best_score;
}

std::pair<int, int> find_longest_subarray_of_ones(int local_n) {
	n = local_n;

	srand(777);
	return {0, iterate(randomize()) - 1};
}
