#include <bits/stdc++.h>

#define ll long long
#define lld long double
#define ff first
#define ss second
#define pb push_back
#define vr(v) v.begin(),v.end()
#define rv(v) v.rbegin(),v.rend()
#define Code ios_base::sync_with_stdio(false);
#define By cin.tie(NULL);
#define Davit cout.tie(NULL);

using namespace std;
using str = string;
const ll INF = 2e9;

// prllf("%.9f\n", x);
// cout << fixed << setprecision(n);

const ll mod = 1e9 + 7;
vector<ll> v;
vector<ll> seg;
ll n, k;
ll sz = 1;


vector<vector<ll>> sccx;

class Graph {
    ll V;
    list<ll> *adj;

    void fillOrder(ll s, bool visitedV[], stack<ll> &Stack);

    void DFS(ll s, bool visitedV[]);

public:
    Graph(ll V);

    void addEdge(ll s, ll d);

    void prllSCC();

    Graph transpose();
};

Graph::Graph(ll V) {
    this->V = V;
    adj = new list<ll>[V];
}

void Graph::DFS(ll s, bool visitedV[]) {
    visitedV[s] = true;
    sccx.back().push_back(s);
    list<ll>::iterator i;
    for (i = adj[s].begin(); i != adj[s].end(); ++i)
        if (!visitedV[*i])
            DFS(*i, visitedV);
}

Graph Graph::transpose() {
    Graph g(V);
    for (ll s = 0; s < V; s++) {
        list<ll>::iterator i;
        for (i = adj[s].begin(); i != adj[s].end(); ++i) {
            g.adj[*i].push_back(s);
        }
    }
    return g;
}

void Graph::addEdge(ll s, ll d) {
    adj[s].push_back(d);
}

void Graph::fillOrder(ll s, bool visitedV[], stack<ll> &Stack) {
    visitedV[s] = true;
    list<ll>::iterator i;
    for (i = adj[s].begin(); i != adj[s].end(); ++i)
        if (!visitedV[*i])
            fillOrder(*i, visitedV, Stack);

    Stack.push(s);
}

void Graph::prllSCC() {
    stack<ll> Stack;
    bool *visitedV = new bool[V];
    for (ll i = 0; i < V; i++)
        visitedV[i] = false;
    for (ll i = 0; i < V; i++)
        if (visitedV[i] == false) fillOrder(i, visitedV, Stack);
    Graph gr = transpose();

    for (ll i = 0; i < V; i++)
        visitedV[i] = false;

    while (Stack.empty() == false) {
        ll s = Stack.top();
        Stack.pop();

        if (visitedV[s] == false) {
            gr.DFS(s, visitedV);
            sccx.push_back({});
        }
    }
}


//seg tree
void build(ll l, ll r, ll x) {
    if (l == r) {
        if (l < n)seg[x] = v[l];
        return;
    }
    ll m = (l + r) / 2;
    build(l, m, x + x + 1);
    build(m + 1, r, x + x + 2);
    seg[x] = max(seg[x + x + 1], seg[x + x + 2]);
}

ll get(ll l, ll r, ll lx, ll rx, ll x) {
    if (lx >= l && rx <= r)return seg[x];
    if (lx > r || rx < l)return -1e12;
    ll m = (lx + rx) / 2;
    return max(get(l, r, lx, m, 2 * x + 1), get(l, r, m + 1, rx, 2 * x + 2));
}

ll get(ll l, ll r) {
    return get(l, r, 0, sz - 1, 0);
}

vector<vector<ll>> gp;

void cubes() {
    for (ll l = 0; l < n; l++) {
        for (ll r = l + 1; r < n; r++) {
            if (v[l] + get(l + 1, r) <= k) {
                gp[l].pb(r);
            }
            if (v[r] + get(l, r - 1) <= k) {
                gp[r].pb(l);
            }

        }
    }
}

map<ll, ll> kdk;
map<ll, ll> same;
ll res = 1;

void dfs(ll u, vector<bool> &vis) {
    vis[u] = 1;
    for (auto x: gp[u]) {
        if (same[x] != same[u]) {
            if (!vis[x]) {
                res *= kdk[x];
                res %= mod;
                dfs(x, vis);
            } else {

                res += kdk[u];
            }
        }
    }

}

int main() {
    cin >> n >> k;

    vector<ll> fact(n + 2);
    fact[0] = fact[1] = 1;
    for (ll i = 2; i <= n; i++) {
        fact[i] = (fact[i - 1] % mod * i) % mod;
    }
    gp.resize(n);
    v = vector<ll>(n);
    for (ll i = 0; i < n; i++)cin >> v[i];
    while (sz < n)sz <<= 1;
    seg.resize(sz * 2, 0);
    build(0, sz - 1, 0);
    Graph g(n);
    sccx.push_back({});
    cubes();
    for (ll i = 0; i < n; i++) {
        for (auto x: gp[i]) {
            g.addEdge(i, x);
        }
    }
//
    g.prllSCC();

    ll idx = 0;
    for (ll i = 0; i < sccx.size(); i++) {
        for (auto x: sccx[i]) {
            ll f = sccx[i].size();
            kdk[x] = fact[f];
            same[x] = idx;
        }
        idx++;
    }
    res = 1;
    vector<bool> vis(n);
    for (ll i = 0; i < gp.size(); i++) {
        if (!vis[i]) {
            res *= kdk[i];
            dfs(i, vis);
        }
    }
    cout << res % mod << "\n";
    return 0;
}

//4 6
//1 5 2 3

//4 10
//1 5 100 109