#include <bits/stdc++.h>

using namespace std ;

const int mod = 1e9 + 7 ;

int Add(int x , int y)
{
	int z = x + y ;
	if(z >= mod)
		z -= mod ;
	return z ;
}

int Sub(int x , int y)
{
	int z = x - y ;
	if(z < 0)
		z += mod ;
	return z ;
}

int Mul(int x , int y)
{
	return (1ll * x * y) % mod ;
}

const int MAX = 2004 ;

int arr[MAX] , mark[MAX] ;
int L[MAX] , R[MAX] ;

int n , k ;

int C[MAX][MAX] ;

void preprocess()
{
	C[0][0] = 1 ;
	for(int i = 1 ; i < MAX ; ++i)
	{
		C[i][0] = 1 ;
		for(int j = 1 ; j <= i ; ++j)
			C[i][j] = Add(C[i-1][j-1] , C[i-1][j]) ;
	}
}

int stars_and_bars(int x , int y)
{
	return C[x+y-1][y-1] ;
}

int solve(int idx)
{
	int x = arr[idx] , cnt1 = 0 , cnt2 = 1 ;
	for(int i = L[idx] ; i <= R[idx] ; ++i)
	{
		if(mark[i])
			continue ;
		if(arr[i] == x)
			cnt1++ , mark[i] = 1 ;
		else if(arr[i] > x)
			cnt2++ ;
		else
			assert(0) ;
	}
	return stars_and_bars(cnt1 , cnt2) ;
}

int main()
{
	ios_base::sync_with_stdio(0) ;
	cin.tie(0) ;
	preprocess() ;
	cin>>n>>k ;
	for(int i = 1 ; i <= n ; ++i)
		cin>>arr[i] ;
	vector<int>order ;
	for(int i = 1 ; i <= n ; ++i)
	{
		order.push_back(i) ;
		L[i] = R[i] = i ;
		for(int j = i-1 ; j >= 1 ; --j)
		{
			if(arr[i] + arr[j] > k)
				break ;
			L[i] = j ;
		}
		for(int j = i+1 ; j <= n ; ++j)
		{
			if(arr[i] + arr[j] > k)
				break ;
			R[i] = j ;
		}
	}
	sort(order.begin() , order.end()) ;
	order.erase(unique(order.begin() , order.end()) , order.end()) ;
	int ans = 1 ;
	for(auto &x : order)
	{
		for(int i = 1 ; i <= n ; ++i)
		{
			if(mark[i] || arr[i] != x)
				continue ;
			ans = Mul(ans , solve(i)) ;
		}
	}
	return cout<<ans<<"\n" , 0 ;
}