#include <bits/stdc++.h>

using namespace std ;

const int mod = 1e9 + 7 ;

int Add(int x , int y)
{
	int z = x + y ;
	if(z >= mod)
		z -= mod ;
	return z ;
}

int Sub(int x , int y)
{
	int z = x - y ;
	if(z < 0)
		z += mod ;
	return z ;
}

int Mul(int x , int y)
{
	return (1ll * x * y) % mod ;
}

int powlog(int base , int power)
{
	if(power == 0)
		return 1 ;
	int x = powlog(base , power / 2) ;
	x = Mul(x , x) ;
	if(power & 1)
		x = Mul(x , base) ;
	return x ;
}

int modinv(int x)
{
	return powlog(x , mod-2) ;
}

int Div(int x , int y)
{
	return Mul(x , modinv(y)) ;
}

const int MAX = 5000 + 10 ;

int arr[MAX] , mark[MAX] ;
int L[MAX] , R[MAX] ;

int n , k ;

int fact[MAX] , inv[MAX] ;

void preprocess()
{
	fact[0] = 1 ;
	for(int i = 1 ; i < MAX ; ++i)
		fact[i] = Mul(fact[i-1] , i) ;
	inv[MAX-1] = Div(1 , fact[MAX-1]) ;
	for(int i = MAX-2 ; i >= 0 ; --i)
		inv[i] = Mul(inv[i+1] , i+1) ;
}

int Choose(int n , int k)
{
	if(n < k || k < 0)
		return 0 ;
	return Div(fact[n] , Mul(fact[k] , fact[n-k])) ;
}

int stars_and_bars(int x , int y)
{
	return Choose(x+y-1 , y-1) ;
}

int solve(int idx)
{
	int x = arr[idx] , cnt1 = 0 , cnt2 = 1 ;
	for(int i = L[idx] ; i <= R[idx] ; ++i)
	{
		if(mark[i])
			continue ;
		if(arr[i] == x)
			cnt1++ , mark[i] = 1 ;
		else if(arr[i] > x)
			cnt2++ ;
		else
			assert(0) ;
	}
	return stars_and_bars(cnt1 , cnt2) ;
}

int main()
{
	ios_base::sync_with_stdio(0) ;
	cin.tie(0) ;
	preprocess() ;
	cin>>n>>k ;
	for(int i = 1 ; i <= n ; ++i)
		cin>>arr[i] ;
	vector<int>order ;
	for(int i = 1 ; i <= n ; ++i)
	{
		order.push_back(arr[i]) ;
		L[i] = R[i] = i ;
		for(int j = i-1 ; j >= 1 ; --j)
		{
			if(arr[i] + arr[j] > k)
				break ;
			L[i] = j ;
		}
		for(int j = i+1 ; j <= n ; ++j)
		{
			if(arr[i] + arr[j] > k)
				break ;
			R[i] = j ;
		}
	}
	sort(order.begin() , order.end()) ;
	order.erase(unique(order.begin() , order.end()) , order.end()) ;
	int ans = 1 ;
	for(auto &x : order)
	{
		for(int i = 1 ; i <= n ; ++i)
		{
			if(mark[i] || arr[i] != x)
				continue ;
			ans = Mul(ans , solve(i)) ;
		}
	}
	return cout<<ans<<"\n" , 0 ;
}