#include <bits/stdc++.h>

using namespace std ;

const int mod = 1e9 + 7 ;

int Add(int x , int y)
{
	int z = x + y ;
	if(z >= mod)
		z -= mod ;
	return z ;
}

int Sub(int x , int y)
{
	int z = x - y ;
	if(z < 0)
		z += mod ;
	return z ;
}

int Mul(int x , int y)
{
	return (1ll * x * y) % mod ;
}

int powlog(int base , int power)
{
	if(power == 0)
		return 1 ;
	int x = powlog(base , power / 2) ;
	x = Mul(x , x) ;
	if(power & 1)
		x = Mul(x , base) ;
	return x ;
}

int modinv(int x)
{
	return powlog(x , mod-2) ;
}

int Div(int x , int y)
{
	return Mul(x , modinv(y)) ;
}

const int MAX = 6e5 + 10 ;

int arr[MAX] , mark[MAX] ;
int L[MAX] , R[MAX] ;

int n , k ;

int fact[MAX] , inv[MAX] ;

void preprocess()
{
	fact[0] = 1 ;
	for(int i = 1 ; i < MAX ; ++i)
		fact[i] = Mul(fact[i-1] , i) ;
	inv[MAX-1] = Div(1 , fact[MAX-1]) ;
	for(int i = MAX-2 ; i >= 0 ; --i)
		inv[i] = Mul(inv[i+1] , i+1) ;
}

int Choose(int n , int k)
{
	if(n < k || k < 0)
		return 0 ;
	return Mul(fact[n] , Mul(inv[k] , inv[n-k])) ;
}

int stars_and_bars(int x , int y)
{
	return Choose(x+y-1 , y-1) ;
}

int bit[MAX] ;

void add(int i , int x)
{
	for(; i <= n ; i += (i & (-i)))
		bit[i] += x ;
}

int get(int i)
{
	int sum = 0 ;
	for(; i > 0 ; i -= (i & (-i)))
		sum += bit[i] ;
	return sum ;
}

int query(int l , int r)
{
	return (get(r) - get(l-1)) ;
}

int main()
{
	ios_base::sync_with_stdio(0) ;
	cin.tie(0) ;
	preprocess() ;
	cin>>n>>k ;
	for(int i = 1 ; i <= n ; ++i)
		cin>>arr[i] ;
	vector< pair<int , int> >order ;
	for(int i = 1 ; i <= n ; ++i)
		order.emplace_back(arr[i] , i) ;
	sort(order.begin() , order.end()) ;
	set<int>s ;
	s.insert(0) , s.insert(n+1) ;
	int j = n-1 ;
	for(auto &p : order)
	{
		int x = p.first , i = p.second ;
		while(j >= 0 && x + order[j].first > k)
			s.insert(order[j].second) , --j ;
		L[i] = *prev(s.lower_bound(i)) + 1 ;
		R[i] = *s.upper_bound(i) - 1 ;
	}

	for(int i = 1 ; i <= n ; ++i)
		add(i , 1) ;
	int ans = 1 ;
	for(int i = 0 ; i < n ; ++i)
	{
		int x = order[i].first , idx = order[i].second ;
		int j = i ;
		int cnt1 = 0 ;
		while(j < n && order[j].first == x && L[order[j].second] == L[idx])
			cnt1++ , add(order[j].second , -1) , ++j ;
		int cnt2 = query(L[idx] , R[idx]) + 1 ;
		ans = Mul(ans , stars_and_bars(cnt1 , cnt2)) ;
		i = j-1 ;
	}
	return cout<<ans<<"\n" , 0 ;
}