#include "ones.h"
#include <random>
#include <chrono>

using namespace std;
using namespace chrono;

int shuffle(int n) {
    mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
    vector <bool> now(n);
    for (int i = 0; i < n; ++i) {
        now[i] = rnd() % 2;
    }
    return flip_bits(now);
}

pair<int, int> find_longest_subarray_of_ones(int n) {
    vector <bool> now(n);
    int cur = shuffle(n);
    if (cur == 0) return make_pair(0, -1);
    for (int i = 0; i < n; ++i) {
        now[i] = true;
        int cha = flip_bits(now);
        if (cha == 0) return make_pair(0, -1);
        if (cha < cur) {
            cha = flip_bits(now);
        } else if (cha == cur) {
            now[i] = false;
            cur = cha;
            continue;
        }
        now[i] = false;
        cur = cha;
        for (int j = i - 1; j >= 0; --j) {
            now[j] = true;
            cha = flip_bits(now);
            if (cha == 0) return make_pair(0, -1);
            flip_bits(now);
            if (cha > cur) {
                return make_pair(j + 1, j + cur);
            }
            now[j] = false;
        }
        return make_pair(0, cur - 1);
    }
}