#include "ones.h"
#include <random>
#include <chrono>

using namespace std;
using namespace chrono;
mt19937 rnd(255);

int shuffle(int n) {
    vector <bool> now(n);
    for (int i = 0; i < n; ++i) {
        now[i] = rnd() % 2;
    }
    return flip_bits(now);
}

inline int ask(int n, const vector <int>& pos) {
    vector <bool> now(n);
    for (int i : pos) now[i] = true;
    return flip_bits(now);
}

pair<int, int> find_longest_subarray_of_ones(int n) {
    int cur = shuffle(n);
    if (cur == 0) return make_pair(0, -1);
    while (true) {
        vector <int> pos;
        pos.push_back(rnd() % 25);
        while (pos.back() + 25 < n) {
            pos.push_back(pos.back() + 25);
        }
        int cha = ask(n, pos);
        if (cha == cur) continue;
        int mx = max(cha, cur);
        cur = cha;
        while (pos.size() > 1) {
            vector <int> npos, npos2;
            for (int i = 0; i < (int)pos.size(); ++i) {
                if (i % 2 == 0) npos.push_back(pos[i]);
                else npos2.push_back(pos[i]);
            }
            int prv = cur;
            cur = ask(n, npos);
            if (prv == mx) {
                if (cur < mx) {
                    pos.swap(npos);
                } else {
                    pos.swap(npos2);
                }
            } else {
                if (cur == mx) {
                    pos.swap(npos);
                } else {
                    pos.swap(npos2);
                }
            }
        }
        int i = pos[0];
        if (cur != mx) cur = ask(n, {i});
        for (int j = i - 1; j >= 0; --j) {
            cha = ask(n, {j});
            if (cha > cur) {
                ask(n, {j});
                return make_pair(j + 1, j + cur);
            }
            ask(n, {j});
        }
        return make_pair(0, cur - 1);
    }
}
