#include <iostream>
#include <vector>

using namespace std;
#define ll long long

inline int get_seg(int l, int r, int x) {
    if (l > r) return 0;
    return r / x - (l - 1) / x;
}

void solve() {
    int p, q, n;
    cin >> p >> q >> n;
    ll ans = 0;
    int mx = p + q;
    vector <int> mind(mx + 1);
    vector <int> flex(mx + 1), pw(mx + 1), pr;
    for (int i = 2; i <= mx; ++i) {
        if (mind[i] == 0) {
            mind[i] = i;
            pw[i] = 1;
            pr.push_back(i);
            flex[i] = i;
        }
        for (int j : pr) {
            if (j > mind[i] || i * j > mx) break;
            int val = i * j;
            mind[val] = j;
            flex[val] = flex[i];
            if (j == mind[i]) {
                pw[val] = pw[i] + 1;
                if (pw[val] & 1) flex[val] *= j;
            } else {
                pw[val] = 1;
                flex[val] *= j;
            }
        }
    }
    ll l = 0, r = 2;
    for (int s = 2; s <= mx; ++s) {
        ll sr = s / 2;
        l = min(l, sr);
        r = max(r, sr + 1);
        while (l * (s - l) > 1ll * s * n) --l;
        while (r * (s - r) > 1ll * s * n) ++r;
        while (l + 1 <= sr && (l + 1) * (s - l - 1) <= 1ll * s * n) ++l;
        while (r - 1 > sr && (r - 1) * (s - r + 1) <= 1ll * s * n) --r;
        int l_seg = max(1, s - q);
        int r_seg = min(p, s - 1);
        if (l_seg > r_seg) continue;
        ans += get_seg(l_seg, l, flex[s]);
        ans += get_seg(r, r_seg, flex[s]);
    }
    cout << ans;
}

void stupid() {
    ll ans = 0;
    int p, q, n;
    cin >> p >> q >> n;
    for (int i = 1; i <= p; ++i) {
        for (int j = 1; j <= q; ++j) {
            if (i * j % (i + j) == 0) {
                if (i * j / (i + j) <= n) {
                    ++ans;
                    cout << i << " " << j << "\n";
                }
                else break;
            }
        }
    }
    cout << ans;
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        solve();
    } else {
        stupid();
    }
}

/*
2 2
3 6
4 4
4 12
6 3
6 6
6 12
8 8
10 10
12 4
12 6
 */