#include <iostream>
#include <vector>
#include <random>

using namespace std;
#define ll long long

inline int get_seg(int l, int r, int x) {
    if (l > r) return 0;
    return r / x - (l - 1) / x;
}

const int MAXS = 5e7 + 10;
int flex[MAXS];

inline ll solve(int p, int q, int n) {
    ll ans = 0;
    int mx = p + q;
    vector <int> pr;
    for (int i = 2; i <= mx; ++i) {
        int d = flex[i];
        if (flex[i] == 0) {
            d = i;
            flex[i] = i;
            pr.push_back(i);
        } else {
            int mp = i / d;
            flex[i] = flex[mp];
            if (mp % d == 0) {
                if ((flex[mp] >> 29) & 1) {
                    flex[i] ^= (1 << 29);
                    flex[i] *= d;
                } else {
                    flex[i] |= (1 << 29);
                }
            } else {
                if ((flex[mp] >> 29) & 1) flex[i] ^= (1 << 29);
                flex[i] *= d;
            }
        }
        for (int j : pr) {
            if (j > d || i * j > mx) break;
            int val = i * j;
            flex[val] = j;
        }
    }
    ll l = 0, r = 2;
    for (int s = 2; s <= mx; ++s) {
        if ((flex[s] >> 29) & 1) flex[s] ^= (1 << 29);
        ll sr = s / 2;
        l = min(l, sr);
        r = max(r, sr + 1);
        while (l * (s - l) > 1ll * s * n) --l;
        while (r * (s - r) > 1ll * s * n) ++r;
        while (l + 1 <= sr && (l + 1) * (s - l - 1) <= 1ll * s * n) ++l;
        while (r - 1 > sr && (r - 1) * (s - r + 1) <= 1ll * s * n) --r;
        int l_seg = max(1, s - q);
        int r_seg = min(p, s - 1);
        if (l_seg > r_seg) continue;
        if (r_seg <= l) ans += get_seg(l_seg, r_seg, flex[s]);
        else if (l_seg >= r) ans += get_seg(l_seg, r_seg, flex[s]);
        else {
            ans += get_seg(l_seg, l, flex[s]);
            ans += get_seg(r, r_seg, flex[s]);
        }
    }
    return ans;
}

inline ll stupid(int p, int q, int n) {
    ll ans = 0;
    for (int i = 1; i <= p; ++i) {
        for (int j = 1; j <= q; ++j) {
            if (i * j % (i + j) == 0) {
                if (i * j / (i + j) <= n) {
                    ++ans;
                }
                else break;
            }
        }
    }
    return ans;
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        int p, q, n;
        cin >> p >> q >> n;
        cout << solve(p, q, n);
    } else {
        mt19937 rnd(228);
        int t;
        cin >> t;
        while (t--) {
            int p = rnd() % 500 + 1;
            int q = rnd() % 500 + 1;
            int n = rnd() % 500 + 1;
            if (solve(p, q, n) != stupid(p, q, n)) {
                cout << p << " " << q << " " << n;
                return 0;
            }
        }
    }
}

/*
2 2
3 6
4 4
4 12
6 3
6 6
6 12
8 8
10 10
12 4
12 6
 */