#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 7;
const int M = 1e9 + 7;

int add(int a, int b) {
	return a + b < M ? a + b : a + b - M;
}

int mul(int a, int b) {
	return a * 1ll * b % M;
}

int pw(int a, int n) {
	int ret = 1;
	for (; n > 0; n >>= 1, a = mul(a, a)) {
		if (n & 1) {
			ret = mul(ret, a);
		}
	}
	return ret;
}

int f[N], rf[N];

int c(int n, int k) {
	return mul(f[n], mul(rf[k], rf[n - k]));
}

int n, k;
int w[N];
int ans = 1;
int kek = 1;
map<int, int> kekcnt;
int tmin[2 * N], tmax[2 * N], tcnt[2 * N];

int argmin(int i, int j) {
	if (i == -1) {
		return j;
	}
	if (j == -1) {
		return i;
	}
	return make_pair(w[i], i) < make_pair(w[j], j) ? i : j;
}

int argmax(int i, int j) {
	if (i == -1) {
		return j;
	}
	if (j == -1) {
		return i;
	}
	return make_pair(w[i], i) > make_pair(w[j], j) ? i : j;
}

void del(int i) {
	i += n;
	tmin[i] = -1;
	tmax[i] = -1;
	tcnt[i] = 0;
	for (; i > 0; i >>= 1) {
		tmin[i >> 1] = argmin(tmin[i], tmin[i ^ 1]);
		tmax[i >> 1] = argmax(tmax[i], tmax[i ^ 1]);
		tcnt[i >> 1] = tcnt[i] + tcnt[i ^ 1];
	}
}

int findmin(int l, int r) {
	int ret = -1;
	for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
		if (l & 1) {
			ret = argmin(ret, tmin[l]);
			++l;
		}
		if (r & 1) {
			--r;
			ret = argmin(ret, tmin[r]);
		}
	}
	return ret;
}

int findmax(int l, int r) {
	int ret = -1;
	for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
		if (l & 1) {
			ret = argmax(ret, tmax[l]);
			++l;
		}
		if (r & 1) {
			--r;
			ret = argmax(ret, tmax[r]);
		}
	}
	return ret;
}

int findcnt(int l, int r) {
	int ret = 0;
	for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
		if (l & 1) {
			ret += tcnt[l];
			++l;
		}
		if (r & 1) {
			--r;
			ret += tcnt[r];
		}
	}
	return ret;
}

void solve(int l, int r) {
	if (l >= r) {
		return;
	}
	int mx = findmax(l, r);
	if (mx == -1) {
		return;
	}
	int cnt = 0;
	kek = 1;
	kekcnt.clear();
	while (true) {
		int mn = findmin(l, mx);
		if (mn == -1) {
			break;
		}
		if (w[mn] + w[mx] > k) {
			break;
		}
		++cnt;
		kek = mul(kek, f[kekcnt[w[mn]]]);
		++kekcnt[w[mn]];
		kek = mul(kek, rf[kekcnt[w[mn]]]);
		del(mn);
	}
	while (true) {
		int mn = findmin(mx + 1, r);
		if (mn == -1) {
			break;
		}
		if (w[mn] + w[mx] > k) {
			break;
		}
		++cnt;
		kek = mul(kek, f[kekcnt[w[mn]]]);
		++kekcnt[w[mn]];
		kek = mul(kek, rf[kekcnt[w[mn]]]);
		del(mn);
	}
	if (2 * w[mx] <= k) {
		kek = mul(kek, f[kekcnt[w[mx]]]);
		++kekcnt[w[mx]];
		kek = mul(kek, rf[kekcnt[w[mx]]]);
		ans = mul(ans, mul(f[cnt + 1], kek));
	} else {
		ans = mul(ans, mul(f[cnt], kek));
		ans = mul(ans, c(cnt + findcnt(l, r), cnt));
		del(mx);
	}
	solve(l, mx);
	solve(mx + 1, r);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	f[0] = 1;
	for (int i = 1; i < N; ++i) {
		f[i] = mul(f[i - 1], i);
	}
	rf[N - 1] = pw(f[N - 1], M - 2);
	for (int i = N - 2; i >= 0; --i) {
		rf[i] = mul(rf[i + 1], i + 1);
	}
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	for (int i = 0; i < n; ++i) {
		tmin[i + n] = i;
		tmax[i + n] = i;
		tcnt[i + n] = 1;
	}
	for (int i = n - 1; i > 0; --i) {
		tmin[i] = argmin(tmin[2 * i], tmin[2 * i + 1]);
		tmax[i] = argmax(tmax[2 * i], tmax[2 * i + 1]);
		tcnt[i] = tcnt[2 * i] + tcnt[2 * i + 1];
	} 
	solve(0, n);
	cout << ans << endl;
	return 0;
}
