
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>



using namespace std;


#define int long long
#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


const ll mod = 1e9 + 7;


struct SGT_mx{
    int rn;
    int n;
    vector<ll> t;

    void build(vector<ll> &a){
        rn = a.size();
        n = 1; 
        while(n < a.size()){
            n *= 2;
        }
        t.assign(n + n, -1);
        for(int i = 0; i < a.size(); i += 1){
            t[i + n] = a[i];
        }
        for(int i = n - 1; i > 0; i -= 1){
            t[i] = max(t[i + i], t[i + i + 1]);
        }
    }


    ll get_frst_bgr(int v, int tl, int tr, int i, int x){
        if(tr <= i || t[v] <= x){
            return -1;
        }
        if(tl == tr){
            return tl;
        }
        int tm = (tl + tr) / 2;
        int ans = get_frst_bgr(v + v, tl, tm, i, x);
        if(ans == -1){
            ans = get_frst_bgr(v + v + 1, tm + 1, tr, i, x);
        }
        return ans;
    }


    ll get_frst_bgr(int i, int x){
        int ans = get_frst_bgr(1, 0, n - 1, i, x);
        if(ans == -1){
            ans = rn;
        }
        return ans;
    }


    ll get_frst_bgr(){

    }
};


struct SGT_sm{
    int n;
    vector<ll> t;

    void build(int _n){
        n = 1; 
        while(n < _n){
            n *= 2;
        }
        t.assign(n + n, 1);
        for(int i = n - 1; i > 0; i -= 1){
            t[i] =  t[i + i] + t[i + i + 1];
        }
    }


    void set(int i){
        i += n;
        for(; i > 0; i /= 2){
            t[i] -= 1;
        }
    }


    ll get(int l, int r){
        l += n;
        r += n;
        ll rs = 0;
        while(l < r){
            if(l & 1){
                rs += t[l];
                l += 1;
            }
            if(r & 1){
                r -= 1;
                rs += t[r];
            }
            l /= 2;
            r /= 2;
        }
        return rs;
    }

};


ll bin_pow(ll x, ll n){
    if(n == 0){
        return 1;
    }
    ll a = bin_pow(x, n / 2);
    a = (a * a) % mod;
    if(n & 1){
        a = (a * x) % mod;
    }
    return a;
}


ll rev(ll x){
    return bin_pow(x, mod - 2);
}


vector<ll> f, rf;


void build_f(int n){    
    f.resize(n + 1);
    rf.resize(n + 1);
    f[0] = 1;
    rf[0] = 1;
    for(int i = 1; i <= n; i += 1){
        f[i] = (f[i - 1] * i) % mod;
        rf[i] = rev(f[i]);
    }
}

ll cnk(ll n, ll k){
    return ((f[n] * rf[k]) % mod * rf[n - k]) % mod;
}


ll solve_slow(vector<ll> &a, ll k){
    int n = a.size();
    vector<int> usd(n, false);
    ll rs = 1;
    vector<pair<ll, int>> s(n);
    for(int i = 0; i < n; i += 1){
        s[i] = make_pair(a[i], i);
    }
    sort(all(s));
    build_f(n);
    SGT_mx sgtmx;
    sgtmx.build(a);
    auto ra = a;
    reverse(all(ra));
    SGT_mx sgtmxr;
    sgtmxr.build(ra);
    SGT_sm sgtsm;
    sgtsm.build(n);
    int itr = 0;
    for(; itr < n; ){
        vector<int> pss;
        pss.push_back(s[itr].second);
        itr += 1;
        while(itr < n && s[itr - 1].first == s[itr].first){
            pss.push_back(s[itr].second);
            itr += 1;
        }
        map<pair<int, int>, int> mpx;
        for(auto i: pss){
            int l = n - sgtmxr.get_frst_bgr(n - i - 1, k - a[i]);
            int r = sgtmx.get_frst_bgr(i, k - a[i]);
            mpx[make_pair(l, r)] += 1;
        }
        for(auto &q: mpx){
            int l = q.first.first;
            int r = q.first.second;
            int c = q.second;
            int f = sgtsm.get(l, r);
            rs = (rs * cnk(f, c)) % mod;
        }
        for(auto i: pss){
            sgtsm.set(i);
        }
    }
    return rs;
}


int32_t main(){
    if(1){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    int n;
    ll k;
    cin >> n >> k;
    vector<ll> a(n);
    for(int i = 0; i < n; i += 1){
        cin >> a[i];
    }
    cout << solve_slow(a, k) << "\n";
    return 0;
}