#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,fma")


#include <bits/stdc++.h>


using namespace std;


#define int long long
#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()



const int mxt = 1e5;
vector<vector<int>> prms;


void build_prms(){
    prms.assign(mxt + 1, {});
    for(int i = 1; i <= mxt; i += 1){
        ll n = i;
        for(ll j = 2; j * j <= n; j += 1){
            if(n % j == 0){
                while(n % j == 0){
                    n /= j;
                }
                prms[i].push_back(j);
            }
        }
        if(n > 1){
            prms[i].push_back(n);
        }
    }
}


const int mx_pw = 16;
vector<ll> prmtvf(1 << mx_pw), prmtvc(1 << mx_pw);


ll cnt_prmtv(ll a, ll l, ll r){
    if(l > r){
        return 0;
    }
    int n = prms[a].size();
    ll rs = 0;
    prmtvc[0] = 0;
    prmtvf[0] = 1;
    for(int t = 0; t < n; t += 1){
        int dt = (1 << t);
        int mp = prms[a][t];
        for(int msk = 0; msk < dt; msk += 1){
            auto f = prmtvf[msk] * mp;
            auto c = prmtvc[msk] ^ 1;
            prmtvf[msk + dt] = f;
            prmtvc[msk + dt] = c;
            ll drs = (r / f) - (l - 1) / f;
            if(c == 1){
                rs += drs;
            } else{
                rs -= drs;
            }
            }
    }
    rs = r - l + 1 - rs;
    return rs;
}


ll cnt_prmtv_l1(ll a, ll r){
    const ll l = 1;
    if(l > r){
        return 0;
    }
    int n = prms[a].size();
    ll rs = 0;
    prmtvc[0] = 0;
    prmtvf[0] = 1;
    for(int t = 0; t < n; t += 1){
        int dt = (1 << t);
        int mp = prms[a][t];
        for(int msk = 0; msk < dt; msk += 1){
            auto f = prmtvf[msk] * mp;
            auto c = prmtvc[msk] ^ 1;
            prmtvf[msk + dt] = f;
            prmtvc[msk + dt] = c;
            ll drs = (r / f);
            if(c == 1){
                rs += drs;
            } else{
                rs -= drs;
            }
            }
    }
    rs = r - l + 1 - rs;
    return rs;
}


ll gcd(ll a, ll b){
    while(a != 0){
        b %= a;
        swap(a, b);
    }
    return b;
}




ll solve_slow(ll p, ll q, ll n){
    ll rs = 0;
    for(ll a1 = 1; a1 * a1 <= p; a1 += 1){
        for(ll b1= 1; b1 * b1 <= q; b1 += 1){
            if(gcd(a1, b1) != 1){
                continue;
            }
            ll mxt = min({n / (a1 * b1), p / ((a1 + b1) * a1), q / ((a1 + b1) * b1)});
            if(mxt == 0){
                break;
            }
            rs += mxt;
        }
    }
    return rs;
}



ll solve(ll p, ll q, ll n){
    build_prms();
    ll rs = 0;
    for(ll t = 1; t <= n;){
        ll tl = t;
        ll tr = n + 1;
        ll p1 = p / t;
        ll q1 = q / t;
        ll n1 = n / t;
        while(tl + 1 < tr){
            ll tm = (tl + tr) / 2;
            if((p / tm) != p1 || (q / tm) != q1 || (n / tm) != n1){
                tr = tm;
            } else{
                tl = tm;
            }
        }
        ll drs = 0;
        for(ll a1 = 1; a1 * a1 <= p1; a1 += 1){
            ll mx_b = min(p1 / (a1) - a1, n1 / (a1));
            mx_b = min(mx_b, (ll)(floor((-(flt)(a1) + sqrt((flt)(a1) * a1 + 4 * q1)) / (flt)(2))));
            ll mn_b = 1;
            drs += cnt_prmtv_l1(a1, mx_b);
        }
        rs += drs * (tr - t);
        t = tr;
    }
    return rs;
}


int32_t main(){
    ll p, q, n;
    cin >> p >> q >> n;
    cout << solve(p, q, n) << "\n";
    return 0;
}