#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <iomanip>

using namespace std;
typedef long long ll;

int n, k;
vector <int> a;

const int MOD = 1000000007;
const int N = 300010;

int fact[N];
int _fact[N];

int bp(int a, int b)
{
	int ans = 1;
	while (b)
	{
		if (b & 1) ans = (ll)ans * a % MOD;
		a = (ll)a * a % MOD;
		b >>= 1;
	}
	return ans;
}

int C(int n, int k)
{
	return (ll)fact[n] * _fact[k] % MOD * _fact[n - k] % MOD;
}

int dfs(vector <int> a)
{
	int n = a.size();
	if (n == 0) return 1;
	int ind = min_element(a.begin(), a.end()) - a.begin();

	for (int i = ind - 1; i >= 0; --i)
	{
		if (a[i] + a[ind] > k)
		{
			vector <int> l;
			vector <int> r;
			for (int j = 0; j < n; ++j)
			{
				if (j < i) l.push_back(a[j]);
				else if (j > i) r.push_back(a[j]);
			}
			int g1 = dfs(l);
			int g2 = dfs(r);
			return (ll)g1 * g2 % MOD;
		}
	}
	for (int i = ind + 1; i < n; ++i)
	{
		if (a[i] + a[ind] > k)
		{
			vector <int> l;
			vector <int> r;
			for (int j = 0; j < n; ++j)
			{
				if (j < i) l.push_back(a[j]);
				else if (j > i) r.push_back(a[j]);
			}
			int g1 = dfs(l);
			int g2 = dfs(r);
			return (ll)g1 * g2 % MOD;
		}
	}

	vector <int> el;
	for (int i = 0; i < n; ++i) if (a[i] != a[ind]) el.push_back(a[i]);
	return (ll)C(n, el.size()) * dfs(el) % MOD;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> k;
	a.resize(n);
	
	for (int i = 0; i < n; ++i) cin >> a[i];

	fact[0] = 1;
	for (int i = 1; i <= n; ++i) fact[i] = (ll)fact[i - 1] * i % MOD;
	for (int i = 0; i <= n; ++i) _fact[i] = bp(fact[i], MOD - 2);

	auto got = dfs(a);

	cout << got;

	return 0;
}
