#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <iomanip>

using namespace std;
typedef long long ll;

const int MOD = 1000000007;
const int N = 300010;
const int inf = 1e9 + 10;
int n, k;
int a[N];


int fact[N];
int _fact[N];

int bp(int a, int b)
{
	int ans = 1;
	while (b)
	{
		if (b & 1) ans = (ll)ans * a % MOD;
		a = (ll)a * a % MOD;
		b >>= 1;
	}
	return ans;
}

int C(int n, int k)
{
	return (ll)fact[n] * _fact[k] % MOD * _fact[n - k] % MOD;
}

pair <int, int> mint[4 * N];
pair <int, int> maxt[4 * N];

void rec(int i)
{
	mint[i] = min(mint[2 * i + 1], mint[2 * i + 2]);
	maxt[i] = max(maxt[2 * i + 1], maxt[2 * i + 2]);
}

void build(int i, int l, int r)
{
	if (l + 1 == r)
	{
		mint[i] = { a[l], l };
		maxt[i] = { a[l], l };
		return;
	}

	int m = (l + r) >> 1;
	build(2 * i + 1, l, m);
	build(2 * i + 2, m, r);
	rec(i);
}

void de(int i, int l, int r, int q)
{
	if (l + 1 == r)
	{
		mint[i] = { inf, 0 };
		maxt[i] = { 0, 0 };
		return;
	}

	int m = (l + r) >> 1;
	if (q < m) de(2 * i + 1, l, m, q);
	else de(2 * i + 2, m, r, q);
	rec(i);
}

pair <int, int> gtmin(int i, int l, int r, int ql, int qr)
{
	if (ql <= l && r <= qr) return mint[i];
	if (qr <= l || r <= ql) return { inf, 0 };

	int m = (l + r) >> 1;
	return min(
		gtmin(2 * i + 1, l, m, ql, qr),
		gtmin(2 * i + 2, m, r, ql, qr)
	);
}

pair <int, int> gtmax(int i, int l, int r, int ql, int qr)
{
	if (ql <= l && r <= qr) return maxt[i];
	if (qr <= l || r <= ql) return { 0, 0 };

	int m = (l + r) >> 1;
	return max(
		gtmax(2 * i + 1, l, m, ql, qr),
		gtmax(2 * i + 2, m, r, ql, qr)
	);
}

int fenw[N];

inline void add(int i, int v = 1)
{
	for (; i < N; i = (i + 1) | i) fenw[i] += v;
}

inline int gt(int i)
{
	int ans = 0;
	for (; i >= 0; i = ((i + 1) & i) - 1) ans += fenw[i];
	return ans;
}

inline int gt(int l, int r)
{
	return gt(r - 1) - gt(l - 1);
}

int dfs(int l, int r)
{
	auto ind = gtmin(0, 1, n + 1, l, r);
	auto indmx = gtmax(0, 1, n + 1, l, r);

	if (ind.second == 0) return 1;

	if (ind.first + indmx.first > k)
	{
		int g1 = dfs(l, indmx.second);
		int g2 = dfs(indmx.second + 1, r);
		return (ll)g1 * g2 % MOD;
	}
	
	int val = ind.first;
	int cnt = 0;
	int f = gt(l, r);
	while (true)
	{
		auto got = gtmin(0, 1, n + 1, l, r);
		if (got.first != val) break;
		de(0, 1, n + 1, got.second);
		add(got.second, -1);
		++cnt;
	}
	return (ll)C(f, cnt) * dfs(l, r) % MOD;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> k;
	
	for (int i = 1; i <= n; ++i) cin >> a[i];

	fact[0] = 1;
	for (int i = 1; i <= n; ++i) fact[i] = (ll)fact[i - 1] * i % MOD;
	for (int i = 0; i <= n; ++i) _fact[i] = bp(fact[i], MOD - 2);

	build(0, 1, n + 1);
	for (int i = 1; i <= n; ++i) add(i);
	auto got = dfs(1, n + 1);

	cout << got;

	return 0;
}
