#include "ones.h"
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <iomanip>
#include <random>

using namespace std;
typedef long long ll;

int gtemp(int n)
{
	vector <bool> zer(n);
	return flip_bits(zer);
}

int gtinv(int n, int i)
{
	vector <bool> zer(n);
	zer[i] = true;
	return flip_bits(zer);
}

int gt(int n, set<int>& a)
{
	vector <bool> zer(n);
	for (auto i : a) zer[i] = true;
	return flip_bits(zer);
}

pair<int, int> find_longest_subarray_of_ones(int n)
{
	int was = gtemp(n);

	int C = min(70, max(1, (int)sqrt(n)));
	if (C <= 5) C = 1;

	while (true)
	{
		set <int> maybe;

		while (maybe.size() < C)
		{
			maybe.insert(rand() % n);
		}

		int nw = gt(n, maybe);
		if (nw == was)
		{
			continue;
		}

		gt(n, maybe);
		for (auto i : maybe)
		{
			int nw = gtinv(n, i);
			if (nw == was)
			{
				continue;
			}

			if (nw < was)
			{
				gtinv(n, i);
				nw = was;
			}
			if (nw < was)
			{
				gtinv(n, i);
				nw = was;
			}

			int l = i, r = -1;
			while (r + 1 < l)
			{
				int m = (l + r) >> 1;
				int gt = gtinv(n, m);
				gtinv(n, m);
				if (gt < nw)
				{
					l = m;
				}
				else
				{
					r = m;
				}
			}
			int x = l;
			l = i, r = n;
			while (l + 1 < r)
			{
				int m = (l + r) >> 1;
				int gt = gtinv(n, m);
				gtinv(n, m);
				if (gt < nw)
				{
					l = m;
				}
				else
				{
					r = m;
				}
			}
			int y = l;
			return { x, y };
		}
	}
	return { 0, -1 };
}