#include "ones.h"
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <iomanip>
#include <random>

using namespace std;
typedef long long ll;

int gtemp(int n)
{
    vector <bool> zer(n);
    return flip_bits(zer);
}

int gtinv(int n, int i)
{
    vector <bool> zer(n);
    zer[i] = true;
    return flip_bits(zer);
}

int gt(int n, set<int>& a)
{
    vector <bool> zer(n);
    for (auto i : a) zer[i] = true;
    return flip_bits(zer);
}

pair<int, int> find_longest_subarray_of_ones(int n)
{
    set <int> globalwas;
    int was = gtemp(n);
    srand(n);

    int F = 40;
    if (n <= 1000) F = 1;

    for (int _ = 0;; ++_)
    {
        int C = F;
        set <int> maybe;

        while (maybe.size() < C)
        {
            if (globalwas.size() == n) globalwas.clear();
            auto u = rand() % n;
            if (globalwas.count(u)) continue;
            globalwas.insert(u);
            maybe.insert(u);
        }

        int nw = gt(n, maybe);
        if (nw == was)
        {
            continue;
        }

        gt(n, maybe);
        vector <int> mb;
        for (auto i : maybe) mb.push_back(i);
        random_shuffle(mb.begin(), mb.end());
        for (auto i : mb)
        {
            int nw = gtinv(n, i);
            if (nw == was)
            {
                continue;
            }

            if (nw < was)
            {
                gtinv(n, i);
                nw = was;
            }
            if (nw < was)
            {
                gtinv(n, i);
                nw = was;
            }

            if (i <= n / 2)
            {
                int l = i, r = -1;
                while (r + 1 < l)
                {
                    int m = (l + r) >> 1;
                    int gt = gtinv(n, m);
                    if (gt != nw) gtinv(n, m);

                    if (gt < nw)
                    {
                        l = m;
                    }
                    else
                    {
                        r = m;
                    }
                }
                int x = l;
                return { x, x + nw - 1 };
            }
            else
            {
                int l = i, r = n;
                while (l + 1 < r)
                {
                    int m = (l + r) >> 1;
                    int gt = gtinv(n, m);
                    if (gt != nw) gtinv(n, m);

                    if (gt < nw)
                    {
                        l = m;
                    }
                    else
                    {
                        r = m;
                    }
                }
                int y = l;
                return { y - nw + 1, y };
            }
        }
    }
    return { 0, -1 };
}