#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <iomanip>

using namespace std;
typedef long long ll;
#define int long long

int gcd(int a, int b)
{
	while (a)
	{
		b %= a;
		swap(a, b);
	}
	return b;
}

int p, q, n;
ll ans;

const int N = 100010;
vector <int> prdiv[N];

int eul(int x, int i)
{
	int len = prdiv[i].size();
	int ans = x;
	for (int musk = 1; musk < (1 << len); ++musk)
	{
		int mult = 1;
		int cnt = 0;
		for (int j = 0; j < len; ++j)
		{
			if ((musk >> j) & 1)
			{
				++cnt;
				mult *= prdiv[i][j];
			}
		}

		if (cnt % 2) ans -= x / mult;
		else ans += x / mult;
	}
	return ans;
}

vector <int> que[N];

ll gt(int p, int q, int n)
{
	ll ans = 0;
	ans += min({ p / 2, q / 2, n });

	int C = 10000;

	for (int f = 1; f <= C; ++f)
	{
		for (int i = 1; i <= p; ++i)
		{
			if (f * i * (i + 1) > n) break;
			int l = i, r = q + 1;
			while (l + 1 < r)
			{
				int j = (l + r) >> 1;
				if (f * (i + j) * i > p || f * (i + j) * j > q || f * i * j > n) r = j;
				else l = j;
			}
			if (l > i) que[i].push_back(l);
		}

		for (int i = 1; i <= q; ++i)
		{
			if (f * i * (i + 1) > n) break; int l = i, r = q + 1;
			while (l + 1 < r)
			{
				int j = (l + r) >> 1;
				if (f * (i + j) * i > q || f * (i + j) * j > p || f * i * j > n) r = j;
				else l = j;
			}
			if (l > i) que[i].push_back(l);
		}
	}

	//int f = 0;

	for (int i = 1; i < N; ++i)
	{
		int got = eul(i, i);
		ans -= got * que[i].size();
		int len = prdiv[i].size();

		for (int musk = 0; musk < (1 << len); ++musk)
		{
			int mult = 1;
			int cnt = 0;
			for (int j = 0; j < len; ++j)
			{
				if ((musk >> j) & 1)
				{
					++cnt;
					mult *= prdiv[i][j];
				}
			}
			
			for (auto x : que[i])
			{
				if (cnt % 2) ans -= x / mult;
				else ans += x / mult;
			}

		}
		//f += (int)(1 << (int)(prdiv[i].size())) * (int)que[i].size();
	}

	for (int i = 1; i <= p; ++i)
	{
		for (int j = i + 1; j <= q; ++j)
		{
			if (C * (i + j) * i > p || C * (i + j) * j > q || C * i * j > n) break;
			if (gcd(i, j) > 1) continue;
			ans += min({ p / ((i + j) * i), q / ((i + j) * j), n / (i * j) }) - C;
		}
	}

	for (int i = 1; i <= q; ++i)
	{
		for (int j = i + 1; j <= p; ++j)
		{
			if (C * (i + j) * i > q || C * (i + j) * j > p || C * i * j > n) break;
			if (gcd(i, j) > 1) continue;
			ans += min({ q / ((i + j) * i), p / ((i + j) * j), n / (i * j) }) - C;
		}
	}

	return ans;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	//int f = 0;

	for (int i = 2; i < N; ++i)
	{
		int cop = i;
		for (int d = 2; d * d <= cop; ++d)
		{
			if (cop % d == 0)
			{
				prdiv[i].push_back(d);
				while (cop % d == 0)
				{
					cop /= d;
				}
			}
		}

		if (cop > 1) prdiv[i].push_back(cop);
		//f += 1 << prdiv[i].size();
	}

	cin >> p >> q >> n;

	auto got = gt(p, q, n);
	cout << got;

	return 0;
}
