#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <iomanip>

using namespace std;
typedef long long ll;
#define int long long
#define __int128 long double

int gcd(int a, int b)
{
	while (a)
	{
		b %= a;
		swap(a, b);
	}
	return b;
}

int p, q, n;
ll ans;

const int N = 100010;
vector <int> prdiv[N];

int eul(int x, int i)
{
	int len = prdiv[i].size();
	int ans = x;
	for (int musk = 1; musk < (1 << len); ++musk)
	{
		int mult = 1;
		int cnt = 0;
		for (int j = 0; j < len; ++j)
		{
			if ((musk >> j) & 1)
			{
				++cnt;
				mult *= prdiv[i][j];
			}
		}

		if (cnt % 2) ans -= x / mult;
		else ans += x / mult;
	}
	return ans;
}

vector <int> que[N];

int j1(int f, int i, int p, int q)
{
//	int l = i, r = q + 1;
//	while (l + 1 < r)
//	{
//		int j = (l + r) >> 1;
//		if ((__int128)f * (i + j) * i > p) r = j;
//		else l = j;
//	}
//
//	int ans = ;
//	//assert(ans == l);
	return p / i - f * i;
}

int j3(int f, int i)
{/*
	int l = i, r = q + 1;
	while (l + 1 < r)
	{
		int j = (l + r) >> 1;
		if ((__int128)f * (i + j) * i > p || (__int128)f * (i + j) * j > q || (__int128)f * i * j > n) r = j;
		else l = j;
	}*/
	return n / (f * i);
}

typedef long double ld;
const ld EPS = 1e-9;

int j2(ld f, ld i, int p, ld q)
{
	/*int l = i, r = q + 1;
	while (l + 1 < r)
	{
		int j = (l + r) >> 1;
		if ((__int128)f * (i + j) * i > p || (__int128)f * (i + j) * j > q || (__int128)f * i * j > n) r = j;
		else l = j;
	}*/
	return (int)((sqrt(i * i + 4 * q / f) - i) / 2 + EPS);
}

ll gt(int p, int q, int n)
{
	ll ans = 0;
	ans += min({ p / 2, q / 2, n });

	int C = 2000;

	for (int f = 1; f <= C; ++f)
	{
		for (int i = 1; i <= p; ++i)
		{
			if ((__int128)f * i * (i + 1) > n) break;
			int l = min({
				j1(f, i, p, q),
				j2(f, i, p, q),
				j3(f, i),
				q
				});
			if (l > i) que[i].push_back(l);
		}

		for (int i = 1; i <= q; ++i)
		{
			if ((__int128)f * i * (i + 1) > n) break;
			int l = min({
				j1(f, i, q, p),
				j2(f, i, q, p),
				j3(f, i),
				p
				});

			if (l > i) que[i].push_back(l);
		}
	}

	for (int i = 1; i < N; ++i)
	{
		int got = eul(i, i);
		ans -= got * que[i].size();
		int len = prdiv[i].size();

		for (int musk = 0; musk < (1 << len); ++musk)
		{
			int mult = 1;
			int cnt = 0;
			for (int j = 0; j < len; ++j)
			{
				if ((musk >> j) & 1)
				{
					++cnt;
					mult *= prdiv[i][j];
				}
			}
			
			for (auto x : que[i])
			{
				if (cnt & 1) ans -= x / mult;
				else ans += x / mult;
			}

		}
	}

	for (int i = 1; i <= p; ++i)
	{
		if ((__int128)i * (i + 1) * C > n) break;
		for (int j = i + 1; j <= q; ++j)
		{
			if ((__int128)C * (i + j) * i > p || (__int128)C * (i + j) * j > q || (__int128)C * i * j > n) break;
			if (gcd(i, j) > 1) continue;
			ans += min({ p / ((i + j) * i), q / ((i + j) * j), n / (i * j) }) - C;
		}
	}

	for (int i = 1; i <= q; ++i)
	{
		if ((__int128)i * (i + 1) * C > n) break;
		for (int j = i + 1; j <= p; ++j)
		{
			if ((__int128)C * (i + j) * i > q || (__int128)C * (i + j) * j > p || (__int128)C * i * j > n) break;
			if (gcd(i, j) > 1) continue;
			ans += min({ q / ((i + j) * i), p / ((i + j) * j), n / (i * j) }) - C;
		}
	}

	return ans;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	//int f = 0;

	for (int i = 2; i < N; ++i)
	{
		int cop = i;
		for (int d = 2; d * d <= cop; ++d)
		{
			if (cop % d == 0)
			{
				prdiv[i].push_back(d);
				while (cop % d == 0)
				{
					cop /= d;
				}
			}
		}

		if (cop > 1) prdiv[i].push_back(cop);
		//f += 1 << prdiv[i].size();
	}

	cin >> p >> q >> n;

	auto got = gt(p, q, n);
	cout << got;

	return 0;
}
