#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back

mt19937 rnd(51);

const int N = 1010, MOD = 1e9 + 7;
int dp[N][N];

int add(int a, int b) {
    return a + b >= MOD ? a + b - MOD : a + b;
}

int mul(int a, int b) {
    return (1ll * a * b % MOD);
}

int solve(int n, int k, vector<int> a) {
    deque<vector<int>> q{a};
    map<vector<int>, int> mp;
    mp[a] = 1;
    int ans = 0;
    while (q.size() > 0) {
        auto v = q.front();
        q.pop_front();
        ans++;
        for (int i = 0; i + 1 < n; i++) {
            if (v[i] + v[i + 1] <= k) {
                swap(v[i], v[i + 1]);
                if (!mp[v]) {
                    q.pb(v);
                    mp[v] = 1;
                }
                swap(v[i], v[i + 1]);
            }
        }
    }
    return ans;
}

int solve2(int k, vector<int> a) {
    if (a.size() <= 1) {
        return 1;
    }
    int ind = -1;
    for (int i = 0; i < a.size(); i++) {
        if (ind == -1 || a[i] > a[ind]) {
            ind = i;
        }
    }
    vector<int> l, r;
    int any = 0;
    for (int i = 0; i < a.size(); i++) {
        if (i == ind) continue;
        if (a[i] + a[ind] > k) {
            if (i < ind) {
                l.pb(a[i]);
            } else {
                r.pb(a[i]);
            }
        } else {
            any++;
        }
    }
    int res1 = solve2(k, l), res2 = solve2(k, r);
    int sz = l.size() + r.size() + 2;
    return mul(mul(res1, res2), dp[sz][any]);
}

void pre_calc() {
    dp[0][0] = 1;
    for (int i = 1; i < N; i++) {
        for (int j = 0; j < N; j++) {
            dp[i][j] = dp[i - 1][j];
            if (j > 0) {
                dp[i][j] = add(dp[i][j], mul(dp[i][j - 1], j));
            }
        }
    }
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    pre_calc();
    while (0) {
        int n = rnd() % 10 + 1;
        int k = rnd() % (2 * n + 2);
        vector<int> a(n);
        iota(a.begin(), a.end(), 0);
        random_shuffle(a.begin(), a.end());
        auto res = solve(n, k, a), res2 = solve2(k, a);
        if (res != res2) {
            cout << n << ' ' << k << endl;
            for (auto to : a) {
                cout << to << ' ';
            }
            cout << endl;
            return 0;
        }
        cout << "ok" << endl;
    }
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cout << solve2(k, a) << endl;
    return 0;
}
