#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back

mt19937 rnd(51);

const int N = 2010, MOD = 1e9 + 7;
int f[N], inv_f[N];

int add(int a, int b) {
    return a + b >= MOD ? a + b - MOD : a + b;
}

int mul(int a, int b) {
    return (1ll * a * b % MOD);
}

int cnk(int n, int k) {
    if (k > n) return 0;
    return mul(f[n], mul(inv_f[k], inv_f[n - k]));
}

int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) {
            res = mul(res, a);
        }
        a = mul(a, a);
        n /= 2;
    }
    return res;
}

int inv(int a) {
    return binpow(a, MOD - 2);
}

void pre_calc() {
    for (int i = 0; i < N; i++) {
        f[i] = (i == 0 ? 1 : mul(f[i - 1], i));
        inv_f[i] = inv(f[i]);
    }
}

int solve(int n, int k, vector<int> a) {
    deque<vector<int>> q{a};
    map<vector<int>, int> mp;
    mp[a] = 1;
    int ans = 0;
    while (q.size() > 0) {
        auto v = q.front();
        q.pop_front();
        ans++;
        for (int i = 0; i + 1 < n; i++) {
            if (v[i] + v[i + 1] <= k) {
                swap(v[i], v[i + 1]);
                if (!mp[v]) {
                    q.pb(v);
                    mp[v] = 1;
                }
                swap(v[i], v[i + 1]);
            }
        }
    }
    return ans;
}

int solve2(int k, vector<int> a) {
    if (a.size() <= 1) {
        return 1;
    }
    int ind = -1;
    map<int,int> cnt;
    for (int i = 0; i < a.size(); i++) {
        if (ind == -1 || a[i] > a[ind]) {
            ind = i;
        }
    }
    vector<int> l, r;
    int any = 0;
    for (int i = 0; i < a.size(); i++) {
        if (i == ind) continue;
        if (a[i] + a[ind] > k) {
            if (i < ind) {
                l.pb(a[i]);
            } else {
                r.pb(a[i]);
            }
        } else {
            any++;
            cnt[a[i]]++;
        }
    }
    int res = f[any];
    for (auto to : cnt) {
        res = mul(res, inv_f[to.second]);
    }
    int res1 = solve2(k, l), res2 = solve2(k, r);
    int sz = l.size() + r.size() + 2;
    res = mul(res, cnk(sz + any - 1, any));
    return mul(mul(res1, res2), res);
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    pre_calc();
    while (0) {
        int n = rnd() % 5 + 1;
        int k = rnd() % (2 * n + 2);
        vector<int> a(n);
        iota(a.begin(), a.end(), 0);
        random_shuffle(a.begin(), a.end());
        auto res = solve(n, k, a), res2 = solve2(k, a);
        if (res != res2) {
            cout << n << ' ' << k << endl;
            for (auto to : a) {
                cout << to << ' ';
            }
            cout << endl;
            return 0;
        }
        cout << "ok" << endl;
    }
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cout << solve2(k, a) << endl;
    return 0;
}
