#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back

mt19937 rnd(51);

const int N = 6e5 + 10, MOD = 1e9 + 7, INF = 1e9;
int f[N], inv_f[N];

int add(int a, int b) {
    return a + b >= MOD ? a + b - MOD : a + b;
}

int mul(int a, int b) {
    return (1ll * a * b % MOD);
}

int cnk(int n, int k) {
    if (k > n) return 0;
    return mul(f[n], mul(inv_f[k], inv_f[n - k]));
}

int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) {
            res = mul(res, a);
        }
        a = mul(a, a);
        n /= 2;
    }
    return res;
}

int inv(int a) {
    return binpow(a, MOD - 2);
}

void pre_calc() {
    for (int i = 0; i < N; i++) {
        f[i] = (i == 0 ? 1 : mul(f[i - 1], i));
        inv_f[i] = inv(f[i]);
    }
}

int solve(int n, int k, vector<int> a) {
    deque<vector<int>> q{a};
    map<vector<int>, int> mp;
    mp[a] = 1;
    int ans = 0;
    while (q.size() > 0) {
        auto v = q.front();
        q.pop_front();
        ans++;
        for (int i = 0; i + 1 < n; i++) {
            if (v[i] + v[i + 1] <= k) {
                swap(v[i], v[i + 1]);
                if (!mp[v]) {
                    q.pb(v);
                    mp[v] = 1;
                }
                swap(v[i], v[i + 1]);
            }
        }
    }
    return ans;
}

struct SegTree {
    vector<pair<int,int>> t_min, t_max;
    vector<int> arr, t_sum;
    void build(int v, int l, int r) {
        if (l == r) {
            t_min[v] = t_max[v] = {arr[l], l};
            t_sum[v] = 1;
            return;
        }
        int m = (l + r) / 2;
        build(2 * v, l, m), build(2 * v + 1, m + 1, r);
        t_min[v] = min(t_min[v * 2], t_min[v * 2 + 1]);
        t_max[v] = max(t_max[v * 2], t_max[v * 2 + 1]);
        t_sum[v] = t_sum[v * 2] + t_sum[v * 2 + 1];
    }
    void upd(int n, vector<int> a) {
        t_min.resize(4 * n);
        t_max.resize(4 * n);
        t_sum.resize(4 * n);
        arr = a;
        build(1, 0, n - 1);
    }
    void update(int v, int l, int r, int pos) {
        if (l == r) {
            t_min[v] = {INF, INF};
            t_max[v] = {-INF, -INF};
            t_sum[v] = 0;
            return;
        }
        int m = (l + r) / 2;
        if (pos <= m) {
            update(2 * v, l, m, pos);
        } else {
            update(2 * v + 1, m + 1, r, pos);
        }
        t_min[v] = min(t_min[v * 2], t_min[v * 2 + 1]);
        t_max[v] = max(t_max[v * 2], t_max[v * 2 + 1]);
        t_sum[v] = t_sum[v * 2] + t_sum[v * 2 + 1];
    }
    pair<int,int> get_max(int v, int tl, int tr, int l, int r) {
        if (l > r) {
            return {-INF, -INF};
        }
        if (tl == l && tr == r) {
            return t_max[v];
        }
        int tm = (tl + tr) / 2;
        return max(get_max(2 * v, tl, tm, l, min(r, tm)), get_max(2 * v + 1, tm + 1, tr, max(l, tm + 1), r));
    }
    pair<int,int> get_min(int v, int tl, int tr, int l, int r) {
        if (l > r) {
            return {INF, INF};
        }
        if (tl == l && tr == r) {
            return t_min[v];
        }
        int tm = (tl + tr) / 2;
        return min(get_min(2 * v, tl, tm, l, min(r, tm)), get_min(2 * v + 1, tm + 1, tr, max(l, tm + 1), r));
    }
    int get(int v, int tl, int tr, int l, int r) {
        if (l > r) return 0;
        if (tl == l && tr == r) {
            return t_sum[v];
        }
        int tm = (tl + tr) / 2;
        return get(2 * v, tl, tm, l, min(r, tm)) + get(2 * v + 1, tm + 1, tr, max(l, tm + 1), r);
    }
} t;

int solve2(int n, int k, int l, int r) {
    pair<int,int> p = t.get_max(1, 0, n - 1, l, r);
    if (p.first == -INF) {
        return 1;
    }
    int m = p.second;
    t.update(1, 0, n - 1, m);
    if (t.get_max(1, 0, n - 1, l, r).first == -INF) {
        return 1;
    }
    map<int,int> cnt;
    int any = 0;
    while (1) {
        auto pp = t.get_min(1, 0, n - 1, l, m - 1);
        if (p.first + pp.first > k) break;
        cnt[pp.first]++;
        any++;
        t.update(1, 0, n - 1, pp.second);
    }
    while (1) {
        auto pp = t.get_min(1, 0, n - 1, m + 1, r);
        if (p.first + pp.first > k) break;
        cnt[pp.first]++;
        any++;
        t.update(1, 0, n - 1, pp.second);
    }
    int sz = t.get(1, 0, n - 1, l, r) + 2;
    int res = f[any];
    for (auto to : cnt) {
        res = mul(res, inv_f[to.second]);
    }
    int res1 = solve2(n, k, l, m - 1), res2 = solve2(n, k, m + 1, r);
    res = mul(res, cnk(sz + any - 1, any));
    return mul(mul(res1, res2), res);
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    pre_calc();
    while (0) {
        int n = rnd() % 5 + 1;
        int k = rnd() % (2 * n + 2);
        vector<int> a(n);
        iota(a.begin(), a.end(), 0);
        random_shuffle(a.begin(), a.end());
        auto res = solve(n, k, a), res2 = solve2(n, k, 0, n - 1);
        if (res != res2) {
            cout << n << ' ' << k << endl;
            for (auto to : a) {
                cout << to << ' ';
            }
            cout << endl;
            return 0;
        }
        cout << "ok" << endl;
    }
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    t.upd(n, a);
    cout << solve2(n, k, 0, n - 1) << endl;
    return 0;
}
