#include<bits/stdc++.h>
#ifndef LOCAL
    #include "ones.h"
#endif // LOCAL

using namespace std;

mt19937 rnd(51);

#ifdef LOCAL

static int _n;
static std::vector<bool> _a;
static long long num_queries;

static int longest_seq_of_1s(){
    int ans = 0, curr = 0;
    for(int i = 0; i < _n; ++i){
        if(_a[i]){
            ++curr;
        }
        else{
            curr = 0;
        }
        ans = std::max(ans, curr);
    }
    return ans;
}

int flip_bits(const std::vector<bool> &flips){
    assert((int)flips.size() == _n);
    ++num_queries;
    /*cout << "FLIPS" << endl;
    for (auto to : flips) {
        cout << to << " ";
    }
    cout << endl;*/
    for(int i = 0; i < _n; ++i)
        _a[i] = flips[i] ^ _a[i];
    /*cout << "NEW_A" << endl;
    for (int i = 0; i < _n; i++) {
        cout << _a[i] << " ";
    }
    cout << endl;*/
    return longest_seq_of_1s();
}

#endif

std::pair<int, int> find_longest_subarray_of_ones(int n) {
    vector<bool> flips(n);
    int last;
    while (1) {
        for (int i = 0; i < n; i++) {
            flips[i] = rnd() % 2;
        }
        last = flip_bits(flips);
        if (last < 10) break;
    }
    fill(flips.begin(), flips.end(), 0);
    if (last == n) {
        return {0, n - 1};
    } else if (last == 0) {
        fill(flips.begin(), flips.end(), 0);
        flips[0] = 1;
        flip_bits(flips);
        return {0, 0};
    }
    pair<int,int> seg{0, n - 1};
    while (1) {
        //cout << "pos " << pos << endl;
        if (seg.second - seg.first <= 200) {
            last = flip_bits(flips);
            fill(flips.begin(), flips.end(), 0);
            for (int pos = seg.first; pos <= seg.second; pos++) {
                flips[pos] = 1;
                int nw = flip_bits(flips);
                if (nw == n) {
                    return {0, n - 1};
                } else if (nw == 0) {
                    fill(flips.begin(), flips.end(), 0);
                    flips[0] = 1;
                    flip_bits(flips);
                    return {0, 0};
                }
                flips[pos] = 0;
                if (nw > last) {
                    int mx = pos;
                    for (int i = pos + 1; i < n; i++) {
                        flips[i] = 1;
                        if (i - 1 > pos) {
                            flips[i - 1] = 1;
                        }
                        int val = flip_bits(flips);
                        if (val > nw) {
                            fill(flips.begin(), flips.end(), 0);
                            flips[i] = 1;
                            flip_bits(flips);
                            break;
                        }
                        mx = i;
                        if (i == n - 1) {
                            fill(flips.begin(), flips.end(), 0);
                            flips.back() = 1;
                            flip_bits(flips);
                        }
                        flips[i] = flips[i - 1] = 0;
                    }
                    return {mx - nw + 1, mx};
                }
                last = nw;
            }
        } else {
            int m = (seg.first + seg.second) / 2 + (int)(rnd() % 30) - 15;
            int nw = -1;
            if (rnd() % 2) {
                fill(flips.begin(), flips.end(), 0);
                for (int j = seg.first; j <= m; j++) {
                    flips[j] = 1;
                }
                nw = flip_bits(flips);
                if (nw != last) {
                    seg.second = m;
                }
            } else {
                fill(flips.begin(), flips.end(), 0);
                for (int j = m; j <= seg.second; j++) {
                    flips[j] = 1;
                }
                nw = flip_bits(flips);
                if (nw != last) {
                    seg.first = m;
                }
            }
            last = nw;
        }
    }
}

#ifdef LOCAL

int main(){
    int t;
    std::cin >> t;

    long long max_qs = 0;

    while(1){
        num_queries = 0;
        _n = rnd() % 10000 + 1;
        _a.resize(_n);
        vector<bool> beg;
        for(int i = 0; i < _n; ++i){
            _a[i] = rnd() % 2;
        }
        num_queries = 0;
        auto p = find_longest_subarray_of_ones(_n);
        int l = p.first, r = p.second;
        if(longest_seq_of_1s() != r - l + 1){
            std::cout << "0\n";
            return 0;
        }
        if(l == 0 && r == -1){
            max_qs = std::max(num_queries, max_qs);
            continue;
        }
        if(r < l || l < 0 || l >= _n || r < 0 || r >= _n){
            std::cout << "0\n";
            return 0;
        }
        for(int i = l; i <= r; ++i){
            if(_a[i] != 1){
                std::cout << "0\n";
                return 0;
            }
        }

        max_qs = std::max(num_queries, max_qs);
        cout << max_qs << endl;
    }

    std::cout << "1 " << max_qs << "\n";
    return 0;
}

#endif
