#include <iostream>
#include <vector>
#include <map>

using namespace std;
#define int long long

const int MOD = 1e9 + 7;

vector<int> tree;
vector<int> a;

void build(int v = 1, int l = 0, int r = (int) tree.size() / 4) {
    if (l + 1 == r) {
        tree[v] = a[l];
        return;
    }
    int mid = (l + r) >> 1;
    build(v + v, l, mid);
    build(v + v + 1, mid, r);
    tree[v] = max(tree[v + v], tree[v + v + 1]);
}

int getleft(int tr, int x, int v = 1, int l = 0, int r = (int) tree.size() / 4) {
    if (tree[v] < x)
        return -1;
    if (l >= tr)
        return -1;
    if (l + 1 == r)
        return l;
    int mid = (l + r) >> 1;
    int ans = getleft(tr, x, v + v + 1, mid, r);
    if (ans != -1)
        return ans;
    return getleft(tr, x, v + v, l, mid);
}

int getright(int tl, int x, int v = 1, int l = 0, int r = (int) tree.size() / 4) {
    if (tree[v] < x)
        return -1;
    if (r <= tl)
        return -1;
    if (l + 1 == r)
        return l;
    int mid = (l + r) >> 1;
    int ans = getright(tl, x, v + v, l, mid);
    if (ans != -1)
        return ans;
    return getright(tl, x, v + v + 1, mid, r);
}

vector<int> sum;

void upd(int x, int v = 1, int l = 0, int r = (int) sum.size() / 4) {
    if (l > x || r <= x)
        return;
    sum[v]++;
    if (l + 1 == r)
        return;
    int mid = (l + r) >> 1;
    upd(x, v + v, l, mid);
    upd(x, v + v + 1, mid, r);
}

int get_sum(int tl, int tr, int v = 1, int l = 0, int r = (int) sum.size() / 4) {
    if(tl <= l && r <= tr)
        return sum[v];
    if(r <= tl || tr <= l)
        return 0;
    int mid = (l + r) >> 1;
    return get_sum(tl, tr, v + v, l, mid) + get_sum(tl, tr, v + v + 1, mid, r);
}

inline void solve() {
    int n, k;
    cin >> n >> k;
    a.resize(n + 2);
    a[0] = k + 1;
    a.back() = k + 1;
    vector<bool> bad(n + 2, false);
    bad[0] = 1;
    bad.back() = 1;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        if (a[i] > k / 2)
            bad[i] = 1;
    }
    tree.resize(4 * n + 8);
    build();
    vector<vector<int> > help;
    for (int i = 1; i <= n; ++i) {
        if (bad[i])
            continue;
        int x = getleft(i, k - a[i] + 1);
        int y = getright(i + 1, k - a[i] + 1);
        help.push_back({x, y, i});
    }
    sum.resize(4 * n + 8);
    int ans = 1;
    for (int i = 0; i < n + 2; ++i) {
        if(bad[i])
            upd(i);
    }
    for(auto u : help){
        int x = u[0], y = u[1], i = u[2];
        ans *= get_sum(x, y);
        ans %= MOD;
        upd(i);
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}