#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <set>
using namespace std;
using ll = long long;

const ll MOD = 1000000007;

struct elm {
    int l = -1;
    int r = -1;
    int vl = -1;

    elm() {}

    elm(int l_, int r_, int vl_): l(l_), r(r_), vl(vl_) {}

    bool operator<(const elm e) const {
        return r - l < e.r - e.l;
    }
};

ll pw(ll a, ll m) {
    if (!m)
        return 1;
    a %= MOD;
    if (m % 2)
        return a * pw(a, m - 1) % MOD;
    return pw(a * a, m / 2);
}

signed main() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> is;
    for (int i = 0; i < n; ++i) {
        if (a[i] * 2 > k)
            is.push_back(i);
    }
    vector<elm> a0(n);
    deque<pair<int, int>> is0;
    is0.push_front({k + 1, -1});
    int j = -1;
    for (int i = 0; i < n; ++i) {
        if (a[i] * 2 > k) {
            ++j;
            while (is0.size() && is0.front().first <= a[j])
                is0.pop_front();
            is0.push_front({a[i], j});
            continue;
        }
        int l = upper_bound(is0.begin(), is0.end(), pair<int, int>{k - a[i], n})->second;
        int r = j;
        while (r + 1 < is.size() && a[i] + a[is[r + 1]] <= k)
            ++r;
        a0[i] = {l + 1, r + 1, a[i]};
    }
    for (int i = 0; i < a0.size(); ++i) {
        if (a0[i].l == -1) {
            swap(a0[i], a0.back());
            a0.pop_back();
            --i;
        }
    }

    vector<vector<int>> els(is.size() + 1);
    sort(a0.begin(), a0.end());
    ll ans = 1;
    for (auto [l, r, vl] : a0) {
        ll vars = r - l + 1;
        ll cntsim = 1;
        for (int i = l; i <= r; ++i) {
            vars += els[i].size();
            for (auto vl0 : els[i]) {
                cntsim += vl0 == vl;
            }
        }
        ans *= vars;
        ans %= MOD;
        ans *= pw(cntsim, MOD - 2);
        ans %= MOD;
        els[l].push_back(vl);
    }
    cout << ans << '\n';

}
