#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
#include <deque>
#include <algorithm>
#include <set>
using namespace std;

using ll = long long;
const ll MOD = 1000000007;

struct elm {
    int l;
    int r;
    int vl;
    elm() {}
    elm(int l_, int r_, int vl_): l(l_), r(r_), vl(vl_) {}
    bool operator<(const elm e) const {
        return r - l < e.r - e.l;
    }
};

ll pw(ll a, ll m) {
    if (!m)
        return 1;
    a %= MOD;
    if (m % 2)
        return a * pw(a, m - 1) % MOD;
    return pw(a * a, m / 2);
}

struct bitr {
    void resize(int n) {
        t.resize(n);
        sz = n;
    }

    void add(int i, int x) {
        while (i < sz) {
            t[i] += x;
            i |= i + 1;
        }
    }

    int get(int i) {
        int ans = 0;
        while (i >= 0) {
            ans += t[i];
            i &= i + 1;
            --i;
        }
        return ans;
    }
 private:
     int sz;
     vector<int> t;
};

struct bitr0 {
    void resize(int n) {
        t.resize(n);
        sz = n;
    }

    void add(int i, int x) {
        while (i < sz) {
            ++t[i][x];
            i |= i + 1;
        }
    }

    int get(int i, int x) {
        int ans = 0;
        while (i >= 0) {
            ans += t[i][x];
            i &= i + 1;
            --i;
        }
        return ans;
    }
 private:
     int sz;
     vector<unordered_map<int, int>> t;
};


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> is;
    for (int i = 0; i < n; ++i) {
        if (a[i] * 2 > k)
            is.push_back(i);
    }
    vector<elm> a0;
    vector<int> ra0(n);
    deque<pair<int, int>> dq;
    dq.push_front({k + 12345, -1});
    int j = -1;
    for (int i = 0; i < n; ++i) {
        if (a[i] * 2 > k) {
            ++j;
            while (dq.size() && dq.front().first <= a[i])
                dq.pop_front();
            dq.push_front({a[i], j});
            continue;
        }
        int l = upper_bound(dq.begin(), dq.end(), pair<int, int>(k - a[i], n + 177013))->second;
        ra0[i] = a0.size();
        a0.push_back({l + 1, -1, a[i]});
    }
    dq.clear();
    dq.push_back({k + 12345, j + 1});
    for (int i = n - 1; i >= 0; --i) {
        if (a[i] * 2 > k) {
            while (dq.size() && dq.front().first <= a[i])
                dq.pop_front();
            dq.push_front({a[i], j});
            --j;
            continue;
        }
        int r = upper_bound(dq.begin(), dq.end(), pair<int, int>(k - a[i], n + 177013))->second;
        a0[ra0[i]].r = r;
    }
    bitr tr;
    bitr0 tr0;
    tr.resize(is.size() + 1);
    tr0.resize(is.size() + 1);

    sort(a0.begin(), a0.end());

    ll ans = 1;
    for (auto [l, r, vl] : a0) {
        ll vars = r - l + 1 + tr.get(r) - tr.get(l - 1);
        ll cntsim = 1;
        ans *= vars;
        ans %= MOD;
        ans *= pw(cntsim, MOD - 2);
        ans %= MOD;
        tr.add(l, 1);
        tr0.add(l, vl);
    }
    cout << ans << '\n';
}

