#include <bits/stdc++.h>

using namespace std;

const int maxn = 3e5 + 5, mod = 1e9 + 7;

const int R = 1 << 19;

vector<pair<int, int>> vals[R * 2];

void build() {
    for (int i = R - 1; i > 0; --i) {
        vals[i].resize(vals[i * 2].size() + vals[i * 2 + 1].size());
        merge(vals[i * 2].begin(), vals[i * 2].end(), vals[i * 2 + 1].begin(), vals[i * 2 + 1].end(), vals[i].begin());
    }
}

int get_cnt(int l, int r, pair<int, int> lx, pair<int, int> rx) {
    l += R;
    r += R;
    int ans = 0;
    while (l < r) {
        if (l & 1) {
            ans += lower_bound(vals[l].begin(), vals[l].end(), rx) - lower_bound(vals[l].begin(), vals[l].end(), lx);
            l++;
        }
        if (r & 1) {
            --r;
            ans += lower_bound(vals[r].begin(), vals[r].end(), rx) - lower_bound(vals[r].begin(), vals[r].end(), lx);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

pair<int, int> get_mx(int l, int r) {
    l += R;
    r += R;
    pair<int, int> ans = {0, 0};
    while (l < r) {
        if (l & 1) {
            if (!vals[l].empty()) {
                ans = max(ans, vals[l].back());
            }
            l++;
        }
        if (r & 1) {
            --r;
            if (!vals[r].empty()) {
                ans = max(ans, vals[r].back());
            }
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

map<int, int> get_cnts(int l, int r, pair<int, int> l_val, pair<int, int> r_val) {
    l += R;
    r += R;
    map<int, int> cnt;
    while (l < r) {
        if (l & 1) {
            int pos = lower_bound(vals[l].begin(), vals[l].end(), l_val) - vals[l].begin();
            while (pos < (int) vals[l].size() && vals[l][pos] < r_val) {
                cnt[vals[l][pos].first]++;
                pos++;
            }
            l++;
        }
        if (r & 1) {
            --r;
            int pos = lower_bound(vals[r].begin(), vals[r].end(), l_val) - vals[r].begin();
            while (pos < (int) vals[r].size() && vals[r][pos] < r_val) {
                cnt[vals[r][pos].first]++;
                pos++;
            }
        }
        l >>= 1;
        r >>= 1;
    }
    return cnt;
}

int binpow(int n, int k) {
    int ans = 1;
    while (k) {
        if (k & 1) {
            ans = ans * 1LL * n % mod;
        }
        n = n * 1LL * n % mod;
        k >>= 1;
    }
    return ans;
}

int a[maxn];

int f[maxn], _f[maxn];

int get_ans(int l, int r, int k, int l_val) {
    if (r <= l + 1) {
        return 1;
    }
    auto p = get_mx(l, r);
    if (p.first < l_val) {
        return 1;
    }
    if (p.first + p.first <= k) {
        map<int, int> cnt = get_cnts(l, r, {l_val, 0}, {p.first + 1, 0});
        int cnt_all = 0;
        int ans = 1;
        for (auto [vl, c] : cnt) {
            ans = ans * 1LL * _f[c] % mod;
            cnt_all += c;
        }
        ans = ans * 1LL * f[cnt_all] % mod;
        return ans;
    }
    int free = 0;
    if (l_val <= k - p.first) {
        free = get_cnt(l, r, {l_val, 0}, {k - p.first + 1, 0});
    }
    int used = get_cnt(l, r, {l_val, 0}, {p.first + 1, 0}) - free;
    int ans = get_ans(l, p.second, k, max(l_val, k - p.first + 1)) * 1LL * get_ans(p.second + 1, r, k, max(l_val, k - p.first + 1)) % mod;
    ans = ans * 1LL * f[used + free] % mod * _f[used] % mod;
    map<int, int> cnt = get_cnts(l, r, {l_val, 0}, {k - p.first + 1, 0});
    for (auto [vl, c] : cnt) {
        ans = ans * 1LL * _f[c] % mod;
    }
    return ans;
}

void solve() {
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    f[0] = _f[0] = 1;
    for (int i = 1; i < maxn; ++i) {
        f[i] = f[i - 1] * 1LL * i % mod;
        _f[i] = binpow(f[i], mod - 2);
    }
    for (int i = 0; i < n; ++i) {
        vals[i + R] = {make_pair(a[i], i)};
    }
    build();
    cout << get_ans(0, n, k, 0) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
