#include <iostream>
#include <vector>
#include <random>
#include <chrono>
//#include "ones.h"
#include <algorithm>

#define int long long
#define all(a) a.begin(), a.end()

using namespace std;

mt19937 rnd(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());

typedef vector<int> vi;
typedef vector<bool> vb;
typedef pair<int, int> pi;
typedef vector<pi> vpi;

template<typename T> void input(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}

int gcd(int a, int b) {
	if (!b)
		return a;
	return gcd(b, a % b);
}

const int MOD = 1e9 + 7, K = 1e5;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int p, q, n;
	cin >> p >> q >> n;
	int ans = 0;
	for (int i = 2; i * i / 4 <= max(p, q); ++i) {
		if (i * i <= K) {
			for (int a = 1; a <= i - 1; ++a) {
				int b = i - a;
				if(gcd(a, b) != 1)
					continue;
				int x = min({ n / (a * b), p / (a * a + a * b), q / (b * b + a * b) });
				ans += x;
			}
		}
		else {
			for (int j = i * i; j <= 3e8; j += i * i) {
				int x = j / (i * i);
				if (i * x > n)
					continue;
				int maxa = min(p / (i * x), i - 1), maxb = min(q / (i * x), i - 1);
				int mina = i - maxb;
				ans += max(maxa - mina + 1, 0ll);
			}
		}
	}
	cout << ans;
	return 0;
}