#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

constexpr int MOD = 1000000007;

ll binpow(int n, int k) {
    if (k == 0) return 1;
    if (k % 2 == 0) {
        ll t = binpow(n, k / 2);
        return t * t % MOD;
    }
    return n * binpow(n, k - 1) % MOD;
}

ll invert(int n) {
    return binpow(n, MOD - 2);
}
vector<ll> fact;

ll cnk(int n, int k) {
    return fact[n] * invert(fact[k]) % MOD * invert(fact[n - k]) % MOD;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    fact.resize(300005, 1);
    for (int i = 1; i <= 300000; ++i) {
        fact[i] = (fact[i - 1] * i) % MOD;
    }

    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<int>> graph(n);
    vector<int> in(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (a[i] == a[j] || a[i] + a[j] > k) {
                graph[i].push_back(j);
                cerr << i << j << ' ';
                ++in[j];
            }
        }
    }
    ll ans = 0;
    vector<int> g(n);
    iota(g.begin(), g.end(), 0);
    do {
        bool ok = true;
        for (int i = 0; ok && i < n; ++i) {
            for (int ch : graph[i]) {
                if (g[i] > g[ch]) {
                    ok = false;
                    break;
                }
            }
        }
        if (ok) ++ans;
    } while (std::next_permutation(g.begin(), g.end()));
    cout << ans;
    return 0;
}