#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
//#include <unordered_set>
#include <deque>
#include <bitset>
#include <iomanip>
#include <queue>
#include <cmath>
#include <ctime>
#include <numeric>
#include <string>

using namespace std;

typedef long long ll;
//typedef __int128_t ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
//#define break_(x) {x; return;}
const ll MOD = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-9;
//const ll MOD2 = 998244353;
ld pi = asin(0.5) * (ld)6;

int n, k;
vector<int> a;
vector<pair<int, int>> tree;

void build(int i, int l, int r) {
    if (l + 1 == r) {
        tree[i] = { a[l], l };
        return;
    }
    int mid = (l + r) / 2;
    build(2 * i + 1, l, mid);
    build(2 * i + 2, mid, r);
    tree[i] = max(tree[2 * i + 1], tree[2 * i + 2]);
}

pair<int, int> get_max(int i, int l, int r, int lq, int rq) {
    if (rq <= l || r <= lq) {
        return { 0, 0 };
    }
    if (lq <= l && r <= rq) {
        return tree[i];
    }
    int mid = (l + r) / 2;
    return max(get_max(2 * i + 1, l, mid, lq, rq), get_max(2 * i + 2, mid, r, lq, rq));
}

int cnt_sm(int l, int r, int st) {
    int ans = 0;
    for (int i = l; i <= r; ++i) {
        if (a[i] <= st) {
            ++ans;
        }
    }
    return ans;
}

int solve(int l, int r, int st) {
    if (r < l) {
        return 1;
    }
    int bg = get_max(0, 0, n, l, r + 1).second;
    if (a[bg] <= st) {
        return 1;
    }
    ll ans = 1;
    int cnt1 = cnt_sm(l, r, st);
    int cnt2 = cnt_sm(l, r, k - a[bg]) - cnt1;
    int sz = r - l + 1 - cnt_sm(l, r, st);
    for (int i = 0; i < cnt2; ++i) {
        ans = ans * (ll)(sz - i) % MOD;
    }
    return ans * solve(l, bg - 1, k - a[bg]) % MOD * solve(bg + 1, r, k - a[bg]) % MOD;
}

inline void solve(void) {
    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    tree.resize(4 * n);
    build(0, 0, n);
    cout << solve(0, n - 1, -MOD);
}

int main(void) {
    //freopen("censored.in", "r", stdin);
    //freopen("censored.out", "w", stdout);
    cout << fixed << setprecision(20);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; srand(time(0)); //cin >> t;
    while (t--) solve();
    return 0;
}