#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
//#include <unordered_set>
#include <deque>
#include <bitset>
#include <iomanip>
#include <queue>
#include <cmath>
#include <ctime>
#include <numeric>
#include <string>

using namespace std;

typedef long long ll;
//typedef __int128_t ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
//#define break_(x) {x; return;}
const ll MOD = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-9;
//const ll MOD2 = 998244353;
ld pi = asin(0.5) * (ld)6;

int n, k;
vector<int> a;
vector<pair<int, int>> tree;
vector<int> tree2;
vector<int> tree3;

void build(int i, int l, int r) {
    if (l + 1 == r) {
        tree[i] = { a[l], l };
        tree2[i] = a[l];
        return;
    }
    int mid = (l + r) / 2;
    build(2 * i + 1, l, mid);
    build(2 * i + 2, mid, r);
    tree[i] = max(tree[2 * i + 1], tree[2 * i + 2]);
    tree2[i] = min(tree2[2 * i + 1], tree2[2 * i + 2]);
}

pair<int, int> get_max(int i, int l, int r, int lq, int rq) {
    if (rq <= l || r <= lq) {
        return { 0, 0 };
    }
    if (lq <= l && r <= rq) {
        return tree[i];
    }
    int mid = (l + r) / 2;
    return max(get_max(2 * i + 1, l, mid, lq, rq), get_max(2 * i + 2, mid, r, lq, rq));
}

int gtnxtsm(int i, int l, int r, int lq, int st) {
    if (r <= lq || tree2[i] > st) {
        return -1;
    }
    if (l + 1 == r) {
        return l;
    }
    int mid = (l + r) / 2;
    int ansl = gtnxtsm(2 * i + 1, l, mid, lq, st);
    if (ansl == -1) {
        return gtnxtsm(2 * i + 2, mid, r, lq, st);
    }
}

void ST(int i, int l, int r, int q, int val) {
    if (l + 1 == r) {
        tree2[i] = val;
        tree3[i] = 1;
        return;
    }
    int mid = (l + r) / 2;
    if (mid <= q) {
        ST(2 * i + 2, mid, r, q, val);
    } else {
        ST(2 * i + 1, l, mid, q, val);
    }
    tree2[i] = min(tree2[2 * i + 1], tree2[2 * i + 2]);
    tree3[i] = tree3[2 * i + 1] + tree3[2 * i + 2];
}

int cnt(int i, int l, int r, int lq, int rq) {
    if (rq <= l || r <= lq) {
        return 0;
    }
    if (lq <= l && r <= rq) {
        return tree3[i];
    }
    int mid = (l + r) / 2;
    return cnt(2 * i + 1, l, mid, lq, rq) + cnt(2 * i + 2, mid, r, lq, rq);
}

ll binpow(ll a, ll b) {
    if (b == 0) {
        return 1;
    }
    ll ans = binpow(a, b / 2);
    ans = ans * ans % MOD;
    if (b % 2) {
        ans = ans * a % MOD;
    }
    return ans;
}

int solve(int l, int r, int st) {
    if (r < l) {
        return 1;
    }
    int bg = get_max(0, 0, n, l, r + 1).second;
    if (a[bg] <= st) {
        return 1;
    }
    ll ans = 1;
    //map<int, int> mp;
    int lst = l;
    int cnt2 = 0;
    int stnew = k - a[bg];
    while (true) {
        int ind = gtnxtsm(0, 0, n, lst, stnew);
        if (ind == -1 || ind > r) {
            break;
        }
        //++mp[a[ind]];
        ST(0, 0, n, ind, MOD);
        lst = ind + 1;
        ++cnt2;
    }
    int sz = r - l + 1 - cnt(0, 0, n, l, r + 1) + cnt2;
    for (int i = 0; i < cnt2; ++i) {
        ans = ans * (ll)(sz - i) % MOD;
    }
    //for (auto p : mp) {
    //    for (int i = 1; i <= p.second; ++i) {
    //        ans = ans * binpow(i, MOD - 2) % MOD;
    //    }
    //}
    return ans * solve(l, bg - 1, stnew) % MOD * solve(bg + 1, r, stnew) % MOD;
}

inline void solve(void) {
    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    tree.resize(4 * n);
    tree2.resize(4 * n);
    tree3.resize(4 * n, 0);
    build(0, 0, n);
    cout << solve(0, n - 1, -MOD);
}

int main(void) {
    //freopen("censored.in", "r", stdin);
    //freopen("censored.out", "w", stdout);
    cout << fixed << setprecision(20);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; srand(time(0)); //cin >> t;
    while (t--) solve();
    return 0;
}
