#include <bits/stdc++.h>

int flip_bits(const std::vector<bool> &flips);

std::pair<int, int> find_longest_subarray_of_ones(int n);

#define vc vector

#define nd node*
#define pnd pair<nd, nd>

using namespace std;
typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vc<pll> vpll;
typedef vc<vll> vvll;
typedef vc<vpll> vvpll;

template<const ll MOD>
struct mod_mul : std::multiplies<const ll> {
    ll operator()(const ll a, const ll b) {
        return (a * b) % MOD;
    }
};


template<typename T>
inline void sort(T &a) {
    sort(a.begin(), a.end());
}

template<typename T>
inline void unique(T &a) {
    a.resize(unique(a.begin(), a.end()) - a.begin());
}

template<typename T>
inline void reverse(T &a) {
    reverse(a.begin(), a.end());
}

const ll INF = 9023372036854775808ll;
const ll MOD = 1000000007ll;

const int L = 20;
mt19937 rnd(313);

pair<int, int> find_ans(int i, int n) {
    vc<bool> flip(n), r(n);
    int was = flip_bits(flip);
    pair<int, int> ans = {0, n - 1};
    for (int j = i - 1; j >= 0; --j) {
        for (int x = 0; x < n; ++x) r[x] = flip[x] ^ (x == j), flip[x] = x == j;
        int e = flip_bits(r);
        assert(e != was);
        if (e > was) {
            ans.first = j + 1;
            assert(was == flip_bits(flip));
            break;
        }
    }
    for (int x = 0; x < n; ++x) flip[x] = false;
    for (int x = 0; x < n; ++x) r[x] = false;
    for (int j = i + 1; j < n; ++j) {
        for (int x = 0; x < n; ++x) r[x] = flip[x] ^ (x == j), flip[x] = x == j;
        int e = flip_bits(r);
        assert(e != was);
        if (e > was) {
            ans.second = j - 1;
            assert(was == flip_bits(flip));
            break;
        }
    }
    return ans;
}

pair<int, int> find_longest_subarray_of_ones(int n) {
//    cout << "yoo\n";
    vc<bool> flip(n);
    int c = 10000, f;
    int d = 0;
    do {
        ++d;
        for (int i = 0; i < n; ++i) flip[i] = rnd() & 1;
        c = flip_bits(flip);
        if (c <= L) {
            for (int i = 0; i < n; ++i) flip[i] = true;
            f = flip_bits(flip);
            c = flip_bits(flip);
        }
    } while (c > L || f >= c);
    if (c == n) return {0, n - 1};
    int l = 0, r = n;
    vc<bool> q(n);
    for (int i = 0; i < n; ++i) flip[i] = false;
    for (int i = 0; i < n; ++i) q[i] = false;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        for (int j = 0; j < n; ++j) q[j] = (j <= mid) ^ flip[j], flip[j] = j <= mid;
        int nw = flip_bits(q);
        if (nw > c) return find_ans(mid, n);
        if (nw == c) l = mid;
        else r = mid;
    }
    for (int i = 0; i < n; ++i) flip[i] = i == r;
    flip_bits(flip);
    return find_ans(r + 1, n);
}

#ifdef _GLIBCXX_DEBUG
static int _n;
static std::vector<bool> _a;
static long long num_queries;

static int longest_seq_of_1s() {
    int ans = 0, curr = 0;
    for (int i = 0; i < _n; ++i) {
        if (_a[i]) {
            ++curr;
        } else {
            curr = 0;
        }
        ans = std::max(ans, curr);
    }
    return ans;
}

int flip_bits(const std::vector<bool> &flips) {
    assert((int) flips.size() == _n);
    ++num_queries;
    for (int i = 0; i < _n; ++i)
        _a[i] = flips[i] ^ _a[i];
    return longest_seq_of_1s();
}

std::pair<int, int> find_longest_subarray_of_ones(int n);

mt19937 Q(chrono::system_clock::now().time_since_epoch().count());

int main() {
    int t;
    std::cin >> t;

    long long max_qs = 0;

    while (t--) {
        num_queries = 0;

        _n = 1e4;
        _a.resize(_n);
        for (int i = 0; i < _n; ++i) {
            bool val = Q() & 1;
//            std::cin >> val;
            _a[i] = val;
        }

        auto [l, r] = find_longest_subarray_of_ones(_n);
        if (longest_seq_of_1s() != r - l + 1) {
            std::cout << "0\n";
            return 0;
        }
        if (l == 0 && r == -1) {
            max_qs = std::max(num_queries, max_qs);
            continue;
        }
        if (r < l || l < 0 || l >= _n || r < 0 || r >= _n) {
            std::cout << "0\n";
            return 0;
        }

        for (int i = l; i <= r; ++i) {
            if (_a[i] != 1) {
                std::cout << "0\n";
                return 0;
            }
        }

        max_qs = std::max(num_queries, max_qs);
    }

    std::cout << "1 " << max_qs << "\n";
    return 0;
}

#endif
