#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <random>

#define int long long
#define pii pair<int,int>
#define fi first
#define se second
#define p_b push_back
#define m_p make_pair
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define sz(x) (int)x.size()
#define pw(x) (1LL<<(x))
#define sqr(x) ((x)*(x))

using namespace std;

const int INF = 1e9 + 7;
int n, k, a[300005];
int f[300005], _f[300005];
struct node
{
    int cnt;
    int ma;
    int pos_ma;
    int mi;
    int pos_mi;
    node(): cnt(0), ma(-INF), pos_ma(-1), mi(INF), pos_mi(-1) {};
    node(int i): cnt(1), ma(a[i]), pos_ma(i), mi(a[i]), pos_mi(i) {};
    node(node l, node r)
    {
        cnt = l.cnt + r.cnt;
        if(l.ma > r.ma)
        {
            ma = l.ma;
            pos_ma = l.pos_ma;
        }
        else
        {
            ma = r.ma;
            pos_ma = r.pos_ma;
        }
        if(l.mi < r.mi)
        {
            mi = l.mi;
            pos_mi = l.pos_mi;
        }
        else
        {
            mi = r.mi;
            pos_mi = r.pos_mi;
        }
    }
};
node t[1200005];

void build(int v, int tl, int tr)
{
    if(tl == tr)
    {
        t[v] = node(tl);
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm + 1, tr);
    t[v] = node(t[v * 2], t[v * 2 + 1]);
}

void rem(int v, int tl, int tr, int pos)
{
    if(pos < tl || pos > tr)
        return;
    if(tl == tr)
    {
        t[v] = node();
        return;
    }
    int tm = (tl + tr) / 2;
    rem(v * 2, tl, tm, pos);
    rem(v * 2 + 1, tm + 1, tr, pos);
    t[v] = node(t[v * 2], t[v * 2 + 1]);
}

node get(int v, int tl, int tr, int l, int r)
{
    if(l > r)
        return node();
    if(l == tl && r == tr)
        return t[v];
    int tm = (tl + tr) / 2;
    return node(get(v * 2, tl, tm, l, min(r, tm)), get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

int fast_pow(int a, int b)
{
    if(!b)
        return 1;
    if(b % 2)
        return (fast_pow(a, b - 1) * a) % INF;
    int x = fast_pow(a, b / 2);
    return sqr(x) % INF;
}

int C(int n, int k)
{
    return (((f[n] * _f[k]) % INF) * _f[n - k]) % INF;
}

int solve(int l, int r)
{
    node q = get(1, 0, n - 1, l, r);
    if(!q.cnt)
        return 1;
    int m = q.pos_ma;
    int sz = q.cnt;
    vector < pii > p;
    p.p_b({0, 0});
    while(true)
    {
        q = get(1, 0, n - 1, l, r);
        if(q.pos_mi == q.pos_ma || q.mi + q.ma > k)
            break;
        if(p.back().fi == q.mi)
            p.back().se++;
        else
            p.p_b({q.mi, 1});
        rem(1, 0, n - 1, q.pos_mi);
    }
    int ans = (solve(l, m - 1) * solve(m + 1, r)) % INF;
    for(auto [val, cnt] : p)
    {
        ans = (ans * C(sz, cnt)) % INF;
        sz -= cnt;
    }
    return ans;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> k;
    for(int i = 0; i < n; i++)
        cin >> a[i];
    f[0] = _f[0] = 1;
    for(int i = 1; i <= n; i++)
    {
        f[i] = (f[i - 1] * i) % INF;
        _f[i] = fast_pow(f[i], INF - 2);
    }
    build(1, 0, n - 1);
    cout << solve(0, n - 1);
    return 0;
}
