#include <bits/stdc++.h>
#define f first
#define s second

using namespace std;
using pi = pair<int, int>;
using ll = long long;

const int INF = 1e9 + 3;

const ll MOD = 1e9 + 7;

ll pw(ll b, ll e) {
    ll r = 1;
    while (e) {
        if (e & 1) {
            r *= b;
            r %= MOD;
        }
        e >>= 1;
        b *= b;
        b %= MOD;
    }
    return r;
}

struct Seg {
    vector<int> seg;
    int n;
    Seg(int n) : n(n), seg(2 * n) {}
    void update(int i, int x) {
        i += n;
        seg[i] += x;
        for (i >>= 1; i; i >>= 1) {
            seg[i] = seg[i << 1] + seg[(i << 1) | 1];
        }
    }
    int query(int a, int b) {
        int res = 0;
        for (a += n, b += n; a < b; a >>= 1, b >>= 1) {
            if (a & 1) {
                res += seg[a++];
            }
            if (b & 1) {
                res += seg[--b];
            }
        }
        return res;
    }
};

struct Seg_Mx {
    vector<int> seg;
    int n;
    Seg_Mx(vector<int> ps) : n(ps.size()) {
        seg.resize(2 * n);
        for (int i = 0; i < n; i++) {
            seg[i + n] = ps[i];
        }
        for (int i = n - 1; i; i--) {
            seg[i] = max(seg[i << 1], seg[(i << 1) | 1]);
        }
    }
    void update(int i, int x) {
        i += n;
        seg[i] += x;
        for (i >>= 1; i; i >>= 1) {
            seg[i] = max(seg[i << 1], seg[(i << 1) | 1]);
        }
    }
    int query(int a, int b) {
        int res = 0;
        for (a += n, b += n; a < b; a >>= 1, b >>= 1) {
            if (a & 1) {
                res = max(res, seg[a++]);
            }
            if (b & 1) {
                res = max(res, seg[--b]);
            }
        }
        return res;
    }
};

const int mxN = 3e5 + 5;

ll fact[mxN];
ll invf[mxN];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    fact[0] = 1;
    for (ll i = 1; i < mxN; i++) {
        fact[i] = (fact[i - 1] * i) % MOD;
    }
    invf[mxN - 1] = pw(fact[mxN - 1], MOD - 2);
    for (ll i = mxN - 1; i; i--) {
        invf[i - 1] = (invf[i] * i) % MOD;
    }
    int n, k;
    cin >> n >> k;
    vector<int> ps(n);
    for (int &p : ps) {
        cin >> p;
    }
    vector<int> L(n);
    vector<int> R(n);
    {
        vector<pi> inc = {{INF, -1}};
        for (int i = 0; i < n; i++) {
            int p = ps[i];
            int l = 0, r = inc.size() - 1;

            while (l < r) {
                int mid = (l + r + 1) / 2;
                if (inc[mid].f + p <= k) {
                    r = mid - 1;
                } else {
                    l = mid;
                }
            }
            L[i] = inc[l].s;
            while (inc.back().f <= p) {
                inc.pop_back();
            }
            inc.push_back({p, i});
        }
    }
    {
        vector<pi> inc = {{INF, n}};
        for (int i = n - 1; i >= 0; i--) {
            int p = ps[i];
            int l = 0, r = inc.size() - 1;

            while (l < r) {
                int mid = (l + r + 1) / 2;
                if (inc[mid].f + p <= k) {
                    r = mid - 1;
                } else {
                    l = mid;
                }
            }
            R[i] = inc[l].s;
            while (inc.back().f <= p) {
                inc.pop_back();
            }
            inc.push_back({p, i});
        }
    }
    Seg tree(n);
    vector<pi> refs(n);
    for (int i = 0; i < n; i++) {
        // cout << i + 1 << ": " << L[i] + 2 << " " << R[i] << endl;
        refs[i] = {ps[i], i};
    }
    sort(refs.begin(), refs.end());
    ll res = 1;
    for (pi seg : refs) {
        // cout << seg.f << " - " << tree.query(seg.s, seg.s + seg.f) << endl;
        res *= ((R[seg.s] - L[seg.s] - 1) - tree.query(L[seg.s] + 1, R[seg.s]));
        tree.update(seg.s, 1);
        res %= MOD;
    }
    vector<int> nxt(n, -1);
    map<int, int> lst;
    for (int i = n - 1; i >= 0; i--) {
        int p = ps[i];
        if (lst.find(p) != lst.end()) {
            nxt[i] = lst[p];
        }
        lst[p] = i;
    }
    Seg_Mx seg_mx(ps);
    map<int, int> cnt;
    for (int i = 0; i < n; i++) {
        int p = ps[i];
        if (p * 2 > k) {
            continue;
        }
        int x = nxt[i];
        cnt[p]++;
        if (x == -1) {
            res *= invf[cnt[p]];
            res %= MOD;
            continue;
        }
        if (seg_mx.query(i, x) + ps[i] > k) {
            res *= invf[cnt[p]];
            res %= MOD;
            cnt[p] = 0;
        }
    }
    cout << res << "\n";
    return 0;
}