// cubes.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
using namespace std;
#include <vector>
#define vi vector<int>
#define ll long long
#define vll vector<ll>
#define pll pair<ll,ll>
#define pi pair<int,int>
int k;
const int siz = 3e5 + 1;
const int m = 1e9 + 7;
const int inf = 1e9 + 1;
vll fac(siz), inv(siz);
vll v(siz);
ll po(ll a, ll b) {
    if (b == 0)
        return 1;
    ll ans = po(a, b / 2);
    ans = (ans * ans) % m;
    if (b % 2) {
        ans = (ans * a) % m;
    }
    return ans;
}
struct node {
    int l, r, mid, mini, maxi, in1, in2, sum;
    node* sl = NULL;
    node* sr = NULL;
    node(int li, int ri) {
        l = li, r = ri, mid = (l + r) / 2, sum = r - l + 1;
        if (l == r) {
            mini = v[l], maxi = v[l], in1 = l, in2 = l;
        }
        else {
            sl = new node(l, mid);
            sr = new node(mid + 1, r);
            if (sl->mini <= sr->mini) {
                mini = sl->mini, in1 = sl->in1;
            }
            else {
                mini = sr->mini, in1 = sr->in1;
            }
            if (sl->maxi >= sr->maxi) {
                maxi = sl->maxi, in2 = sl->in2;
            }
            else {
                maxi = sr->maxi, in2 = sr->in2;
            }
        }
    }
    pi ask1(int a, int b) {
        if (b < l || a > r) {
            return { inf, 0 };
        }
        if (a <= l && b >= r) {
            return { mini,in1 };
        }
        pi p1 = sl->ask1(a, b), p2 = sr->ask1(a, b);
        return min(p1, p2);
    }
    pi ask2(int a, int b) {
        if (b < l || a > r) {
            return { 0, 0 };
        }
        if (a <= l && b >= r) {
            return { maxi,in2 };
        }
        pi p1 = sl->ask2(a, b), p2 = sr->ask2(a, b);
        return max(p1, p2);
    }
    int sum_q(int a, int b) {
        if (b < l || a > r) {
            return 0;
        }
        if (a <= l && b >= r) {
            return sum;
        }
        return sl->sum_q(a, b) + sr->sum_q(a, b);
    }
    void shut(int i) {
        sum--;
        if (l == r) {
            maxi = 0, mini = 1e9 + 1;
        }
        else {
            if (i <= mid) {
                sl->shut(i);
            }
            else {
                sr->shut(i);
            }
            if (sl->mini <= sr->mini) {
                mini = sl->mini, in1 = sl->in1;
            }
            else {
                mini = sr->mini, in1 = sr->in1;
            }
            if (sl->maxi >= sr->maxi) {
                maxi = sl->maxi, in2 = sl->in2;
            }
            else {
                maxi = sr->maxi, in2 = sr->in2;
            }
        }
    }
};

ll f(ll a, ll b) {
    //return number of ways to write A as a sum of B-A+1 nonegative numbers, i.e, B+1 as B-A+1 positives i.e B choose B-A = B choose A 
    ll x = (inv[a] * inv[b - a]) % m;
    return (x * fac[b]) % m;
}
ll solve(int l, int r, node seg) {
    int sum = seg.sum_q(l, r);
    if (sum == 0)
        return 1;
    pi p1 = seg.ask1(l, r), p2 = seg.ask2(l, r);
    int num = 0;
    if (p1.first + p2.first > k) {
        return (solve(l, p2.second - 1, seg) * solve(p2.second + 1, r, seg)) % m;
    }
    else {
        seg.shut(p1.second);
        int i = p1.second;
        while (v[i] == p1.first) {
            i = seg.ask1(i + 1, r).second;
            if (v[i] == p1.first)seg.shut(i);
            num++;
        }
    }
    return (f(num, sum) * solve(l, r, seg)) % m;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n >> k;
    for (int i = 1; i <= n; i++) {
        int ai;
        cin >> ai;
        v[i] = ai;
    }
    fac[0] = 1;
    for (int i = 1; i < siz; i++) {
        fac[i] = (i * fac[i - 1]) % m;
    }
    for (int i = 0; i < siz; i++) {
        inv[i] = po(fac[i], m - 2);
    }
    node seg = node(1, n);
    cout << solve(1, n, seg);
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
