#include <bits/stdc++.h>
#define x first
#define y second
#define all(v) v.begin(), v.end()
#define chkmin(a, b) a = min(a, b)
#define chkmax(a, b) a = max(a, b)
using namespace std;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vii;

const int mod = 1e9 + 7;
const int MAX_N = 1e5 + 5;

struct Seg {
    vi seg;
    int n;
    Seg(int m) {
        for (n = 1; n < m; n <<= 1);
        seg.resize(2 * n);
    }
    void update(int i, int x) {
        for (i += n; i; i >>= 1) seg[i] += x;
    }
    int query(int l, int r) {
        int ans = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) ans += seg[l++];
            if (r & 1) ans += seg[--r];
        }
        return ans;
    }
};

struct SegMax {
    vi seg;
    int n;
    SegMax(int m) {
        for (n = 1; n < m; n <<= 1);
        seg.resize(2 * n);
    }
    void update(int i, int x) {
        for (i += n; i; i >>= 1) chkmax(seg[i], x);
    }
    int query(int l, int r) {
        int ans = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) chkmax(ans, seg[l++]);
            if (r & 1) chkmax(ans, seg[--r]);
        }
        return ans;
    }
};


int n, k;

ll Solve(vi &a) {
    if (a.empty()) return 1;
    int i = min_element(all(a)) - a.begin();
    ll l, r;
    for (l = i - 1; l >= 0 && a[l] + a[i] <= k; l--);
    for (r = i + 1; r < a.size() && a[r] + a[i] <= k; r++);
    a.erase(a.begin() + i);
    return Solve(a) * (r - l - 1) % mod;
}

int a[MAX_N], ind[MAX_N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    for (int i = 0; i < n; i++) cin >> a[i];
    Seg seg(n), seg_max(n);
    for (int i = 0; i < n; i++) seg.update(i, 1), seg_max.update(i, a[i]);
    iota(ind, ind + n, 0);
    sort(ind, ind + n, [&] (int i, int j) {
        return a[i] < a[j];
    });
    ll ans = 1;
    for (int i = 0; i < n; i++) {
        int j = ind[i];
        int begin = 0, end = j, mid;
        while (begin < end) {
            mid = (begin + end) >> 1;
            if (seg_max.query(mid, j) + a[j] > k) begin = mid + 1;
            else end = mid;
        }
        ll l = end;
        begin = j + 1, end = n, mid;
        while (begin < end) {
            mid = (begin + end) >> 1;
            if (seg_max.query(j + 1, mid + 1) + a[j] > k) {
                end = mid;
            } else begin = mid + 1;
        }
        ll r = end - 1;
        ans *= seg.query(l, r + 1);
        ans %= mod;
        seg.update(j, -1);
    }
    cout << ans;
//    cout << Solve(a);
}
