#include <bits/stdc++.h>
#define x first
#define y second
#define all(v) v.begin(), v.end()
#define chkmin(a, b) a = min(a, b)
#define chkmax(a, b) a = max(a, b)
using namespace std;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vii;

const int mod = 1e9 + 7;
const int MAX_N = 3e5 + 5;

struct Seg {
    vi seg;
    int n;
    Seg(int m) {
        for (n = 1; n < m; n <<= 1);
        seg.resize(2 * n);
    }
    void update(int i, int x) {
        for (i += n; i; i >>= 1) seg[i] += x;
    }
    int query(int l, int r) {
        int ans = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) ans += seg[l++];
            if (r & 1) ans += seg[--r];
        }
        return ans;
    }
};

struct SegMax {
    vi seg;
    int n;
    SegMax(int m) {
        for (n = 1; n < m; n <<= 1);
        seg.resize(2 * n);
    }
    void update(int i, int x) {
        for (i += n; i; i >>= 1) chkmax(seg[i], x);
    }
    int query(int l, int r) {
        int ans = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) chkmax(ans, seg[l++]);
            if (r & 1) chkmax(ans, seg[--r]);
        }
        return ans;
    }
};

ll Power(ll a, ll b) {
    if (!b) return 1;
    return Power(a * a % mod, b / 2) * (b & 1 ? a : 1) % mod;
}

inline ll Invert(ll a) {
    return Power(a, mod - 2);
}
ll factorial[MAX_N], invert_factorial[MAX_N];

inline ll Choose(int n, int k) {
    return factorial[n] * invert_factorial[k] % mod * invert_factorial[n - k] % mod;
}


int n, k;

map<int, vi> ind;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    vi a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    Seg seg(n);
    SegMax seg_max(n);
    for (int i = 0; i < n; i++) {
        seg.update(i, 1), seg_max.update(i, a[i]);
        ind[a[i]].push_back(i);
    }
    factorial[0] = 1;
    for (ll i = 1; i <= n; i++) factorial[i] = factorial[i - 1] * i % mod;
    invert_factorial[n] = Invert(factorial[n]);
    for (ll i = n - 1; i >= 0; i--) invert_factorial[i] = invert_factorial[i + 1] * (i + 1) % mod;
    ll ans = 1;
    for (auto &[x, v] : ind) {
        int sz = v.size();
        for (int i = 0; i < sz;) {
            int t;
            for (t = i + 1; t < sz; t++) {
                if (seg_max.query(v[i], v[t]) + a[v[i]] > k) break;
            }
            int j = v[i];
            int begin = 0, end = j, mid;
            while (begin < end) {
                mid = (begin + end) >> 1;
                if (seg_max.query(mid, j) + a[j] > k) begin = mid + 1;
                else end = mid;
            }
            ll l = end;
            begin = j + 1, end = n;
            while (begin < end) {
                mid = (begin + end) >> 1;
                if (seg_max.query(j + 1, mid + 1) + a[j] > k) {
                    end = mid;
                } else begin = mid + 1;
            }
            ll r = end - 1;
            ans *= Choose(seg.query(l, r + 1), t - i);
            ans %= mod;
            for (; i < t; i++) seg.update(v[i], -1);
        }
    }
    cout << ans;
}
/*
5 10
1 2 3 4 5
*/