#include <bits/stdc++.h>
#define x first
#define y second
#define all(v) v.begin(), v.end()
#define chkmin(a, b) a = min(a, b)
#define chkmax(a, b) a = max(a, b)
using namespace std;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vii;

const int mod = 1e9 + 7;
const int MAX_N = 3e5 + 5;

struct Fen {
    vi fen;
    int n;
    Fen(int n): n(n) {
        fen.resize(n + 1);
    }
    void update(int i, int x) {
        for (i++; i <= n; i += i & (-i)) fen[i] += x;
    }
    int query(int i) {
        int ans = 0;
        for (i++; i; i -= i & (-i)) ans += fen[i];
        return ans;
    }
    inline int query(int l, int r) {
        return query(r) - query(l - 1);
    }
};

int loga[MAX_N], rmq[20][MAX_N];
int a[MAX_N];
int n, k;

void InitRmq() {
    for (int i = 2; i <= n; i++) loga[i] = loga[i >> 1] + 1;
    for (int i = 0; i < n; i++) rmq[0][i] = a[i];
    for (int i = 1; i <= loga[n]; i++) {
        for (int j = 0; j < n; j++) {
            rmq[i][j] = max(rmq[i - 1][j], rmq[i - 1][min(n - 1, (j + (1 << (i - 1))))]);
        }
    }
}
inline int query(int l, int r) {
    return max(rmq[loga[r - l]][l], rmq[loga[r - l]][r - (1 << loga[r - l])]);
}

ll Power(ll a, ll b) {
    if (!b) return 1;
    return Power(a * a % mod, b / 2) * (b & 1 ? a : 1) % mod;
}

inline ll Invert(ll a) {
    return Power(a, mod - 2);
}
ll factorial[MAX_N], invert_factorial[MAX_N];

inline ll Choose(int n, int k) {
    return factorial[n] * invert_factorial[k] % mod * invert_factorial[n - k] % mod;
}

map<int, vi> ind;

int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
    cin >> n >> k;
    for (int i = 0; i < n; i++) cin >> a[i];
    Fen seg(n);
    InitRmq();
    for (int i = 0; i < n; i++) {
        seg.update(i, 1);
        ind[a[i]].push_back(i);
    }
    factorial[0] = 1;
    for (ll i = 1; i <= n; i++) factorial[i] = factorial[i - 1] * i % mod;
    invert_factorial[n] = Invert(factorial[n]);
    for (ll i = n - 1; i >= 0; i--) invert_factorial[i] = invert_factorial[i + 1] * (i + 1) % mod;
    ll ans = 1;
    for (auto &[x, v] : ind) {
        int sz = v.size();
        for (int i = 0; i < sz;) {
            int t;
            for (t = i + 1; t < sz; t++) {
                if (query(v[i], v[t]) + a[v[i]] > k) break;
            }
            int j = v[i];
            int begin = 0, end = j, mid;
            while (begin < end) {
                mid = (begin + end) >> 1;
                if (query(mid, j) + a[j] > k) begin = mid + 1;
                else end = mid;
            }
            int l = end;
            begin = j + 1, end = n;
            while (begin < end) {
                mid = (begin + end) >> 1;
                if (query(j + 1, mid + 1) + a[j] > k) {
                    end = mid;
                } else begin = mid + 1;
            }
            int r = end - 1;
            ans *= Choose(seg.query(l, r), t - i);
            ans %= mod;
            for (; i < t; i++) seg.update(v[i], -1);
        }
    }
    cout << ans;
}
/*
5 10
1 2 3 4 5
*/