#include <bits/stdc++.h>
typedef long long int64;
using namespace std;
const int64 mod = 1e9 + 7;
const int maxn = 1e5 + 2;
vector <int> ad (maxn, -1);
vector <int> adrev [maxn];
int vis[maxn];
int64 dp [maxn][2]; // dp[i][0]-> nr moduri / dp[i][1] -> nr items
int64 fact [maxn];

int64 pw (int64 a, int64 b) {
    if (!b) return 1;
    int64 h = pw(a, b / 2);
    return (b % 2 ? h * h % mod * a % mod: h * h % mod);
}

int64 inv (int64 a) {
    return pw(a, mod - 2);
}

int64 choose (int64 a, int64 b) {
    return fact[a] * inv(fact[b]) % mod * inv(fact[a - b]) % mod;
}

int64 dist (int64 a, int64 b) { // a objects in b buckets (possibly empty)
    return choose (a + b - 1, b - 1);
}

int64 brute (vector <int> a, int k) {
    int n = a.size();
    map <int, int> pos;
    for (int i = 0; i < n; i++){
        pos[a[i]] = i;
    }
    vector <int> b = a;
    sort(b.begin(), b.end());
    int rs = 0;
    do {
        bool f = 1;
        for (int i = 0; i < n; i++){
            for (int j = i + 1; j < n; j++){
                if (b[i] + b[j] > k && pos[b[i]] > pos[b[j]]) f = 0;
            }
        }
        rs+=f;
        // if (f) {
        //     for (int i = 0; i < n; i++){
        //         cout << b[i] << " ";
        //     }
        //     cout << "\n";
        // }
    } while (next_permutation(b.begin(), b.end()));
    return rs;
}

void dfs (int u) {
    // cout << u << " ";
    bool first = 1;
    for (int v: adrev[u]) {
        dfs(v);
        if (first) {
            first = 0;
            dp[u][0] = dp[v][0];
            dp[u][1] += dp[v][1];
        }
        else {
            dp[u][0] = dp[v][0] * dp[u][0] % mod * dist(dp[v][1], dp[u][1]) % mod;
            dp[u][1]+=dp[v][1];
        }
    }
    // cout << u << " " << dp[u][0] << " " << dp[u][1] << "\n";
}

int64 graph (vector <int> a, int k) {
    int n = a.size();
    for (int i = 0; i < n; i++){
        dp[i][0] = dp[i][1] = 1;
        for (int j = i + 1; j < n; j++){
            if (a[i] + a[j] > k) {
                ad[i] = j;
                adrev[j].push_back(i);
                break;
            }
        }
    }
    for (int i = 0; i < n; i++){
        if (ad[i] == -1) {
            ad[i] = n;
            adrev[n].push_back(i);
        }
    }
    // for (int i = 0; i < n; i++){
    //     cout << i << " " << ad[i] << "\n";
    // }
    dp[n][0] = 1;
    dfs(n);

    return dp[n][0];
}

int main() {
    cin.tie(0); ios_base::sync_with_stdio(0);
    fact[0] = 1;
    for (int64 i = 1; i < maxn; i++) fact[i] = fact[i-1] * i % mod;
    int n, k;
    cin >> n >> k;
    vector <int> a (n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    cout <<  graph(a, k);
    return 0;
}