#include "ones.h"
#include <random>
#include <chrono>
#include <iostream>
#include <algorithm>

std::mt19937 rng(0);

int ran(int lim) {
  return std::uniform_int_distribution<int>(0, lim)(rng);
}

std::pair<int,int> find_longest_subarray_of_ones(int n) {
  std::vector<bool> flip(n), repair(n);
  for(int i = 0; i < n; i++)
    flip[i] = ran(1);
  int base = flip_bits(flip);
  if(base == 0)
    return {0, -1};
  std::vector<int> candidates(n);
  std::iota(candidates.begin(), candidates.end(), 0);
  

  while(0 < base && 1 < candidates.size()) {
    //std::cout << "Try: " << base << " " << candidates.size() << '\n';
    //can collect random number of candidates instead
    std::random_shuffle(candidates.begin(), candidates.end());
    flip = repair;
    std::fill(repair.begin(), repair.end(), 0);
    
    for(int i = 0; i < candidates.size() / 2; i++) 
      flip[candidates[i]] = 1 - flip[candidates[i]];
    int newbase = flip_bits(flip);
      
    if(base == newbase)
      continue;
    else if(base < newbase) {
      candidates.resize(candidates.size() / 2);
      base = newbase;
    } else if(newbase < base) {
      for(int i = 0; i < candidates.size() / 2; i++)
        repair[candidates[i]] = 1 - repair[candidates[i]];
      candidates.resize(candidates.size() / 2);
    }
  }
  if(base == 0) 
    return {0, -1};
  int x = candidates[0];

  while(0 < x) {
    flip = repair;
    std::fill(repair.begin(), repair.end() , 0);
    flip[x - 1] = 1 - flip[x - 1];
    repair[x - 1] = 1 - repair[x - 1];
    int newbase = flip_bits(flip);
    if(newbase < base)
      x--;
    else
      break;
  }
  flip_bits(repair);
  return {x, x + base - 1};
}
