#include <iostream>
#include <vector>
#include <algorithm>

using ll = long long;

bool valid(int x, int y) {
  return (x * y) % (x + y) == 0;
}

bool valid_fast(int x, int y) {
  int d = std::__gcd(x, y);
  return (d % (x / d + y / d)) == 0;
}

int const nmax = 200000;
int mobius[5 + nmax], prime[5 + nmax];

void precompute() {
  mobius[1] = prime[1] = 1;
  for(int i = 2;i <= nmax; i++)
    if(prime[i] == 0) {
      for(int j = 2 * i; j <= nmax; j += i)
        prime[j] = 1;
      for(int j = i; j <= nmax; j += i)
        if(0 < ((j / i) % i))
          mobius[j] = -mobius[j / i];
    }
}

int coef[5 + nmax];

int brut(int p, int q, int n) {
  int result = 0;
  for(int i = 1; i <= p; i++)
    for(int j = 1;j <= q; j++)
      if(1LL * i * j % (i + j) == 0)
        result += ((i * j) <= n * (i + j));
  return result;
}

int main() {
  precompute();
  ll p, q, n;
  std::cin >> p >> q >> n;

  ll result = 0;
  for(int dsmall = 1; dsmall <= nmax; dsmall++)
    for(int d = dsmall; d <= nmax; d += dsmall) {
      int lim = std::min(dsmall - 1, nmax / d);
      for(int x = 1; x <= lim; x++) {
        int y = dsmall - x;
        if(x <= y) {
          result += (1LL * x * d <= p) && (1LL * y * d <= q) && (std::__gcd(x, y) == 1) && 
           1LL * d * x * y <= 1LL * n * dsmall;
          if(x < y) {          
            result += (1LL * y * d <= p) && (1LL * x * d <= q) && (std::__gcd(x, y) == 1) && 
             1LL * d * x * y <= 1LL * n * dsmall;
          }
        }
      }
    }
  std::cout << result << '\n';
  //std::cout << brut(p, q, n) << " "<< result << '\n';
  return 0;
}
