#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using ll = long long;

bool valid(int x, int y) {
  return (x * y) % (x + y) == 0;
}

bool valid_fast(int x, int y) {
  int d = std::__gcd(x, y);
  return (d % (x / d + y / d)) == 0;
}

//int const nmax = 20;

int const nmax = 5 + sqrt(50 * 1000000);
int mobius[5 + nmax], prime[5 + nmax];

void precompute() {
  mobius[1] = prime[1] = 1;
  for(int i = 2;i <= nmax; i++)
    if(prime[i] == 0) {
      for(int j = 2 * i; j <= nmax; j += i)
        prime[j] = 1;
      for(int j = i; j <= nmax; j += i)
        if(0 < ((j / i) % i))
          mobius[j] = -mobius[j / i];
    }
}

int coef[5 + nmax];

int brut(int p, int q, int n) {
  int result = 0;
  for(int i = 1; i <= p; i++)
    for(int j = 1;j <= q; j++)
      if(1LL * i * j % (i + j) == 0) {
        result += ((i * j) <= n * (i + j));
        std::cout << i << " " << j << " " << std::__gcd(i, j) << '\n';
        std::cout << i / std::__gcd(i, j) << " " << j / std::__gcd(i, j) << '\n' << '\n';
        std::cout << (i + j) / std::__gcd(i, j) << '\n';

      }
  return result;
}

int main() {
  precompute();
  ll p, q, n;
  std::cin >> p >> q >> n;

  ll result = 0;
  for(int dsmall = 1; dsmall <= nmax; dsmall++) {
    int lim = dsmall - 1;
    for(int x = 1; x < dsmall; x++) {
      int y = dsmall - x;
      ll dbound = std::min(n * dsmall / x / y, std::min(p / x, q / y)) / dsmall;
      result += (std::__gcd(x, y) == 1) * dbound; 
    }
  }
  //std::cout << brut(p, q, n) << '\n';
  std::cout << result << '\n';
  //std::cout << brut(p, q, n) << " "<< result << '\n';
  return 0;
}
