#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using ll = long long;

bool valid(int x, int y) {
  return (x * y) % (x + y) == 0;
}

bool valid_fast(int x, int y) {
  int d = std::__gcd(x, y);
  return (d % (x / d + y / d)) == 0;
}

//int const nmax = 20;

int const nmax = 5 + 2 * sqrt(25 * 1000000);
int prev[5 + nmax], coprime[5 + nmax];

void precompute() {
  prev[1] = 1;
  for(int i = 2;i <= nmax; i++)
    if(prev[i] == 0) {
      for(int j = i; j <= nmax; j += i)
        prev[j] = i;
    }
}

int coef[5 + nmax];

int brut(int p, int q, int n) {
  int result = 0;
  for(int i = 1; i <= p; i++)
    for(int j = 1;j <= q; j++)
      if(1LL * i * j % (i + j) == 0) {
        result += ((i * j) <= n * (i + j));
        /*
        std::cout << i << " " << j << " " << std::__gcd(i, j) << '\n';
        std::cout << i / std::__gcd(i, j) << " " << j / std::__gcd(i, j) << '\n' << '\n';
        std::cout << (i + j) / std::__gcd(i, j) << '\n';
        */

      }
  return result;
}


int main() {
  precompute();
  ll p, q, n;
  std::cin >> p >> q >> n;

  ll result = 0;
  /*
  for(int dsmall = 1; dsmall <= nmax; dsmall++) {
    int lim = dsmall - 1;
    for(int x = 1; x < dsmall; x++) {
      int y = dsmall - x;
      ll dbound = std::min(n * dsmall / x / y, std::min(p / x, q / y)) / dsmall;
      result += (std::__gcd(x, y) == 1) * dbound; 
    }
  }
  */

  for(int dsmall = 1; dsmall <= nmax; dsmall++) {
    //*
    std::vector<int> primes;
    int dcp = dsmall;
    while(1 < dcp) {
      primes.push_back(prev[dcp]);
      dcp = dcp / prev[dcp];
    }
    primes.erase(std::unique(primes.begin(), primes.end()), primes.end());
    std::fill(coprime, coprime + dsmall, 1);
    
    for(int i = 0; i < primes.size(); i++) { 
      int val = primes[i];
      for(int j = val; j < dsmall; j += val) {
        coprime[j] = 0;
      }
    }

    int lim = dsmall - 1;
    for(int x = 1; x < dsmall; x++) {
      int y = dsmall - x;
      
      ll dbound = std::min(n / x / y, std::min(p / x / dsmall, q / y / dsmall));
      result += coprime[x] * dbound; 
    }
  }
  
  /*
  for(int x = 2; x <= nmax; x++) {
    for(int dsmall = x * 2; dsmall <= nmax; dsmall += x) {
      int y = dsmall - x;
      ll dbound = std::min(n * dsmall / x / y, std::min(p / x, q / y)) / dsmall;
      result -= dbound; 
    }
  }
  */
  //std::cout << brut(p, q, n) << '\n';
  std::cout << result << '\n';
  //std::cout << brut(p, q, n) << " "<< result << '\n';
  return 0;
}
