#pragma GCC optimize ("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using ll = int;

bool valid(int x, int y) {
  return (x * y) % (x + y) == 0;
}

bool valid_fast(int x, int y) {
  int d = std::__gcd(x, y);
  return (d % (x / d + y / d)) == 0;
}

//int const nmax = 20;

ll const valmax = 25000000;
int const nmax = 5 + 2 * sqrt(valmax);
int prev[5 + nmax], coprime[5 + nmax];

void precompute() {
  prev[1] = 1;
  for(int i = 2;i <= nmax; i++)
    if(prev[i] == 0) {
      for(int j = i; j <= nmax; j += i)
        prev[j] = i;
    }
}

int coef[5 + nmax];

int brut(int p, int q, int n) {
  int result = 0;
  for(int i = 1; i <= p; i++)
    for(int j = 1;j <= q; j++)
      if(1LL * i * j % (i + j) == 0) {
        result += ((i * j) <= n * (i + j));
        /*
           std::cout << i << " " << j << " " << std::__gcd(i, j) << '\n';
           std::cout << i / std::__gcd(i, j) << " " << j / std::__gcd(i, j) << '\n' << '\n';
           std::cout << (i + j) / std::__gcd(i, j) << '\n';
         */

      }
  return result;
}


int main() {
  precompute();
  ll p, q, n;
  std::cin >> p >> q >> n;

  long long result = 0;

  for(int dsmall = 1; dsmall <= nmax; dsmall++) {
    //*
    std::vector<int> primes;
    int dcp = dsmall;
    while(1 < dcp) {
      primes.push_back(prev[dcp]);
      dcp = dcp / prev[dcp];
    }
    primes.erase(std::unique(primes.begin(), primes.end()), primes.end());
    std::fill(coprime, coprime + dsmall, 1);

    for(int i = 0; i < primes.size(); i++) { 
      int val = primes[i];
      for(int j = val; j < dsmall; j += val) {
        coprime[j] = 0;
      }
    }

    int lim = dsmall - 1;
    //*
    for(int x = 1; x < dsmall; x++) {
      if(coprime[x] == 1) {
        int y = dsmall - x;

        ll dbound = std::min(n / x / y, std::min(p / x / dsmall, q / y / dsmall));
        result += coprime[x] * dbound; 
      }
    }
  }

  std::cout << result << '\n';
  return 0;
}
