#include <bits/stdc++.h>

using namespace std;

const int offset = (1 << 19);
struct SegTree {
    struct node {
        int right_block = -1, left_block = -1, active = 0;
    } aint[2 * offset];

    node comb(node l, node r) {
        node ret;
        if(r.right_block == -1) ret.right_block = l.right_block;
        else ret.right_block = r.right_block;

        if(l.left_block == -1) ret.left_block = r.left_block;
        else ret.left_block = l.left_block;

        ret.active = l.active + r.active;
        return ret;
    }

    void update(int poz, int activ, int block) {
        if(block == true) block = poz; else block = -1;
        aint[poz + offset] = {block, block, activ};

        for(poz = (poz + offset) / 2; poz > 0; poz /= 2) {
            // cerr << "Updated" << poz << endl;
            aint[poz] = comb(aint[2 * poz], aint[2 * poz + 1]);
        }
    }

    node query(int n, int l, int r, int gl, int gr) {
        if(r < gl || gr < l) return node();

        if(gl <= l && r <= gr) return aint[n];

        int mid = (l + r) / 2;
        return comb(query(2 * n, l, mid, gl, gr), query(2 * n + 1, mid + 1, r, gl, gr));
    }

    node qry(int l, int r) {
        return query(1, 0, offset - 1, l, r);
    }

    SegTree() {
        for(int i = offset; i < 2 * offset; i++) aint[i] = node();
        for(int i = offset - 1; i >= 1; i--) aint[i] = comb(aint[2 * i], aint[2 * i + 1]);
    }
} st;

const int mod = 1e9 + 7;
int lgpow(int b, int e) {
    int ret = 1;
    while(e) {
        if(e & 1) ret = (1LL * ret * b) % mod;
        b = (1LL * b * b) % mod;

        e /= 2;
    }
    return ret;
}

int find_possible(int poz) {
    int left_block = st.qry(0, poz - 1).right_block;
    int right_block = st.qry(poz + 1, offset - 1).left_block;

    int possible = st.qry(left_block + 1, right_block - 1).active + 1;
    return possible;
}

int main()
{
    /* cerr << st.aint[1].left_block << endl;
    cerr << st.aint[1].right_block << endl;
    cerr << st.aint[1].active << endl; */

    int n, k; cin >> n >> k;
    vector<int> v(n); for(auto &e : v) cin >> e;

    vector<pair<int, int>> pos;
    for(int i = 0; i < n; i++) pos.push_back({v[i], i + 1});
    sort(pos.begin(), pos.end());
    reverse(pos.begin(), pos.end());

    st.update(0, 0, true);
    st.update(n + 1, 0, true);

    int ptr2 = pos.size() - 1;

    int64_t ans = 1;
    for(int ptr = 0; ptr < pos.size();) {
        int value = pos[ptr].first; vector<int> pozs;

        while(ptr2 >= 0 && pos[ptr2].first + value <= k) {
            if(pos[ptr2].first > value) st.update(pos[ptr2].second, 1, false);
            ptr2--;
        }

        while(ptr < pos.size() && pos[ptr].first == value) {
            pozs.push_back(pos[ptr].second); ptr++;
        }
        // cerr << value << ": " << endl;
        // for(auto e : pozs) cerr << e << " "; cerr << endl;

        int last_possible = find_possible(pozs[0]), last_i = 1;
        ans = (1LL * ans * last_possible) % mod;
        for(int i = 1; i < pozs.size(); i++) {
            if(st.qry(pozs[i - 1], pozs[i]).left_block == -1) {
                ans = (1LL * ans * (last_possible + last_i)) % mod;
                ans = (1LL * ans * lgpow(last_i + 1, mod - 2)) % mod;
                last_i += 1;


                // cerr << "Divved by " << last_i << endl;
            }
            else {
                last_possible = find_possible(pozs[i]);
                last_i = 1;

                ans = (1LL * ans * last_possible) % mod;
            }
        }

        for(auto e : pozs) {
            st.update(e, 1, 2 * value > k);
        }
    }

    cout << ans << endl;
    return 0;
}
