#ifndef LOCAL
#include "ones.h"
#endif // LOCAL

#ifdef LOCAL
#include <bits/stdc++.h>
using namespace std;
#include <vector>
#include <utility>
#include <cassert>
#include <iostream>

static int _n;
static std::vector<bool> _a;
static long long num_queries;

static int longest_seq_of_1s(){
    int ans = 0, curr = 0;
    for(int i = 0; i < _n; ++i){
        if(_a[i]){
            ++curr;
        }
        else{
            curr = 0;
        }
        ans = std::max(ans, curr);
    }
    return ans;
}

int flip_bits(const std::vector<bool> &flips){
    assert((int)flips.size() == _n);
    ++num_queries;
    for(int i = 0; i < _n; ++i)
        _a[i] = flips[i] ^ _a[i];

    // for(auto e : _a) cerr << e << " "; cerr << endl;
    return longest_seq_of_1s();
}
#endif // LOCAL

#include <bits/stdc++.h>
using namespace std;

vector<bool> setter;
void flip(int poz) {
    if(poz >= 0 && poz < setter.size()) setter[poz] = !setter[poz];
}

int last = -1;
int query() {
    int cnt = 0;
    for(int i = 0; i < setter.size(); i++) {
        cnt += 1;
    }

    if(last == -1 || cnt > 0) {
        last = flip_bits(setter);
        for(int i = 0; i < setter.size(); i++) setter[i] = 0;
    }
    return last;
}

mt19937 rng(2432453);
std::pair<int, int> find_longest_subarray_of_ones(int n) {
    setter.resize(n);

    for(int i = 0; i < setter.size(); i++) if(0 == uniform_int_distribution<>{0, 1}(rng)) flip(i);

    while(query() >= 15) {
        for(int i = 0; i < setter.size(); i++) if(0 == uniform_int_distribution<>{0, 1}(rng)) flip(i);
    }

    int mod = query() + 1;
    int orig = query();

    if(orig == 0) return {0, -1};

    for(int rem = 0; rem < mod; rem++) {
        for(int i = 0; i < n; i++) {
            if(i % mod == rem) flip(i);
        }

        if(query() >= orig + 2) {
            // found it
            cerr << orig << " " << query() << endl;

            for(int i = 0; i < n; i++) {
                if(i % mod == rem) flip(i);
            }

            vector<int> pos;
            for(int i = 0; i < n; i++) {
                if(i % mod == rem) pos.push_back(i);
            }

            while(pos.size() > 1) {
                vector<int> left_half;
                vector<int> right_half;
                for(int i = 0; i < pos.size(); i += 1) {
                    if(i % 2 == 0) left_half.push_back(pos[i]);
                    else right_half.push_back(pos[i]);

                    if(i % 2 == 0) flip(pos[i]);
                }

                if(query() >= orig + 1) {
                    pos = left_half;
                }
                else {
                    pos = right_half;
                }

                for(auto e : left_half) flip(e);
            }

            int best = pos[0];
            #ifdef LOCAL
            cerr << best << endl;
            for(int i = best - 24; i <= best + 24; i++) {
                cerr << _a[i] << " ";
            }
            cerr << endl;
            #endif // LOCAL

            flip(best);
            int target = query();

            int first_adding = 0;
            for(int step = (1 << 4); step; step /= 2) {
                int nfa = first_adding + step;
                flip(best - nfa);
                if(query() < target) { first_adding = nfa; }
                flip(best - nfa);
            }

            int last_adding = 0;
            for(int step = (1 << 4); step; step /= 2) {
                int nla = last_adding + step;
                flip(best + nla);
                if(query() < target) { last_adding = nla; }
                flip(best + nla);
            }

            // cerr << first_adding << " " << last_adding << endl;
            query(); return {best - first_adding, best + last_adding};
        }

        for(int i = 0; i < n; i++) {
            if(i % mod == rem) flip(i);
        }
    }

    return {0, n - 1};
}

#ifdef LOCAL
int main(){
    int t;
    // std::cin >> t;
    t = 100;

    long long max_qs = 0;

    while(t--){
        num_queries = 0;

        // std::cin >> _n;
        _n = 5;
        _a.resize(_n);
        for(int i = 0; i < _n; ++i){
            bool val;
            // std::cin >> val;
            val = 1;
            _a[i] = val;
        }

        auto [l, r] = find_longest_subarray_of_ones(_n);
        if(longest_seq_of_1s() != r - l + 1){
            std::cout << "BAD\n";
            // continue;
        }
        if(l == 0 && r == -1){
            max_qs = std::max(num_queries, max_qs);
            continue;
        }
        if(r < l || l < 0 || l >= _n || r < 0 || r >= _n){
            std::cout << "BAD\n";
            // continue;
        }

        for(int i = l; i <= r; ++i){
            if(_a[i] != 1){
                std::cout << "BAD\n";
                break;
            }
        }

        cerr << "QUERIES " << num_queries << endl;
        max_qs = std::max(num_queries, max_qs);
    }

    std::cout << "1 " << "QR " << max_qs << "\n";
    return 0;
}
#endif // LOCAL
