#include <bits/stdc++.h>
#define int long long 
using namespace std;

#ifdef EVAL
#define in cin
#define out cout
#else
ifstream in("in.in");
ofstream out("out.out");
#endif

const int MOD = 1000000007,inf = (1LL << 60);
struct Element {
    int pos, val;
    mutable int nr_behind;

    mutable pair<int,int> debt; /// ammount, and value that have been added behind this dude

    Element(int pos, int val, int nr_behind, pair<int,int> debt) {
        this->pos = pos;
        this->val = val;
        this->nr_behind = nr_behind;
        this->debt = debt;
    }
    bool operator < (const Element other) const {
        return pos < other.pos;
    }

    bool operator < (const int other) const {
        return pos < other;
    }
};

int put(int x, int y) {
    int s = 1;
    while(y) {
        if (y%2) {
            s = s * x % MOD;
        }
        x = x * x % MOD;
        y /= 2;
    }
    return s;
}

int inv(int x) {
    return put(x , MOD - 2);
}
int32_t main() {
    int n,k;
    in >> n >> k;
    vector<int> fact(n + 1);
    fact[0] = 1;
    for (int i = 1; i <= n; i++) {
        fact[i] = fact[i - 1] * i % MOD;
    }
    vector<int> a(n + 1),taken(n + 1, 0);
    vector<pair<int,int>> values;

    set<Element,less<>> s;

    for (int i = 1; i <= n; i++) {
        in >> a[i];
        values.push_back({a[i] , i});
    }
    sort(values.begin() , values.end(), [&](pair<int,int> x, pair<int,int> y) {
        return x.first > y.first;
    });

    s.insert(Element({n + 1, inf, 0, {-1,0}}));

    int prod = 1;

    auto pay = [&](pair<int,int> cum_debt, pair<int,int> erased_debt) {
        if (cum_debt.first == erased_debt.first) {
            cum_debt.second += erased_debt.second;
        } else {
            prod = prod * inv(fact[erased_debt.second]) % MOD;
        }
        return cum_debt;
    };

    auto erase_front = [&](set<Element> :: iterator it, int x_val) {
        int nr_erased = 0;
        auto after = it; /// the element that comes after
        pair<int,int> debt = {x_val, 1};

        while(after != s.end() && after->val + x_val <= k) {
            nr_erased += after->nr_behind + 1;
            debt = pay(debt, after->debt);
            after = s.erase(after);
        }
        after->nr_behind += nr_erased;
        debt = pay(debt, after->debt);
        after->debt = debt;
        return after;
    };

    auto erase_behind = [&](set<Element> :: iterator it, int x_val) {
        int nr_erased = 0;
        pair<int,int> debt = {x_val, 1};
        while(it != s.begin()) {
            it--;
            if (it->val + x_val <= k) {
                nr_erased += it->nr_behind + 1;
                pay(debt, it->debt); /// if the numbers differ, pay the debt of what you're erasing, if not, add the debt to currnet debt
                it = s.erase(it);
            } else {
                break;
            }
        }
        return pair<int,pair<int,int>>{nr_erased,debt};
    };

    auto get_so_far = [&](int x) {

        auto it = s.lower_bound(x);

        auto new_front = erase_front(it, a[x]);
        auto erased_behind = erase_behind(new_front, a[x]);

        int nr_erased_behind = erased_behind.first;
        auto debt = erased_behind.second;

        s.insert(Element{x , a[x] , nr_erased_behind, debt});
        return new_front->nr_behind + 1 + nr_erased_behind;
    };
    for (auto k : values) {
        prod = prod * get_so_far(k.second) % MOD;
        taken[k.second] = 1;
    }

    
    for (auto k : s) {
        prod = prod * inv(fact[k.debt.second]) % MOD;
    }
    out << prod << "\n";
}