#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 300000 + 7;
const int M = (int) 1e9 + 7;

int add(int a, int b)
{
  a += b;
  if (a >= M)
  {
    return a - M;
  }
  if (a < 0)
  {
    return a + M;
  }
  return a;
}

int mul(int a, int b)
{
  return a * (ll) b % M;
}

int pw(int a, int b)
{
  int r = 1;
  while (b)
  {
    if (b & 1)
    {
      r = mul(r, a);
    }
    a = mul(a, a);
    b /= 2;
  }
  return r;
}

int dv(int a, int b)
{
  return mul(a, pw(b, M - 2));
}

void addup(int &a, int b)
{
  a = add(a, b);
}

void mulup(int &a, int b)
{
  a = mul(a, b);
}

int n;
int k;
int a[N];
int fact[N];
int ifact[N];
int aib[N];

void add_aib(int i, int x)
{
  while (i <= n)
  {
    aib[i] += x;
    i += i & (-i);
  }
}

int get_aib(int i)
{
  int sol = 0;
  while (i)
  {
    sol += aib[i];
    i -= i & (-i);
  }
  return sol;
}

pair<int, int> t[4 * N];

void build(int v, int tl, int tr)
{
  if (tl == tr)
  {
    t[v] = {a[tl], tl};
    return;
  }
  int tm = (tl + tr) / 2;
  build(2 * v, tl, tm);
  build(2 * v + 1, tm + 1, tr);
  t[v] = max(t[2 * v], t[2 * v + 1]);
}

pair<int, int> get(int v, int tl, int tr, int l, int r)
{
  if (tr < l || r < tl)
  {
    return {0, 0};
  }
  if (l <= tl && tr <= r)
  {
    return t[v];
  }
  int tm = (tl + tr) / 2;
  return max(get(2 * v, tl, tm, l, r), get(2 * v + 1, tm + 1, tr, l, r));
}

void upd(int v, int tl, int tr, int i, int x)
{
  if (tr < i || i < tl)
  {
    return;
  }
  if (tl == tr)
  {
    assert(tl == i);
    assert(tr == i);
    t[v].first = x;
    return;
  }
  int tm = (tl + tr) / 2;
  upd(2 * v, tl, tm, i, x);
  upd(2 * v + 1, tm + 1, tr, i, x);
  t[v] = max(t[2 * v], t[2 * v + 1]);
}

int comb(int n, int k)
{
  assert(0 <= k && k <= n && n < N);
  return mul(fact[n], mul(ifact[k], ifact[n - k]));
}


int solve(int l, int r, int over)
{
  if (l > r)
  {
    return 1;
  }
  assert(1 <= l && l <= r && r <= n);
  int pmx = l;
  for (int i = l; i <= r; i++)
  {
    if (a[i] > a[pmx])
    {
      pmx = i;
    }
  }
  assert(1 <= l && l <= pmx && pmx <= r && r <= n);
  if (a[pmx] < over)
  {
    return 1;
  }
  int cnt_both = 0, cnt_active = 0, c1 = 0, c2 = 0;
  map<int, int> f;
  for (int i = l; i <= r; i++)
  {
    if (a[i] >= over)
    {
      cnt_active++;
      if (i != pmx)
      {
        if (a[i] + a[pmx] <= k)
        {
          add_aib(i, -1);
          f[a[i]]++;
          cnt_both++;
        }
        else
        {
          if (i < pmx)
          {
            c1++;
          }
          else
          {
            c2++;
          }
        }
      }
    }
  }
  assert(c1 == get_aib(pmx - 1) - get_aib(l));
  assert(c2 == get_aib(r) - get_aib(pmx));

  int total_coef = fact[cnt_both];
  for (auto &it : f)
  {
    mulup(total_coef, ifact[it.second]);
  }
  int sol = 0;
  //cout << "= " << cnt_active << " " << cnt_both << " " << c1 << " " << c2  << "\n";
  for (int clft = 0; clft <= cnt_both; clft++)
  {
    int crgh = cnt_both - clft;
    int coef = total_coef;
    mulup(coef, comb(c1 + clft, clft));
    mulup(coef, comb(c2 + crgh, crgh));
    //cout << "==== " << coef << "\n";
    addup(sol, coef);
  }
  /// a[i] + a[pmx] >= k + 1
  mulup(sol, solve(l, pmx - 1, max(over, k + 1 - a[pmx])));
  mulup(sol, solve(pmx + 1, r, max(over, k + 1 - a[pmx])));
  return sol;
}

int main()
{
  ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
  //freopen ("input.txt", "r", stdin);
  fact[0] = 1;
  for (int i = 1; i < N; i++)
  {
    fact[i] = mul(fact[i - 1], i);
  }
  ifact[N - 1] = dv(1, fact[N - 1]);
  for (int i = N - 2; i >= 0; i--)
  {
    ifact[i] = mul(ifact[i + 1], i + 1);
  }
  if (0)
  {
    for (int i = 0; i <= 10; i++)
    {
      cout << "fact[" << i << "] = " << fact[i] << " " << ifact[i] << " : " << mul(fact[i], ifact[i]) << "\n";
    }
    return 0;
  }
  cin >> n >> k;
  for (int i = 1; i <= n; i++)
  {
    cin >> a[i];
    add_aib(i, +1);
  }


  int sol = solve(1, n, 0);

  cout << sol << "\n";

  return 0;
}
/**
4 5
1 2 1 3
ans = 12
**/
/**
5 4
4 3 1 5 2
ans = 2
**/
