#include <bits/stdc++.h>

using namespace std;

const int Mod = 1e9 + 7;
const int vmax = 3e5;

int n,k;

int v[vmax + 5];

long long fact[vmax + 5], invfact[vmax + 5];

vector<int> u_l[vmax + 5], u_r[vmax + 5];

int s[vmax + 5];

int l[vmax + 5], r[vmax + 5];

int aib[vmax + 5];

int ub(int x)
{
    return (x & (-x));
}

void update(int poz, int val)
{
    for(int i=poz;i<=n;i+=ub(i))
    {
        aib[i] += val;
    }
}

int query(int qa, int qb)
{
    if(qa > qb)
    {
        return 0;
    }
    int rez = 0;
    for(int i=qb;i>=1;i-=ub(i))
    {
        rez += aib[i];
    }
    for(int i=qa-1;i>=1;i-=ub(i))
    {
        rez -= aib[i];
    }
    return rez;
}

long long lgput(long long a, long long b)
{
    long long p = 1;
    while(b)
    {
        if(b%2==0)
        {
            b/=2;
            a = 1LL * a * a % Mod;
        }
        else
        {
            --b;
            p = 1LL * p * a % Mod;
        }
    }
    return p;
}

long long invmod(long long x)
{
    return lgput(x,Mod-2);
}

long long aranj(int a, int b)
{
    return 1LL * fact[a] * invfact[a - b] % Mod;
}

int Log2[vmax + 5];
pair<int,int> rmq[25][2 * vmax + 5];

pair<int,int> Merge(pair<int,int> a,pair<int,int> b)
{
    if(a.first > b.first || (a.first==b.first && a.second < b.second))
    {
        return a;
    }
    return b;
}

void build_rmq()
{
    for(int i=2;i<=n;i++)
    {
        Log2[i] = 1 + Log2[i / 2];
    }
    for(int i=1;i<=n;i++)
    {
        rmq[0][i].first = v[i];
        rmq[0][i].second = i;
    }
    for(int k=1;k<=Log2[n];k++)
    {
        for(int i=1;i<=n;i++)
        {
            if(i + (1<<k) - 1 > n)
            {
                break;
            }
            rmq[k][i] = Merge(rmq[k-1][i],rmq[k-1][i+(1<<(k-1))]);
        }
    }
}

int query_rmq(int x, int y)
{
    int k = Log2[y - x + 1];
    return Merge(rmq[k][x],rmq[k][y-(1<<k)+1]).second;
}

map<int,int> mp;

int divide(int st, int dr, int ramase)
{
    if(ramase<=1)
    {
        return 1;
    }
    int poz = query_rmq(st,dr);
    int nr = 0;
    for(auto it : u_l[poz])
    {
        ++nr;
        ++mp[v[it]];
        update(it,-1);
    }
    for(auto it : u_r[poz])
    {
        ++nr;
        ++mp[v[it]];
        update(it,-1);
    }
    long long rez = aranj(ramase,nr);
    for(auto it : mp)
    {
        rez = 1LL * rez * invfact[it.second] % Mod;
    }
    mp.clear();
    return 1LL * divide(st,poz-1,query(st,poz-1)) * divide(poz+1,dr,query(poz+1,dr)) % Mod * rez % Mod;
}

void precalc()
{
    fact[0] = 1;
    for(int i=1;i<=vmax;i++)
    {
        fact[i] = 1LL * fact[i - 1] * i % Mod;
    }
    invfact[vmax] = invmod(fact[vmax]);
    for(int i=vmax-1;i>=0;i--)
    {
        invfact[i] = 1LL * invfact[i + 1] * (i + 1) % Mod;
    }
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    #ifdef HOME
    freopen("nr.in","r",stdin);
    freopen("nr.out","w",stdout);
    #endif // HOME
    precalc();
    cin>>n>>k;
    vector<int> aux;
    for(int i=1; i<=n; i++)
    {
        cin>>v[i];
        aux.push_back(v[i]);
        update(i,+1);
    }
    build_rmq();
    int top = 0;
    for(int i=1; i<=n; i++)
    {
        while(top > 0 && v[i] > v[s[top]])
        {
            --top;
        }
        l[i] = -1;
        int st = 1;
        int dr = top;
        while(st<=dr)
        {
            int mij = (st + dr) >> 1;
            if(v[s[mij]] + v[i] <= k)
            {
                l[i] = s[mij];
                dr = mij - 1;
            }
            else
            {
                st = mij + 1;
            }
        }
        s[++top] = i;
    }
    top = 0;
    for(int i=n;i>=1;i--)
    {
        while(top > 0 && v[i] >= v[s[top]])
        {
            --top;
        }
        r[i] = -1;
        int st = 1;
        int dr = top;
        while(st<=dr)
        {
            int mij = (st + dr) >> 1;
            if(v[s[mij]] + v[i] <= k)
            {
                r[i] = s[mij];
                dr = mij - 1;
            }
            else
            {
                st = mij + 1;
            }
        }
        s[++top] = i;
    }
    for(int i=1;i<=n;i++)
    {
        if(r[i]==-1 && l[i]==-1)
        {
            continue;
        }
        if(r[i]==-1)
        {
            u_r[l[i]].push_back(i);
        }
        else if(l[i]==-1)
        {
            u_l[r[i]].push_back(i);
        }
        else
        {
            if(v[l[i]] >= v[r[i]])
            {
                u_r[l[i]].push_back(i);
            }
            else
            {
                u_l[r[i]].push_back(i);
            }
        }
    }
    cout<<divide(1,n,n)<<'\n';
    return 0;
}
