#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 3e5 + 5;
constexpr int MOD = 1e9 + 7;
constexpr int INF = 1e9 + 2;

int N, K, W[NMAX];

struct Node {
    int posMax;
    int valMax;
    int posMin;
    int valMin;
    int cnt;

    Node () {
        posMax = posMin = 0;
        cnt = 0;
        valMax = valMin = INF;
    }
};

Node arb[4*NMAX];

Node Combin (Node st, Node dr) {
    Node ans;

    ans.cnt = st.cnt + dr.cnt;

    if (st.valMax == INF) {
        ans.valMax = dr.valMax;
        ans.posMax = dr.posMax;
    }
    else if (dr.valMax == INF) {
        ans.valMax = st.valMax;
        ans.posMax = st.posMax;
    }
    else {
        if (st.valMax >= dr.valMax) {
            ans.valMax = st.valMax;
            ans.posMax = st.posMax;
        }
        else {
            ans.valMax = dr.valMax;
            ans.posMax = dr.posMax;
        }
    }

    if (st.valMin <= dr.valMin) {
        ans.valMin = st.valMin;
        ans.posMin = st.posMin;
    }
    else {
        ans.valMin = dr.valMin;
        ans.posMin = dr.posMin;
    }

    return ans;
}

void Update (int nod, int a, int b, int pos, int val) {
    if (a == b) {
        arb[nod].posMax = pos;
        arb[nod].posMin = pos;
        arb[nod].valMin = val;
        arb[nod].valMax = val;

        if (val != INF) arb[nod].cnt = 1;

        return;
    }

    int mij = (a + b) / 2;

    if (pos <= mij) Update(2*nod, a, mij, pos, val);
    else Update(2*nod+1, mij+1, b, pos, val);

    arb[nod] = Combin(arb[2*nod], arb[2*nod+1]);
}

Node Query (int nod, int a, int b, int qa, int qb) {
    if (qa > qb) {
        Node aux;
        return aux;
    }

    if (qa <= a && b <= qb) return arb[nod];

    int mij = (a + b) / 2;
    Node ans_st, ans_dr;

    if (qa <= mij) ans_st = Query(2*nod, a, mij, qa, qb);
    if (mij < qb) ans_dr = Query(2*nod+1, mij+1, b, qa, qb);

    return Combin(ans_st, ans_dr);
}

void Read () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> K;

    for (int i = 1; i <= N; ++ i ) {
        cin >> W[i];
        Update(1, 1, N, i, W[i]);
    }
}

int ans = 1;

void Solve (int st, int dr) {
    if (st >= dr) return;

    Node spl = Query(1, 1, N, st, dr);

    if (spl.valMax == INF) return;

    Node aux = Query(1, 1, N, st, spl.posMax - 1);
    int contor = 0;
    while (aux.valMin != INF && aux.valMin + spl.valMax <= K) {
        ans = (1LL * ans * (spl.cnt - contor)) % MOD;
        ++ contor;
        Update(1, 1, N, aux.posMin, INF);
        aux = Query(1, 1, N, st, spl.posMax - 1);
    }

    aux = Query(1, 1, N, spl.posMax + 1, dr);
    while (aux.valMin != INF && aux.valMin + spl.valMax <= K) {
        ans = (1LL * ans * (spl.cnt - contor)) % MOD;
        ++ contor;
        Update(1, 1, N, aux.posMin, INF);
        aux = Query(1, 1, N, spl.posMax + 1, dr);
    }

    Solve(st, spl.posMax - 1);
    Solve(spl.posMax + 1, dr);
}

int main () {
    Read();
    //Precompute();
    Solve(1, N);

    cout << ans << '\n';
    return 0;
}
