#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int N_MAX = 300000;
const int MOD = (int) 1e9 + 7;

int pwr (const int &a, const int &b) {
    if (b == 0) {
        return 1;
    } else if (b & 1) {
        return (ll) a * pwr(a, (b ^ 1)) % MOD;
    } else {
        int aux = pwr(a, (b >> 1));
        return (ll) aux * aux % MOD;
    }
}
int inv (const int &a) {
    return pwr(a, MOD - 2);
}

int N, K;
int W[N_MAX + 2];

int order[N_MAX + 2];

int fact[N_MAX + 2];
int ifact[N_MAX + 2];
void precalc () {
    fact[0] = 1;
    for (int i = 1; i <= N; i++) {
        fact[i] = (ll) fact[i - 1] * i % MOD;
    }
    ifact[N] = inv(fact[N]);
    for (int i = N - 1; i >= 0; i--) {
        ifact[i] = (ll) ifact[i + 1] * (i + 1) % MOD;
    }
}
int choose (const int &a, const int &b) {
    return (ll) fact[a] * ifact[b] % MOD * ifact[a - b] % MOD;
}

bool active[N_MAX + 2];
int root[N_MAX + 2];
map <int, int> sw[N_MAX + 2];
int large[N_MAX + 2];

int answer = 1;

int findRoot (int u) {
    return (root[u] == 0 ? u : root[u] = findRoot(root[u]));
}
void join (int u, int v) {
    u = findRoot(u);
    v = findRoot(v);
    if ((int) sw[u].size() > (int) sw[v].size()) {
        swap(u, v);
    }
    root[u] = v;
    large[v] += large[u];
    while (sw[u].empty() == false) {
        pair <int, int> p = *sw[u].begin();
        sw[v][p.first] += p.second;
        sw[u].erase(sw[u].begin());
    }
}
void update (int u, int nxt) {
    u = findRoot(u);
    if (sw[u].empty() == true) {
        return;
    }
    while (sw[u].empty() == false && sw[u].rbegin()->first + nxt > K) {
        large[u] += sw[u].rbegin()->second;
        answer = (ll) answer * choose(large[u], sw[u].rbegin()->second) % MOD;
        sw[u].erase(prev(sw[u].end()));
    }
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie();

    cin >> N >> K;
    for (int i = 1; i <= N; i++) {
        cin >> W[i];
        order[i] = i;
    }
    sort(order + 1, order + N + 1, [&] (const int &i, const int &j) {
        return W[i] < W[j];
    });

    precalc();
    for (int k = 1; k <= N; k++) {
        int i = order[k];
        active[i] = true;
        if (W[i] * 2 <= K) {
            sw[i][W[i]] = 1;
        } else {
            large[i]++;
        }
        if (active[i - 1] == true) {
            update(i - 1, W[i]);
            join(i, i - 1);
        }
        if (active[i + 1] == true) {
            update(i + 1, W[i]);
            join(i, i + 1);
        }
    }
    update(1, K);
    cout << answer << "\n";

    return 0;
}
