#include <bits/stdc++.h>

using namespace std;

const int MAX = 300005;

const int md = 1e9 + 7;

long long f[MAX];

long long add(long long a, long long b) {
  return a + b >= md ? a + b - md : a + b;
}

long long mul(long long a, long long b) {
  return (a * b) % md;
}

long long sub(long long a, long long b) {
  return a - b < 0 ? a - b + md : a - b;
}

long long bin_pow(long long x, long long k) {
  long long r = 1;
  while (k > 0) {
    if (k & 1) {
      r = mul(r, x);
    }
    x = mul(x, x);
    k >>= 1;
  }
  return r;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  f[0] = 1;
  f[1] = 1;
  for (int i = 2; i < MAX; i++) {
    f[i] = mul(f[i - 1], i);
  }
  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  /*vector<long long> dp(n);
  for (int i = 0; i < n; i++) {
    int mx = 0;
    int smx = -1;
    //dp[i] = (i == 0 ? 1LL : dp[i - 1]);
    for (int j = i; j >= 0; j--) {
      //mn = min(mn, a[j]);
      //mx = max(mx, a[j]);
      if (mx < a[j]) {
        smx = mx;
        mx = a[j];
      } else {
        smx = max(smx, a[j]);
      }
      if (j < i && smx + mx <= k) {
        dp[i] = add(dp[i], mul((j == 0 ? 1LL : dp[j - 1]), sub(f[i - j + 1], f[i - j])));
      }
    }
  }
  for (int i = 0; i < n; i++) {
    cout << dp[i] << " ";
  }
  cout << '\n';*/
  const int L = 25;
  vector<vector<int>> st(n, vector<int>(L));
  for (int i = 0; i < n; i++) {
    st[i][0] = a[i];
  }
  for (int j = 1; j < L; j++) {
    for (int i = 0; i + (1 << j) <= n; i++) {
      st[i][j] = max(st[i][j - 1], st[i + (1 << (j - 1))][j - 1]);
    }
  }
  vector<int> logs(n + 1);
  for (int i = 2; i <= n; i++) {
    logs[i] = logs[i >> 1] + 1;
  }
  auto GetMax = [&](int l, int r) {
    int k = logs[r - l + 1];
    return max(st[l][k], st[r - (1 << k) + 1][k]);
  };
  auto C = [&](int n, int k) {
    return mul(f[n], mul(bin_pow(f[k], md - 2), bin_pow(f[n - k], md - 2)));
  };
  vector<vector<int>> g(n);
  vector<int> deg(n);
  auto AddEdge = [&](int x, int y) {
    if (a[x] < a[y]) {
      swap(x, y);
    }
    if (a[x] == a[y]) {
      x = min(x, y);
    }
    g[x].push_back(y);
    deg[y]++;
  };
  for (int i = 0; i < n; i++) {
    int parL;
    int parR;
    {
      parL = -1;
      int l = 0, r = i - 1;
      while (l <= r) {
        int mid = l + r >> 1;
        int mx = GetMax(mid, i - 1);
        if (mx >= a[i] && mx + a[i] > k) {
          parL = mid;
          l = mid + 1;
        } else {
          r = mid - 1;
        }
      }
    }
    {
      parR = -1;
      int l = i + 1, r = n - 1;
      while (l <= r) {
        int mid = l + r >> 1;
        int mx = GetMax(i + 1, mid);
        if (mx >= a[i] && mx + a[i] > k) {
          parR = mid;
          r = mid - 1;
        } else {
          l = mid + 1;
        }
      }
    }
    if (parL == -1 && parR == -1) {
      continue;
    }
    if (parL == -1) {
      swap(parL, parR);
    }
    if (parR != -1 && a[parL] > a[parR]) {
      swap(parL, parR);
    }
    AddEdge(i, parL);
  }
  for (int i = 0; i < n; i++) {
    sort(g[i].begin(), g[i].end());
    g[i].erase(unique(g[i].begin(), g[i].end()), g[i].end());
//    cout << "i = " << i << ": ";
//    for (int j : g[i]) {
//      cout << j << " ";
//    }
//    cout << '\n';
  }
  vector<int> q;
  for (int i = 0; i < n; i++) {
    if (deg[i] == 0) {
      q.push_back(i);
    }
  }
  for (int b = 0; b < (int) q.size(); b++) {
    int i = q[b];
    for (int j : g[i]) {
      deg[j]--;
      if (deg[j] == 0) {
        q.push_back(j);
      }
    }
  }
//  cout << C(6, 5) << '\n';
  auto Solve = [&](vector<pair<int, long long>> vec) {
    int len = 0;
    for (auto& p : vec) {
      len += p.first;
    }
    long long res = 1;
    for (auto& p : vec) {
      res = mul(res, mul(p.second, C(len, p.first)));
      len -= p.first;
    }
    return res;
  };
  reverse(q.begin(), q.end());
  vector<int> sz(n);
  vector<long long> dp(n);
  for (int b = 0; b < (int) q.size(); b++) {
    int i = q[b];
    if (g[i].empty()) {
      dp[i] = 1;
      sz[i] = 1;
    } else {
      long long prodL = 1;
      long long prodR = 1;
      int cntL = 0;
      int cntR = 0;
      sz[i] = 1;
      vector<pair<int, long long>> v_L;
      vector<pair<int, long long>> v_R;
      for (int j : g[i]) {
        if (j < i) {
          prodL = mul(prodL, dp[j]);
          v_L.emplace_back(sz[j], dp[j]);
          cntL += 1;
        } else {
          prodR = mul(prodR, dp[j]);
          v_R.emplace_back(sz[j], dp[j]);
          cntR += 1;
        }
        dp[i] = mul(Solve(v_L), Solve(v_R));
        //dp[i] = mul(mul(prodL, f[cntL]), mul(prodR, f[cntR]));
        sz[i] += sz[j];
        sz[j] = 0;
      }
    }
//    cout << i << " " << sz[i] << " " << dp[i] << endl;
  }
//  cout << "Hi" << endl;
  vector<pair<int, long long>> comps;
  for (int i = 0; i < n; i++) {
    if (sz[i] != 0) {
      comps.emplace_back(sz[i], dp[i]);
    }
  }
//  long long ans = Solve();
//  int rem = n;
//  for (int i = n - 1; i >= 0; i--) {
//    if (sz[i] != 0) {
////      cout << sz[i] << '\n';
//      ans += mul(C(rem, sz[i]), dp[i]);
////      ans += mul(1, dp[i]);
//      rem -= sz[i];
//    }
//  }
  cout << Solve(comps) << '\n';
  return 0;
}
