#include <bits/stdc++.h>
#define ll long long
#define fi first
#define se second
#define all(a) (a).begin(),(a).end()
#define pii pair<int,int>
#define pb push_back
using namespace std;

const int NMAX = 300010;
ll modi = 1e9+7;


int seg1[NMAX*4],seg2[NMAX*4];
int N;
int L[NMAX], R[NMAX];
bool calc[NMAX];

void update(int *seg, int gde, int v, int l = 0, int r = NMAX, int node = 0) {
    if ( l > gde || r < gde ) return;
    if ( l == r ) {
        seg[node] += v;
        return;
    }
    int mid = (l+r)/2;
    update(seg,gde,v,l,mid,node*2+1);
    update(seg,gde,v,mid+1,r,node*2+2);
    seg[node] = seg[node*2+1] + seg[node*2+2];
}

int levo(int *seg, int sl, int sr, int l = 0, int r = NMAX, int node = 0) {

    if ( sr < l || sl > r || sl > sr) {
        return -1;
    }
    if ( seg[node] != r-l+1 ) {
        if ( l == r ) {
            return l;
        }
        int mid = (l+r)/2;
        int temp = levo(seg,sl,sr,mid+1,r,node*2+2);
        if ( temp != -1 ) {
            return temp;
        }
        return levo(seg,sl,sr,l,mid,node*2+1);
    }
    else return -1;
}

int desno(int *seg, int sl, int sr, int l = 0, int r = NMAX, int node = 0) {

    if ( sr < l || sl > r || sl > sr) {
        return N;
    }
    if ( seg[node] != r-l+1 ) {
        if ( l == r ) {
            return l;
        }
        int mid = (l+r)/2;
        int temp = desno(seg,sl,sr,l,mid,node*2+1);
        if ( temp != N ) {
            return temp;
        }
        return desno(seg,sl,sr,mid+1,r,node*2+2);
    }
    else return N;
}

void init(int *seg, int l = 0, int r = NMAX, int node = 0) {
    if ( l == r ) {
        seg[node] = 1;
        return;
    }

    int mid = (l+r)/2;
    init(seg,l,mid,node*2+1);
    init(seg,mid+1,r,node*2+2);
    seg[node] = seg[node*2+1] + seg[node*2+2];
}

int query(int *seg, int sl, int sr, int l = 0, int r = NMAX, int node = 0) {
    if ( sr < l || sl > r || sl > sr) {
        return 0;
    }
    if ( sl <= l && r <= sr ) {
        return seg[node];
    }

    int mid = (l+r)/2;
    return query(seg,sl,sr,l,mid,node*2+1) + query(seg,sl,sr,mid+1,r,node*2+2);
}

ll step(ll a, ll b) {
    if ( b == 0) return 1;
    ll temp2 = step(a,b/2);
    ll temp3 = (temp2*temp2)%modi;
    if ( b%2 ) temp3*=a;
    temp3%=modi;
    return temp3;
}

ll inv(ll a) {
    return step(a,modi-2);
}

int main()
{
    int n,k;
    cin >> n >> k;
    vector<int>v(n,INT_MAX);
    vector<pii>vec(n);
    for (int i = 1 ; i <= n ; i++ ) {
        cin >> vec[i-1].fi;
        vec[i-1].se = i-1;
    }
    N = n;
    //cout << "#" << endl;
    sort(all(vec));
    int l = 0;
    for (int i = n-1 ; i >=0 ; i-- ) {
        //cout << "#" << endl;
        while(l<n && vec[l].fi + vec[i].fi <= k ) {
            update(seg1,vec[l].se,1);
            l++;
        }



        L[vec[i].se] = levo(seg1,0,vec[i].se-1);
        R[vec[i].se] = desno(seg1,vec[i].se+1,n-1);
    }
    /*
    for (int i = 0; i < n ; i++ ) {
        cout << vec[i].se << ' ' << L[vec[i].se] << ' ' << R[vec[i].se] << endl;
    }
    //*/
    ll res = 1;
    init(seg2);
    vector<pii>ma(n);
    for (int i = 0 ; i < n; i++) {
        res *= query(seg2,L[vec[i].se]+1,R[vec[i].se]-1);
        res %= modi;
        update(seg2,vec[i].se,-1);
        //cout << res << endl;
        ma[i] = {vec[i].fi, L[vec[i].se]+1};
    }

    sort(all(ma));



    ll fakt[NMAX];

    fakt[1] = 1;
    for (int i = 2 ; i <= n ; i++ ) {
        fakt[i] = fakt[i-1];
        fakt[i] *= i;
        fakt[i]%=modi;
    }
    //cout <<"#"<<endl;
    //cout << step(2,2) << endl;
    int cnt = 1;
    for (int i = 1 ; i < n ; i++) {
        if ( ma[i] == ma[i-1] ) {
            cnt++;
        }
        else {
            pii u;
            u.se = cnt;
            if ( !calc[u.se] )
                fakt[u.se] = inv(fakt[u.se]);
            res *= fakt[u.se];
            calc[u.se] = 1;
            //cout << u.se << ' ' << inv(u.se) << endl;
            res%=modi;
            cnt = 1;
        }
    }

    if ( cnt > 1) {
            pii u;
            u.se = cnt;
            if ( !calc[u.se] )
                fakt[u.se] = inv(fakt[u.se]);
            res *= fakt[u.se];
            calc[u.se] = 1;
            //cout << u.se << ' ' << inv(u.se) << endl;
            res%=modi;
            cnt = 1;
    }

    cout << res << endl;



}

/*

4 3
1 2 1 3



*/
