#include "ones.h"
#include <iostream>

bool bits[1001];
int prev_state = -1;

void flip_bits_c(std::vector<int> bits_changed) {
    for(int i = 0; i < bits_changed.size(); i++)
        bits[i] ^= bits_changed[i];
}

void flip_one_bit(int i) {
    bits[i] = !bits[i];
}

int get_state(int n) {
    bool has_changed = false;
    for(int i = 0; i < n; i++)
        if(bits[i])
            has_changed = true;

    if(prev_state == -1 || has_changed) {
        std::vector<bool> vec(n);
        for (int i = 0; i < n; i++)
            vec[i] = bits[i];
        prev_state = flip_bits(vec);
        for(int i = 0; i < n; i++)
            bits[i] = false;
    }

    return prev_state;
}

std::pair<int, int> find_longest_subarray_of_ones(int n) {
    int longest_touches, longest;
    while(true) {
        while (true) {
            std::vector<int> vec;
            for (int i = 0; i < n; i++)
                vec.push_back(rand() % 2);
            flip_bits_c(vec);

            if (get_state(n) >= 10)
                break;
        }

        longest = get_state(n);
        longest_touches = -1;

        for(int i = longest - 1; i < n && longest_touches == -1; i += longest) {
            flip_one_bit(i);
            if(get_state(n) < longest)
                longest_touches = i;
            flip_one_bit(i);
        }

        if(longest_touches != -1)
            break;
    }

    int l = longest_touches, r = longest_touches + 1;
    while(true) {
        flip_one_bit(r);
        int state = get_state(n);
        flip_one_bit(r);

        if(state == longest)
            break;

        r++;
    }
    r -= 2;
    l = r - longest + 1;
    get_state(n);
    return {l, r};
}