#include <vector>
#include <utility>
#include <cassert>
#include <iostream>

static int _n;
static std::vector<bool> _a, _b;
static long long num_queries;

static int longest_seq_of_1s(){
    int ans = 0, curr = 0;
    for(int i = 0; i < _n; ++i){
        if(_a[i]){
            ++curr;
        }
        else{
            curr = 0;
        }
        ans = std::max(ans, curr);
    }
    return ans;
}

int flip_bits(const std::vector<bool> &flips){
    assert((int)flips.size() == _n);
    ++num_queries;
    for(int i = 0; i < _n; ++i)
    {
        _a[i] = flips[i] ^ _a[i];
       //std:: cerr<<flips[i]<<" ";
    }
    //std:: cerr<<'\n';
    return longest_seq_of_1s();
}


std:: pair<int,int> find_longest_subarray_of_ones (int n)
{
    std:: vector<bool> g(n, 0), f(n, 0);
    int x = flip_bits(g);
	if(x == n) 
	{
		std:: pair<int, int> p;
        p.first = 0;
        p.second = n - 1;
        return(p);
	}
	if(x == 0) 
	{
		std:: pair<int, int> p;
        p.first = 0;
        p.second = -1;
        return(p);
	}
    int ind = n - 1;
    for(int i = 0; i < n / 2; i++)
    {
        g[i] = 1;
        g[ind] = 1;
        int y = flip_bits(g);
		if(i > 0) 
        {
            g[ind + 1] = 0;
            g[i - 1] = 0;
        }
        if(y < x)
        {
            f[ind] = 1;
            int w = flip_bits(f);
            if(w < x)
            {
                std:: pair<int, int> p;
                p.first = i + 1;
                p.second = i + y;
                return(p);
            }
            else 
            {
                std:: pair<int, int> p;
                p.second = ind;
                p.first = ind - y;
                return(p);
            }
        }
		else 
		if(y > x)
		{
            f[ind] = 1;
            int t = flip_bits(f);
            f[ind] = 0;
            if(t > x)
            {
                int yy = y - x - 1;
                std:: pair<int, int> p;
                //if(i + 1 != n) 
                f[i + 1] = 1;
                int w = flip_bits(f);
                //std::cerr<<w<<"\n";
                if(yy == 0)
                {
                    int ww = flip_bits(f);
                    if(w == x - 1)
                    {
                        p.first = i;
                        p.second = i + x;
                        return p;
                    }
                    else 
                    if(w > x)
                    {
                        p.first = i - x;
                        p.second = i;
                        return p;
                    }
                    ww = flip_bits(f);
                }
                if(w == x + 1)
                {
                    p.first = i - x;
                    p.second = i;
                    return p;
                }
                if(w == yy + 1)
                {
                    p.first = i - yy;
                    p.second = i;
                    return p;
                }
                if(w == x - 1)
                {
                    p.first = i + 2;
                    p.second = i + x;
                    return p;
                }
                if(w == yy - 1)
                {
                    p.first = i + 2;
                    p.second = i + yy;
                    return p;
                }
                //std:: cout<<i<<"\n";
                w = flip_bits(f);
                f[i + 1] = 0;
            }
            else
            {
                //std::cerr<<i<<" ";
                int yy = y - x - 1;
                std:: pair<int, int> p;
                //if(i + 1 != n) 
                f[ind - 1] = 1;
                f[i] = 1;
                int w = flip_bits(f);
                f[i] = 0;
                if(w == x)
                {
                    f[ind] = 1;
                    int w = flip_bits(f);
                    p.second = ind;
                    p.first = ind - x;
                    return p;
                }
                //std::cerr<<w<<' '<<yy<<"\n";
                if(yy == 0)
                {
                    int ww = flip_bits(f);
                    if(w == x - 1)
                    {
                        p.second = ind - x;
                        p.first = ind - 2;
                        return p;
                    }
                    else 
                    if(w > x)
                    {
                        p.second = ind;
                        p.first = ind + x;
                        return p;
                    }
                    ww = flip_bits(f);
                }
                if(w == x + 1)
                {
                    p.second =  ind + x;
                    p.first = ind;
                    return p;
                }
                if(w == yy + 1)
                {
                    p.second = ind + yy;
                    p.first = ind;
                    return p;
                }
                if(w == x - 1)
                {
                    p.second = i - x;
                    p.first = i - 2;
                    return p;
                }
                if(w == yy - 1)
                {
                    p.second = i - 2;
                    p.first = i - yy;
                    return p;
                }
                //std:: cout<<i<<"\n";
                w = flip_bits(f);
                f[i + 1] = 0;
            }
		}
    }
    std:: pair<int, int> p;
    p.first = 1;
    p.second = -100;
    return p;
}


int main(){
    int t = 1;
    //std::cin >> t;

    long long max_qs = 0;

    while(t--){
        num_queries = 0;

        std::cin >> _n;
        //_n = 10;
        _a.resize(_n);
        _b.resize(_n);
        for(int i = 0; i < _n; ++i){
            bool val;
            std::cin >> val;
            _a[i] = val;
            //_a[i] = rand() % 2;
            //_b[i] = _a[i];
        }

        auto [l, r] = find_longest_subarray_of_ones(_n);
        //std::cout<<l<<" "<<r<<" ";
        if(longest_seq_of_1s() != r - l + 1){
            for(int i = 0; i < _n; i++)
            {
                std:: cout<<_a[i]<<" ";
            }
            std::cout << "0\n";
            return 0;
        }
        if(l == 0 && r == -1){
            max_qs = std::max(num_queries, max_qs);
            continue;
        }
        if(r < l || l < 0 || l >= _n || r < 0 || r >= _n){
            for(int i = 0; i < _n; i++)
            {
                std:: cout<<_a[i]<<" ";
            }
            std::cout << "0\n";
            return 0;
        }

        for(int i = l; i <= r; ++i){
            if(_a[i] != 1){
                for(int i = 0; i < _n; i++)
            {
                std:: cout<<_a[i]<<" ";
            }
                std::cout << "0\n";
                return 0;
            }
        }

        max_qs = std::max(num_queries, max_qs);
    }

    std::cout << "1 "; //<< max_qs << "\n";
    return 0;
}