#include "ones.h"
#include <cassert>
// #include "Lgrader.cpp"

using namespace std;

pair<int, int> find_longest_subarray_of_ones(int n) {
    vector<bool> flips(n);
    auto query = [&](vector<int> v) {
        for (int x : v) flips[x] = true;
        int z = flip_bits(flips);
        for (int x : v) flips[x] = false;
        return z;
    };

    vector<int> v{};
    int longest = query(v);
    vector<bool> defo1(n, 0);

    auto tryI = [&](int i) {
        if (defo1[i]) return;
        v.push_back(i);
        int current = query(v);
        v.clear();
        if (current < longest) { // now 0
            v.push_back(i); // flip back to 1 next query
            defo1[i] = true;
        } else if (current > longest) { // now 1
            defo1[i] = true;
            longest = current;
        }
    };

    for (int i = 0; i < n; ++i) tryI(i);
    for (int i = n-2; i >= 0; --i) tryI(i);
    assert(query(v) == n);
    return {0, n-1};
}

